/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './rational.pmc'
 * by ../../tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_rational.h"
#include "pmc_default.h"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./rational.pmc"
/*
Copyright (C) 2008-2009, Parrot Foundation.
$Id: rational.pmc 44649 2010-03-05 16:20:00Z tene $

=pod

=head1 NAME

src/dynpmc/rational.pmc - Rational numbers PMC

=head1 DESCRIPTION

Rational is currently going to get implemented. It uses the GNU Multiple Precision (GMP) library,
like BigInt, because implementation with integers would be too unstable and inaccurate.

'LispRational' will subclass this.

You may use Rational with any of parrot's basic data types as well as with String-, Integer- and
Float-PMCs.

=head1 Functions

Currently C<rational.pmc> only has some C<static> functions for code sharing.

=over 4

=cut

*/

#include "parrot/has_header.h"

#ifdef PARROT_HAS_GMP
#  include <gmp.h>
   typedef struct RATIONAL {
      mpq_t q;
   } RATIONAL;
#  define PMC_rational(x) ((Parrot_Rational_attributes *)PMC_data(x))->rational
#  define RT(x)           ((Parrot_Rational_attributes *)PMC_data(x))->rational->q
#else
#  define RT(x)
#endif

#define RAISE_EXCEPTION   Parrot_ex_throw_from_c_args(interp, NULL, \
    EXCEPTION_LIBRARY_NOT_LOADED, "GNU Multiple Precision library not found.");

/*

=item * static STRING *rat_get_string_to_base(PARROT_INTERP, PMC *self, int base)

Returns a string representation of a Rational-PMC to a certain base.

=cut

*/
static STRING *rat_get_string_to_base(PARROT_INTERP, PMC *self, int base) {
  #ifdef PARROT_HAS_GMP
    char * const cstr   = mpq_get_str(NULL, (int) base, RT(self));
    STRING * const pstr = Parrot_str_new(interp, cstr, 0);
    Parrot_str_free_cstring(cstr);
    return pstr;
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_add_integer(PARROT_INTERP, PMC *self, int value)

Adds an integer "value" to a Rational-PMC inplace.

=cut

*/
static void rat_add_integer(PARROT_INTERP, PMC *self, int value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;
    mpq_init(t);
    mpq_set_si(t, (int) value, 1);
    mpq_add(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_add_float(PARROT_INTERP, PMC *self, double value)

Adds a float "value" to a Rational-PMC in-place. "value" is first conveted to a
rational using GMPs mpq_set_d-function. This is meant to be exact.

=cut

*/
static void rat_add_float(PARROT_INTERP, PMC *self, double value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_add(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_multiply_integer(PARROT_INTERP, PMC *self, int value)

Multiplys a Rational-PMC with an integer "value" in-place.

=cut

*/
static void rat_multiply_integer(PARROT_INTERP, PMC *self, int value) {
  #ifdef PARROT_HAS_GMP
    mpz_mul_ui(mpq_numref(RT(self)), mpq_numref(RT(self)), (unsigned int) value);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_multiply_float(PARROT_INTERP, PMC *self, double value)

Multiplies a Rational-PMC with a float "value" in-place.

=cut

*/
static void rat_multiply_float(PARROT_INTERP, PMC *self, double value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_mul(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_divide_integer(PARROT_INTERP, PMC *self, int value)

Divides a Rational-PMC through an integer "value" in-place.

=cut

*/
static void rat_divide_integer(PARROT_INTERP, PMC *self, int value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    mpq_init(t);
    mpq_set_si(t, (int) value, 1);
    mpq_div(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_divide_float(PARROT_INTERP, PMC *self, double value)

Divides a Rational-PMC through a float "value" in-place.

=cut

*/
static void rat_divide_float(PARROT_INTERP, PMC *self, double value) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_div(RT(self), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=back

=cut

*/
#line 226 "./rational.c"
static  PMC  * Parrot_Rational_absolute(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC  * Parrot_Rational_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Rational_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_Rational_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Rational_decrement(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Rational_destroy(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Rational_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Rational_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  INTVAL  Parrot_Rational_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Rational_get_integer(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Rational_get_number(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Rational_get_string(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Rational_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base);
static  void  Parrot_Rational_i_absolute(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Rational_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Rational_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Rational_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Rational_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Rational_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Rational_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Rational_i_neg(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Rational_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Rational_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Rational_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Rational_init(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Rational_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Rational_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_Rational_neg(PARROT_INTERP, PMC *pmc, PMC *dest);
static  void  Parrot_Rational_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Rational_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Rational_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value);
static  void  Parrot_Rational_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  PMC  * Parrot_Rational_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Rational_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void Parrot_Rational_nci_version(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Rational_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_add_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_add_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Rational_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_add_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_add_Rational(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Rational_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_subtract_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_subtract_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Rational_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_subtract_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_subtract_Rational(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Rational_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_multiply_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_multiply_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Rational_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_multiply_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_multiply_Rational(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Rational_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_divide_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_divide_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Rational_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Rational_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_divide_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_divide_Rational(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Rational_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Rational_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Rational_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Rational_multi_cmp_Rational(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Rational_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Rational_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Rational_multi_is_equal_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Rational_multi_is_equal_Rational(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Rational_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
PARROT_DYNEXT_EXPORT void    Parrot_Rational_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_get_vtable(PARROT_INTERP);
PARROT_DYNEXT_EXPORT void    Parrot_Rational_ro_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_Rational_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Rational_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 954 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    mpq_abs(RT(dest), RT(pmc));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 321 "./rational.c"
}
static  PMC  *
Parrot_Rational_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 567 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_add_float(interp, dest, (double) value);
    return dest;
#line 331 "./rational.c"
}
static  PMC  *
Parrot_Rational_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 543 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);;
    rat_add_integer(interp, dest, (int) value);
    return dest;
#line 341 "./rational.c"
}
static  PMC  *
Parrot_Rational_clone(PARROT_INTERP, PMC *pmc)
{
#line 254 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    PMC * const ret = Parrot_pmc_new(interp, pmc->vtable->base_type);
    mpq_set(RT(ret), RT(pmc));
    return ret;
  #else
    RAISE_EXCEPTION
  #endif
#line 355 "./rational.c"
}
static  void 
Parrot_Rational_decrement(PARROT_INTERP, PMC *pmc)
{
#line 462 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_sub(mpq_numref(RT(pmc)), mpq_numref(RT(pmc)), mpq_denref(RT(pmc)));
    mpq_canonicalize(RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 368 "./rational.c"
}
static  void 
Parrot_Rational_destroy(PARROT_INTERP, PMC *pmc)
{
#line 271 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_clear(RT(pmc));
    mem_gc_free(interp, RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 381 "./rational.c"
}
static  PMC  *
Parrot_Rational_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 897 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_divide_float(interp, dest, (double) value);
    return dest;
#line 391 "./rational.c"
}
static  PMC  *
Parrot_Rational_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 873 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_divide_integer(interp, dest, (int) value);
    return dest;
#line 401 "./rational.c"
}
static  INTVAL 
Parrot_Rational_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 399 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (mpq_cmp_si(RT(pmc), 0, 0))
        return 0;
    else
        return 1;
  #else
    RAISE_EXCEPTION
  #endif
#line 416 "./rational.c"
}
static  INTVAL 
Parrot_Rational_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 356 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_t q;
    mpz_init(q);
    mpz_tdiv_q(q, mpq_numref(RT(pmc)), mpq_denref(RT(pmc)));
    if (mpz_fits_slong_p(q)) {
        const INTVAL ret = (INTVAL) mpz_get_si(q);
        mpz_clear(q);
        return ret;
    }
    else {
        mpz_clear(q);
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "Rational, get_integer(): Number is too big.");
    }
  #else
    RAISE_EXCEPTION
  #endif
#line 440 "./rational.c"
}
static  FLOATVAL 
Parrot_Rational_get_number(PARROT_INTERP, PMC *pmc)
{
#line 383 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    const double d = mpq_get_d(RT(pmc));
    return (FLOATVAL) d;
  #else
    RAISE_EXCEPTION
  #endif
#line 453 "./rational.c"
}
static  STRING  *
Parrot_Rational_get_string(PARROT_INTERP, PMC *pmc)
{
#line 416 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return rat_get_string_to_base(interp, pmc, 10);
  #else
    RAISE_EXCEPTION
  #endif
#line 465 "./rational.c"
}
static  STRING  *
Parrot_Rational_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base)
{
#line 431 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return rat_get_string_to_base(interp, pmc, (int) base);
  #else
    RAISE_EXCEPTION
  #endif
#line 477 "./rational.c"
}
static  void 
Parrot_Rational_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 972 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_abs(RT(pmc), RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 489 "./rational.c"
}
static  void 
Parrot_Rational_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 580 "./rational.pmc"

    rat_add_float(interp, pmc, (double) value);
#line 497 "./rational.c"
}
static  void 
Parrot_Rational_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 556 "./rational.pmc"

    rat_add_integer(interp, pmc, (int) value);
#line 505 "./rational.c"
}
static  void 
Parrot_Rational_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 910 "./rational.pmc"

    rat_divide_float(interp, pmc, (double) value);
#line 513 "./rational.c"
}
static  void 
Parrot_Rational_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 886 "./rational.pmc"

    rat_divide_integer(interp, pmc, (int) value);
#line 521 "./rational.c"
}
static  void 
Parrot_Rational_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 800 "./rational.pmc"

    rat_multiply_float(interp, pmc, (double) value);
#line 529 "./rational.c"
}
static  void 
Parrot_Rational_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 776 "./rational.pmc"

    rat_multiply_integer(interp, pmc, (int) value);
#line 537 "./rational.c"
}
static  void 
Parrot_Rational_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 939 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_neg(RT(pmc), RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 549 "./rational.c"
}
static  void 
Parrot_Rational_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 690 "./rational.pmc"

    rat_add_float(interp, pmc, -((double) value));
#line 557 "./rational.c"
}
static  void 
Parrot_Rational_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 666 "./rational.pmc"

    rat_add_integer(interp, pmc, -((int) value));
#line 565 "./rational.c"
}
static  void 
Parrot_Rational_increment(PARROT_INTERP, PMC *pmc)
{
#line 446 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_add(mpq_numref(RT(pmc)), mpq_numref(RT(pmc)), mpq_denref(RT(pmc)));
    mpq_canonicalize(RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 578 "./rational.c"
}
static  void 
Parrot_Rational_init(PARROT_INTERP, PMC *pmc)
{
#line 237 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    Parrot_Rational_attributes *attrs =
        PARROT_RATIONAL(pmc);
    attrs->rational = mem_gc_allocate_zeroed_typed(interp, RATIONAL);
    mpq_init(RT(pmc));
    PObj_custom_destroy_SET(pmc);
  #endif
#line 592 "./rational.c"
}
static  PMC  *
Parrot_Rational_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 787 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_multiply_float(interp, dest, (double) value);
    return dest;
#line 602 "./rational.c"
}
static  PMC  *
Parrot_Rational_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 763 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_multiply_integer(interp, dest, (int) value);
    return dest;
#line 612 "./rational.c"
}
static  PMC  *
Parrot_Rational_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 921 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    mpq_neg(RT(dest), RT(pmc));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 627 "./rational.c"
}
static  void 
Parrot_Rational_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 287 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_set_si(RT(pmc), (signed int) value, 1);
    mpq_canonicalize(RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 640 "./rational.c"
}
static  void 
Parrot_Rational_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 303 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_set_d(RT(pmc), (double) value);
    mpq_canonicalize(RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 653 "./rational.c"
}
static  void 
Parrot_Rational_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value)
{
#line 337 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    char * const cstr = Parrot_str_to_cstring(interp, value);
    mpq_set_str(RT(pmc), cstr, (int) base);
    mpq_canonicalize(RT(pmc));
    Parrot_str_free_cstring(cstr);
  #else
    RAISE_EXCEPTION
  #endif
#line 668 "./rational.c"
}
static  void 
Parrot_Rational_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 319 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    char * const cstr = Parrot_str_to_cstring(interp, value);
    mpq_set_str(RT(pmc), cstr, 0);
    mpq_canonicalize(RT(pmc));
    Parrot_str_free_cstring(cstr);
  #else
    RAISE_EXCEPTION
  #endif
#line 683 "./rational.c"
}
static  PMC  *
Parrot_Rational_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 677 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_add_float(interp, dest, -((double) value));
    return dest;
#line 693 "./rational.c"
}
static  PMC  *
Parrot_Rational_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 653 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_add_integer(interp, dest, -((int) value));
    return dest;
#line 703 "./rational.c"
}
static  void
Parrot_Rational_nci_version(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 716 "./rational.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 220 "./rational.pmc"

    STRING *version;
  #ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
  #else
    version = Parrot_str_new(interp, "0.0.0", 0);
  #endif
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *version */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)version);
    return;
    /*END RETURN STRING *version */
    }
#line 227 "./rational.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 748 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 480 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_add_integer(interp, dest, VTABLE_get_integer(interp, value));
    return dest;
#line 758 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_add_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 486 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_add_float(interp, dest, VTABLE_get_number(interp, value));
    return dest;
#line 768 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_add_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 492 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    mpq_add(RT(dest), RT(pmc), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 783 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 503 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, add: Not implemented (yet).");
#line 792 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 515 "./rational.pmc"

    rat_add_integer(interp, pmc, (int) VTABLE_get_integer(interp, value));
#line 800 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_add_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 519 "./rational.pmc"

    rat_add_float(interp, pmc, (double) VTABLE_get_number(interp, value));
#line 808 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_add_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 523 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_add(RT(pmc), RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 820 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 531 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_add: Not implemented (yet).");
#line 829 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 591 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_add_integer(interp, dest, -((int) VTABLE_get_integer(interp, value)));
    return dest;
#line 839 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_subtract_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 597 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_add_float(interp, dest, - ((double) VTABLE_get_number(interp, value)));
    return dest;
#line 849 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_subtract_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 603 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);
    mpq_sub(RT(dest), RT(pmc), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 863 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 613 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, subtract: Not implemented (yet).");
#line 872 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 625 "./rational.pmc"

    rat_add_integer(interp, pmc, -((int) VTABLE_get_integer(interp, value)));
#line 880 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_subtract_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 629 "./rational.pmc"

    rat_add_float(interp, pmc, - ((double) VTABLE_get_number(interp, value)));
#line 888 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_subtract_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 633 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_sub(RT(pmc), RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 900 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 641 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_subtract: Not implemented (yet).");
#line 909 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 701 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_multiply_integer(interp, dest, (int) VTABLE_get_integer(interp, value));
    return dest;
#line 919 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_multiply_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 707 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_multiply_float(interp, dest, (double) VTABLE_get_number(interp, value));
    return dest;
#line 929 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_multiply_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 713 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);
    mpq_mul(RT(dest), RT(pmc), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 943 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 723 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, multiply: Not implemented (yet).");
#line 952 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 735 "./rational.pmc"

    rat_multiply_integer(interp, pmc, (int) VTABLE_get_integer(interp, value));
#line 960 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_multiply_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 739 "./rational.pmc"

    rat_multiply_float(interp, pmc, (double) VTABLE_get_number(interp, value));
#line 968 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_multiply_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 743 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_mul(RT(pmc), RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 980 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 751 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_multiply: Not implemented (yet).");
#line 989 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 811 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_divide_integer(interp, dest, (int) VTABLE_get_integer(interp, value));
    return dest;
#line 999 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_divide_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 817 "./rational.pmc"

    dest = Parrot_Rational_clone(interp, pmc);
    rat_divide_float(interp, dest, (double) VTABLE_get_number(interp, value));
    return dest;
#line 1009 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_divide_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 823 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);
    mpq_div(RT(dest), RT(pmc), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 1023 "./rational.c"
}
static  PMC  *
Parrot_Rational_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 833 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, divide: Not implemented (yet).");
#line 1032 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 845 "./rational.pmc"

    rat_divide_integer(interp, pmc, (int) VTABLE_get_integer(interp, value));
#line 1040 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_divide_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 849 "./rational.pmc"

    rat_divide_float(interp, pmc, (double) VTABLE_get_number(interp, value));
#line 1048 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_divide_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 853 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_div(RT(pmc), RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1060 "./rational.c"
}
static  void 
Parrot_Rational_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 861 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_divide: Not implemented (yet).");
#line 1069 "./rational.c"
}
static  INTVAL 
Parrot_Rational_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 987 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_cmp_si(RT(pmc), VTABLE_get_integer(interp, value), 1);
  #else
    RAISE_EXCEPTION
  #endif
#line 1081 "./rational.c"
}
static  INTVAL 
Parrot_Rational_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 995 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "This is going to get implemented soon.");
  #else
    RAISE_EXCEPTION
  #endif
#line 1094 "./rational.c"
}
static  INTVAL 
Parrot_Rational_multi_cmp_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1004 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_cmp(RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1106 "./rational.c"
}
static  INTVAL 
Parrot_Rational_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1012 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "cmp not implemented (yet).");
#line 1115 "./rational.c"
}
static  INTVAL 
Parrot_Rational_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1024 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    INTVAL eq = 0;
    mpq_t t;
    mpq_init(t);
    mpq_set_ui(t, VTABLE_get_integer(interp, value), 1);

    eq = (INTVAL) mpq_equal(RT(pmc), RT(value));
    mpq_clear(t);

    return eq;
  #else
    RAISE_EXCEPTION
  #endif
#line 1135 "./rational.c"
}
static  INTVAL 
Parrot_Rational_multi_is_equal_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1040 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Equality to floats can not be checked because of limited machine "
        "accuracy.\nApproximate the rational and check whether the "
        "difference to a value is lower\nthan an epsilon.");
#line 1146 "./rational.c"
}
static  INTVAL 
Parrot_Rational_multi_is_equal_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1047 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_equal(RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1158 "./rational.c"
}
static  INTVAL 
Parrot_Rational_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1055 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "is_equal not implemented (yet).");
#line 1167 "./rational.c"
}
#include "pmc/pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_Rational_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Rational_absolute;
    vt->add_float = Parrot_Rational_add_float;
    vt->add_int = Parrot_Rational_add_int;
    vt->clone = Parrot_Rational_clone;
    vt->decrement = Parrot_Rational_decrement;
    vt->destroy = Parrot_Rational_destroy;
    vt->divide_float = Parrot_Rational_divide_float;
    vt->divide_int = Parrot_Rational_divide_int;
    vt->get_bool = Parrot_Rational_get_bool;
    vt->get_integer = Parrot_Rational_get_integer;
    vt->get_number = Parrot_Rational_get_number;
    vt->get_string = Parrot_Rational_get_string;
    vt->get_string_keyed_int = Parrot_Rational_get_string_keyed_int;
    vt->i_absolute = Parrot_Rational_i_absolute;
    vt->i_add_float = Parrot_Rational_i_add_float;
    vt->i_add_int = Parrot_Rational_i_add_int;
    vt->i_divide_float = Parrot_Rational_i_divide_float;
    vt->i_divide_int = Parrot_Rational_i_divide_int;
    vt->i_multiply_float = Parrot_Rational_i_multiply_float;
    vt->i_multiply_int = Parrot_Rational_i_multiply_int;
    vt->i_neg = Parrot_Rational_i_neg;
    vt->i_subtract_float = Parrot_Rational_i_subtract_float;
    vt->i_subtract_int = Parrot_Rational_i_subtract_int;
    vt->increment = Parrot_Rational_increment;
    vt->init = Parrot_Rational_init;
    vt->multiply_float = Parrot_Rational_multiply_float;
    vt->multiply_int = Parrot_Rational_multiply_int;
    vt->neg = Parrot_Rational_neg;
    vt->set_integer_native = Parrot_Rational_set_integer_native;
    vt->set_number_native = Parrot_Rational_set_number_native;
    vt->set_string_keyed_int = Parrot_Rational_set_string_keyed_int;
    vt->set_string_native = Parrot_Rational_set_string_native;
    vt->subtract_float = Parrot_Rational_subtract_float;
    vt->subtract_int = Parrot_Rational_subtract_int;
    vt->attr_size = sizeof(Parrot_Rational_attributes);

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_Rational_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Rational_absolute;
    vt->add_float = Parrot_Rational_add_float;
    vt->add_int = Parrot_Rational_add_int;
    vt->clone = Parrot_Rational_clone;
    vt->destroy = Parrot_Rational_destroy;
    vt->divide_float = Parrot_Rational_divide_float;
    vt->divide_int = Parrot_Rational_divide_int;
    vt->get_bool = Parrot_Rational_get_bool;
    vt->get_integer = Parrot_Rational_get_integer;
    vt->get_number = Parrot_Rational_get_number;
    vt->get_string = Parrot_Rational_get_string;
    vt->get_string_keyed_int = Parrot_Rational_get_string_keyed_int;
    vt->init = Parrot_Rational_init;
    vt->multiply_float = Parrot_Rational_multiply_float;
    vt->multiply_int = Parrot_Rational_multiply_int;
    vt->neg = Parrot_Rational_neg;
    vt->subtract_float = Parrot_Rational_subtract_float;
    vt->subtract_int = Parrot_Rational_subtract_int;
    vt->attr_size = sizeof(Parrot_Rational_attributes);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Rational_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Rational_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Rational_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Rational_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Rational_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Rational", 8, NULL, 0));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Rational_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Rational")), PMCNULL);
    return isa;
}

void
Parrot_Rational_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":rational ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Rational_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = string_make(interp, "Rational", 8,
                                       "ascii", PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_append(interp, vt->provides_str,
            string_make(interp, "scalar", 6, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Rational_ro_get_vtable(interp);
            vt_ro->base_type      = -1;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Rational_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Rational_nci_version), CONST_STRING_GEN(interp, "version"));
        {
        STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
        STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
        STRING * const mfl_2 = CONST_STRING_GEN(interp, "Rational,Integer,PMC");
        STRING * const mfl_3 = CONST_STRING_GEN(interp, "Rational");
        STRING * const mfl_4 = CONST_STRING_GEN(interp, "Rational,Float,PMC");
        STRING * const mfl_5 = CONST_STRING_GEN(interp, "Rational,Rational,PMC");
        STRING * const mfl_6 = CONST_STRING_GEN(interp, "Rational,DEFAULT,PMC");
        STRING * const mfl_7 = CONST_STRING_GEN(interp, "i_add");
        STRING * const mfl_8 = CONST_STRING_GEN(interp, "vJPP");
        STRING * const mfl_9 = CONST_STRING_GEN(interp, "Rational,Integer");
        STRING * const mfl_10 = CONST_STRING_GEN(interp, "Rational,Float");
        STRING * const mfl_11 = CONST_STRING_GEN(interp, "Rational,Rational");
        STRING * const mfl_12 = CONST_STRING_GEN(interp, "Rational,DEFAULT");
        STRING * const mfl_13 = CONST_STRING_GEN(interp, "subtract");
        STRING * const mfl_14 = CONST_STRING_GEN(interp, "i_subtract");
        STRING * const mfl_15 = CONST_STRING_GEN(interp, "multiply");
        STRING * const mfl_16 = CONST_STRING_GEN(interp, "i_multiply");
        STRING * const mfl_17 = CONST_STRING_GEN(interp, "divide");
        STRING * const mfl_18 = CONST_STRING_GEN(interp, "i_divide");
        STRING * const mfl_19 = CONST_STRING_GEN(interp, "cmp");
        STRING * const mfl_20 = CONST_STRING_GEN(interp, "IJPP");
        STRING * const mfl_21 = CONST_STRING_GEN(interp, "is_equal");

              multi_func_list _temp_multi_func_list[] = {
                        { mfl_0,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_add_Integer_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_add_Float_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_add_Rational_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_add_DEFAULT_PMC }
,
        { mfl_7,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_add_Integer }
,
        { mfl_7,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_add_Float }
,
        { mfl_7,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_add_Rational }
,
        { mfl_7,
          mfl_8,
          mfl_12,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_add_DEFAULT }
,
        { mfl_13,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_subtract_Integer_PMC }
,
        { mfl_13,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_subtract_Float_PMC }
,
        { mfl_13,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_subtract_Rational_PMC }
,
        { mfl_13,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_subtract_DEFAULT_PMC }
,
        { mfl_14,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_subtract_Integer }
,
        { mfl_14,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_subtract_Float }
,
        { mfl_14,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_subtract_Rational }
,
        { mfl_14,
          mfl_8,
          mfl_12,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_subtract_DEFAULT }
,
        { mfl_15,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_multiply_Integer_PMC }
,
        { mfl_15,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_multiply_Float_PMC }
,
        { mfl_15,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_multiply_Rational_PMC }
,
        { mfl_15,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_multiply_DEFAULT_PMC }
,
        { mfl_16,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_multiply_Integer }
,
        { mfl_16,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_multiply_Float }
,
        { mfl_16,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_multiply_Rational }
,
        { mfl_16,
          mfl_8,
          mfl_12,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_multiply_DEFAULT }
,
        { mfl_17,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_divide_Integer_PMC }
,
        { mfl_17,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_divide_Float_PMC }
,
        { mfl_17,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_divide_Rational_PMC }
,
        { mfl_17,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_divide_DEFAULT_PMC }
,
        { mfl_18,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_divide_Integer }
,
        { mfl_18,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_divide_Float }
,
        { mfl_18,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_divide_Rational }
,
        { mfl_18,
          mfl_8,
          mfl_12,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_i_divide_DEFAULT }
,
        { mfl_19,
          mfl_20,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_cmp_Integer }
,
        { mfl_19,
          mfl_20,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_cmp_Float }
,
        { mfl_19,
          mfl_20,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_cmp_Rational }
,
        { mfl_19,
          mfl_20,
          mfl_12,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_cmp_DEFAULT }
,
        { mfl_21,
          mfl_20,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_is_equal_Integer }
,
        { mfl_21,
          mfl_20,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_is_equal_Float }
,
        { mfl_21,
          mfl_20,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_is_equal_Rational }
,
        { mfl_21,
          mfl_20,
          mfl_12,
          mfl_3,
          (funcptr_t) Parrot_Rational_multi_is_equal_DEFAULT }

            };
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_Rational_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_rational_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_rational_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typeRational;
    int pass;

    /* create a library PMC */
    pmc = Parrot_pmc_new_constant(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "Rational");
    typeRational = Parrot_pmc_register_new_type(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_Rational_class_init(interp, typeRational, pass);
    }
    return pmc;
}

#line 1058 "./rational.pmc"


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
