/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bignum.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_bignum.h"
#include "pmc_default.h"
#include "bignum.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/bignum.pmc"
/*
Copyright (C) 2004-2010, Parrot Foundation.
$Id: bignum.pmc 44291 2010-02-22 09:28:39Z bacek $

=head1 NAME

src/pmc/bignum.pmc - BigNum PMC class

=head1 DESCRIPTION

C<BigNum> provides arbitrary precision floating point mathematic
functions, based on the GMP mpf library.

=head1 SYNOPSIS

Make mixing of classes work, like in:

        new $P0 ['BigInt']
        new $P1 ['BigNum']
        set $P0, 10
        set $P1, 2
        div P2, P0, P1  # $P2 = $P0 / $P1; (BigNum) 5.0

Make auto-upgrading/downgrading work.

        set $N1, $P0
        set $N1, $P1
        set $I1, $P0
        set $I1, $P1
        set $P0, $I1
        set $P0, $N1
        set $P1, $I1
        set $P1, $N1

  BigNum
    => BigInt => Integer
    => Number: float (can be long double) and double
    => Integer (unsigned long)

=head2 Functions

=over 4

=item C<static void bignum_init(Interp*, PMC *self)>

=item C<static void bignum_clear(Interp*, PMC *self)>

=item C<static void bignum_set(Interp*, PMC *dest, PMC *src)>

=item C<static void bignum_set_si(Interp*, PMC *self, long value)>

=item C<static void bignum_set_ui(Interp*, PMC *self, unsigned long value)>

=item C<static void bignum_set_float(Interp*, PMC *self, FLOATVAL value)>

=item C<static void bignum_set_double(Interp*, PMC *self, double value)>

=item C<static void bignum_set_str(Interp*, PMC *self, char *value, int base)>

=item C<static void bignum_set_bigint(Interp*, PMC *self, struct BIGINT *value)>

=item C<static BIGNUM* bignum_get_self(Interp*, PMC *self)>

=item C<static void bignum_set_self(Interp*, PMC *self, BIGNUM *value)>

=item C<static long bignum_get_si(Interp*, PMC *self)>

=item C<static unsigned long bignum_get_ui(Interp*, PMC *self)>

=item C<static int bignum_get_bool(Interp*, PMC *self)>

=item C<static char* bignum_get_string(Interp*, PMC *self, int base)>

=item C<static char* bignum_get_string_size(Interp*, PMC *self, int base, int digits)>

=item C<static double bignum_get_double(Interp*, PMC *self)>

=item C<static FLOATVAL bignum_get_float(Interp*, PMC *self)>

=item C<static BIGINT bignum_get_bigint(Interp*, PMC *self)>

=item C<static void bignum_add_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_add_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_add_bignum_float(Interp*, PMC *self, FLOATVAL value, PMC *dest)>

=item C<static void bignum_sub_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_sub_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_sub_bignum_float(Interp*, PMC *self, FLOATVAL value, PMC *dest)>

=item C<static void bignum_mul_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_mul_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_mul_bignum_float(Interp*, PMC *self, FLOATVAL value, PMC *dest)>

=item C<static void bignum_pow_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_check_divide_zero(Interp*, PMC *value)>

=item C<static void bignum_div_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_div_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_div_bignum_float(Interp*, PMC *self, FLOATVAL value, PMC *dest)>

=item C<static void bignum_fdiv_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_fdiv_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static INTVAL bignum_cmp(Interp*, PMC *self, PMC *value)>

=item C<static INTVAL bignum_cmp_double(Interp*, PMC *self, double value)>

=item C<static INTVAL bignum_cmp_int(Interp*, PMC *self, INTVAL value)>

=item C<static INTVAL bignum_cmp_ulong(Interp*, PMC *self, unsigned long value)>

=item C<static void bignum_abs(Interp*, PMC *self, PMC *dest)>

=item C<static void bignum_neg(Interp*, PMC *self, PMC *dest)>

=item C<static INTVAL bignum_get_default_prec(Interp*, PMC *self)>

=item C<static void bignum_set_default_prec(Interp*, PMC *self, INTVAL prec)>

=cut

*/

#ifdef S_SPLINT_S
#  undef PARROT_HAS_GMP /* splint barfs on the gmp.h header */
#endif /* S_SPLINT_S */

/* Uncomment to easily disable it */
/*
#ifdef PARROT_HAS_GMP
#  undef PARROT_HAS_GMP
#endif
*/
#undef PARROT_BIGNUM_CAN_BIGINT

#ifdef PARROT_HAS_GMP
#  include "pmc_bigint.h"
#  include <gmp.h>
typedef struct BIGNUM {
    mpf_t b;
} BIGNUM;
#endif

static void
bignum_init(PARROT_INTERP, PMC *self) {
#ifdef PARROT_HAS_GMP
    BIGNUM * const bn = mem_gc_allocate_zeroed_typed(interp, BIGNUM);
    SETATTR_BigNum_bn(interp, self, bn);
    mpf_clear(bn->b);
    mpf_init(bn->b);
#else
    SETATTR_BigNum_bn(interp, self, NULL);
#endif
}


static void
bignum_clear(PARROT_INTERP, PMC *self) {
#ifdef PARROT_HAS_GMP
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_clear(bn->b);
    mem_gc_free(interp, bn);
#endif
}


#ifdef PARROT_HAS_GMP

static void
bignum_set(PARROT_INTERP, PMC *dest, PMC *src) {
    BIGNUM *bn_dest, *bn_src;
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    GETATTR_BigNum_bn(interp, src,  bn_src);
    mpf_set(bn_dest->b, bn_src->b);
}

static void
bignum_set_si(PARROT_INTERP, PMC *self, long value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_si(bn->b, value);
}

static void
bignum_set_ui(PARROT_INTERP, PMC *self, unsigned long value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_ui(bn->b, value);
}

static void
bignum_set_float(PARROT_INTERP, PMC *self, FLOATVAL value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_d(bn->b, (double)value);
}

static void
bignum_set_double(PARROT_INTERP, PMC *self, double value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_d(bn->b, value);
}

static void
bignum_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_str(bn->b, value, base);
}

#  ifdef PARROT_BIGNUM_CAN_BIGINT
static void
bignum_set_bigint(PARROT_INTERP, PMC *self, struct BIGINT *value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set(bn->b, (mpf_srcptr)value->b);
}
#  endif

static BIGNUM*
bignum_get_self(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return bn;
}

static void
bignum_set_self(PARROT_INTERP, PMC *self, BIGNUM *value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set(bn->b, (mpf_srcptr)(value)->b);
}

static long
bignum_get_si(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_fits_slong_p(bn->b))
        return mpf_get_si(bn->b);

    Parrot_ex_throw_from_c_args(interp, NULL, 1, "bignum_get_si: number too big");
}

static unsigned long
bignum_get_ui(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_fits_slong_p(bn->b))
        return mpf_get_ui(bn->b);

    Parrot_ex_throw_from_c_args(interp, NULL, 1, "bignum_get_ui: number too big");
}

static int
bignum_get_bool(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_sgn(bn->b) != 0)
        return 1;
    else
        return 0;
}

static char *
bignum_get_string(PARROT_INTERP, PMC *self, int base) {
    BIGNUM *bn;
    size_t  n;
    char   *s;
    mp_exp_t exponent;

    GETATTR_BigNum_bn(interp, self, bn);
    n = (mpf_get_prec(bn->b)) / log(base) * log(2);
    s = mem_gc_allocate_n_typed(interp, n + 5, char);
    return mpf_get_str(s, &exponent, base, 0, bn->b);
}

static char *
bignum_get_string_size(PARROT_INTERP, PMC *self, int base, int digits) {
    BIGNUM *bn;
    size_t  n;
    char   *s;
    mp_exp_t exponent;

    GETATTR_BigNum_bn(interp, self, bn);
    s = mem_gc_allocate_n_typed(interp, digits + 5, char);
    return mpf_get_str(s, &exponent, base, digits, bn->b);
}

static double
bignum_get_double(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_get_d(bn->b);
}

static FLOATVAL
bignum_get_float(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_get_d(bn->b);
}

#  ifdef PARROT_BIGNUM_CAN_BIGINT
static struct BIGINT
bignum_get_bigint(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    struct BIGINT *bi_dest;
    GETATTR_BigNum_bn(interp, self, bn);
    mpz_clear(bi_dest->b);
    mpz_init(bi_dest->b);
    if (mpf_fits_slong_p(bn->b)) {
        bi_dest->b = mpf_get_ui(bn->b);
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "bignum_get_bigint: Precision loss");
    }
    return bi_dest;
}
#  endif

static void
bignum_add_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_add(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_add_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    if (value < 0)
        mpf_sub_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
    else
        mpf_add_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_add_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    BIGNUM *bn_value, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_value);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_value->b, value);
    mpf_add(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_sub_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_sub(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_sub_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    if (value < 0)
        mpf_add_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
    else
        mpf_sub_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_sub_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    BIGNUM *bn_tmp, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_tmp);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_tmp->b, value);
    mpf_sub(bn_dest->b, bn_self->b, bn_tmp->b);
}

static void
bignum_mul_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_mul(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_mul_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_mul_ui(bn_dest->b, bn_self->b, (unsigned long)value);
}

static void
bignum_mul_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    BIGNUM *bn_tmp, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_tmp);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_tmp->b, value);
    mpf_mul(bn_dest->b, bn_self->b, bn_tmp->b);
}

static void
bignum_pow_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_pow_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value) {
    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bignum_check_divide_zero(PARROT_INTERP, PMC *value) {
    /* Throw an exception if we are dividing by zero. */
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, value, bn);
    if (mpf_cmp_si(bn->b, 0) == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bignum_div_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    bignum_check_divide_zero(interp, value);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_div(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_div_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    /* this is mpz_fdiv_q */
    if (value < 0) {
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_div_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    BIGNUM bn, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);
    mpf_init(bn.b);

    if (value < 0) {
        mpf_set_d(bn.b, -value);
        mpf_div(bn_dest->b, bn_self->b, bn.b);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else {
        mpf_set_d(bn.b, value);
        mpf_div(bn_dest->b, bn_self->b, bn.b);
    }
    mpf_clear(bn.b);
}

/* There's no such mpf_fdiv, only mpz_fdiv and mpf_div */
static void
bignum_fdiv_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    bignum_check_divide_zero(interp, value);
    mpf_div(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_fdiv_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static INTVAL
bignum_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    BIGNUM *bn_self, *bn_value;
    GETATTR_BigNum_bn(interp, self,  bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    return mpf_cmp(bn_self->b, bn_value->b);
}

static INTVAL
bignum_cmp_double(PARROT_INTERP, PMC *self, double value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_d(bn->b, value);
}

static INTVAL
bignum_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_si(bn->b, value);
}

static INTVAL
bignum_cmp_ulong(PARROT_INTERP, PMC *self, unsigned long value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_ui(bn->b, value);
}

static void
bignum_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_abs(bn_dest->b, bn_self->b);
}

static void
bignum_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_neg(bn_dest->b, bn_self->b);
}

static INTVAL
bignum_get_default_prec(PARROT_INTERP, PMC *self) {
    return mpf_get_default_prec();
}

static void
bignum_set_default_prec(PARROT_INTERP, PMC *self, INTVAL prec) {
    mpf_set_default_prec(prec);
}

#else /* ifdef PARROT_HAS_GMP */

typedef struct BIGNUM {
    FLOATVAL b; /* bogus definition for users without libgmp*/
} BIGNUM;

#  define THROW_NYI Parrot_ex_throw_from_c_args(interp, NULL, \
                        EXCEPTION_LIBRARY_ERROR, "no bignum lib loaded")

#  if 0
static void
bignum_init(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static void
bignum_clear(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}
#  endif

static void
bignum_set(PARROT_INTERP, PMC *dest, PMC *src) {
    THROW_NYI;
}

static void
bignum_set_si(PARROT_INTERP, PMC *self, long value) {
    THROW_NYI;
}

static void
bignum_set_double(PARROT_INTERP, PMC *self, double value) {
    THROW_NYI;
}

static void
bignum_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    THROW_NYI;
}

static void
bignum_set_self(PARROT_INTERP, PMC *self, BIGNUM *value) {
    THROW_NYI;
}

static BIGNUM*
bignum_get_self(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static char *
bignum_get_string(PARROT_INTERP, PMC *self, int base) {
    THROW_NYI;
}

static char *
bignum_get_string_size(PARROT_INTERP, PMC *self, int base, int digits) {
    THROW_NYI;
}

static unsigned long
bignum_get_ui(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static long
bignum_get_si(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static long
bignum_get_bool(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static double
bignum_get_double(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static void
bignum_add_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_add_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_add_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_sub_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_sub_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_sub_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_mul_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_mul_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_mul_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_pow_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_pow_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_div_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_div_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_div_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static INTVAL
bignum_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    THROW_NYI;
}

static INTVAL
bignum_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    THROW_NYI;
}

static INTVAL
bignum_cmp_float(PARROT_INTERP, PMC *self, FLOATVAL value) {
    THROW_NYI;
}

static void
bignum_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    THROW_NYI;
}

static void
bignum_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    THROW_NYI;
}

static INTVAL
bignum_get_default_prec(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static void
bignum_set_default_prec(PARROT_INTERP, PMC *self, INTVAL prec) {
    THROW_NYI;
}

#  undef THROW_NYI

#endif /* ifdef PARROT_HAS_GMP */
#line 800 "./src/pmc/bignum.c"
static  PMC  * Parrot_BigNum_absolute(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_BigNum_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_BigNum_cmp(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_decrement(PARROT_INTERP, PMC *pmc);
static  void  Parrot_BigNum_destroy(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_BigNum_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_BigNum_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  INTVAL  Parrot_BigNum_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_BigNum_get_integer(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_BigNum_get_number(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_BigNum_get_repr(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_BigNum_get_string(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_BigNum_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base);
static  void  Parrot_BigNum_i_absolute(PARROT_INTERP, PMC *pmc);
static  void Parrot_BigNum_i_add(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_BigNum_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_BigNum_i_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_BigNum_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_BigNum_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_BigNum_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_BigNum_i_neg(PARROT_INTERP, PMC *pmc);
static  void Parrot_BigNum_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_BigNum_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_BigNum_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_BigNum_init(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_BigNum_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC * Parrot_BigNum_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_neg(PARROT_INTERP, PMC *pmc, PMC *dest);
static  void  Parrot_BigNum_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_BigNum_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_BigNum_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value);
static  void  Parrot_BigNum_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  PMC * Parrot_BigNum_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void Parrot_BigNum_nci_version(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_BigNum_multi_add_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_add_BigNum(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_add_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigNum_multi_subtract_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_subtract_BigNum(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigNum_multi_multiply_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_multiply_BigNum(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_BigNum_nci_pow(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_BigNum_multi_divide_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_divide_BigNum(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_divide_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_BigNum_multi_floor_divide_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_floor_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_BigNum_multi_i_floor_divide_BigNum(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_floor_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_BigNum_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_BigNum(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_BigNum(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
void    Parrot_BigNum_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_BigNum_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_BigNum_get_vtable(PARROT_INTERP);
void    Parrot_BigNum_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_BigNum_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_BigNum_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_BigNum_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1438 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_abs(interp, pmc, dest);
    return dest;
#line 904 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_add_BigNum_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_add_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_add_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1069 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_add_bignum_int(interp, pmc, value, dest);
    return dest;
#line 943 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_clone(PARROT_INTERP, PMC *pmc)
{
#line 812 "./src/pmc/bignum.pmc"

    PMC *res = Parrot_pmc_new(interp, pmc->vtable->base_type);
    bignum_set(interp, res, pmc);
    return res;
#line 953 "./src/pmc/bignum.c"
}
static  INTVAL
Parrot_BigNum_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_cmp_BigNum(interp, pmc, value);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_cmp_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_cmp_DEFAULT(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  void 
Parrot_BigNum_decrement(PARROT_INTERP, PMC *pmc)
{
#line 1036 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, pmc, 1, pmc);
#line 989 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_destroy(PARROT_INTERP, PMC *pmc)
{
#line 818 "./src/pmc/bignum.pmc"

    bignum_clear(interp, pmc);
#line 997 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_divide_BigNum_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_divide_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_divide_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1298 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_div_bignum_float(interp, pmc, value, dest);
    return dest;
#line 1036 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1291 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_div_bignum_int(interp, pmc, value, dest);
    return dest;
#line 1047 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_floor_divide_BigNum_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_floor_divide_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1354 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_fdiv_bignum_int(interp, pmc, value, dest);
    return dest;
#line 1086 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 959 "./src/pmc/bignum.pmc"

    return bignum_get_bool(interp, pmc);
#line 1094 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 912 "./src/pmc/bignum.pmc"

    return bignum_get_si(interp, pmc);
#line 1102 "./src/pmc/bignum.c"
}
static  FLOATVAL 
Parrot_BigNum_get_number(PARROT_INTERP, PMC *pmc)
{
#line 898 "./src/pmc/bignum.pmc"

    return bignum_get_double(interp, pmc);
#line 1110 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 1008 "./src/pmc/bignum.pmc"

    STRING *s = VTABLE_get_string(interp, pmc);
    return Parrot_str_append(interp, s, Parrot_str_new(interp, "N", 1));
#line 1119 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_string(PARROT_INTERP, PMC *pmc)
{
#line 987 "./src/pmc/bignum.pmc"

    char   *s  = bignum_get_string(interp, pmc, 10);
    STRING *ps = Parrot_str_new(interp, s, 0);
    mem_gc_free(interp, s);
    return ps;
#line 1130 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base)
{
#line 994 "./src/pmc/bignum.pmc"

    char   *s  = bignum_get_string(interp, pmc, base);
    STRING *ps = Parrot_str_new(interp, s, 0);
    mem_gc_free(interp, s);
    return ps;
#line 1141 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1445 "./src/pmc/bignum.pmc"

    bignum_abs(interp, pmc, pmc);
#line 1149 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_add_BigNum(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_add_Integer(interp, pmc, value);
            break;

        case enum_class_Float:
            Parrot_BigNum_multi_i_add_Float(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_add_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1099 "./src/pmc/bignum.pmc"

    bignum_add_bignum_float(interp, pmc, value, pmc);
#line 1189 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1095 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, pmc, value, pmc);
#line 1197 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_divide_BigNum(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_divide_Integer(interp, pmc, value);
            break;

        case enum_class_Float:
            Parrot_BigNum_multi_i_divide_Float(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_divide_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1321 "./src/pmc/bignum.pmc"

    bignum_div_bignum_int(interp, pmc, value, pmc);
#line 1237 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_floor_divide_BigNum(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_floor_divide_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_floor_divide_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1376 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum_int(interp, pmc, value, pmc);
#line 1273 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_multiply_BigNum(interp, pmc, value);
            break;

        case enum_class_Float:
            Parrot_BigNum_multi_i_multiply_Float(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_multiply_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_multiply_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1225 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_float(interp, pmc, value, pmc);
#line 1313 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1221 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_int(interp, pmc, value, pmc);
#line 1321 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 1469 "./src/pmc/bignum.pmc"

    bignum_neg(interp, pmc, pmc);
#line 1329 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_subtract_BigNum(interp, pmc, value);
            break;

        case enum_class_Integer:
            Parrot_BigNum_multi_i_subtract_Integer(interp, pmc, value);
            break;

        case enum_class_Float:
            Parrot_BigNum_multi_i_subtract_Float(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_BigNum_multi_i_subtract_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_BigNum_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1162 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_float(interp, pmc, value, pmc);
#line 1369 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1158 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, pmc, value, pmc);
#line 1377 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_increment(PARROT_INTERP, PMC *pmc)
{
#line 1022 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, pmc, 1, pmc);
#line 1385 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_init(PARROT_INTERP, PMC *pmc)
{
#line 807 "./src/pmc/bignum.pmc"

    bignum_init(interp, pmc);
    PObj_custom_destroy_SET(pmc);
#line 1394 "./src/pmc/bignum.c"
}
static  INTVAL
Parrot_BigNum_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_is_equal_BigNum(interp, pmc, value);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_is_equal_Integer(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_is_equal_DEFAULT(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  PMC *
Parrot_BigNum_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_multiply_BigNum_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_multiply_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_multiply_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1195 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_mul_bignum_int(interp, pmc, value, dest);
    return dest;
#line 1461 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1462 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_neg(interp, pmc, dest);
    return dest;
#line 1472 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 830 "./src/pmc/bignum.pmc"

    bignum_set_si(interp, pmc, (long)value);
#line 1480 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 844 "./src/pmc/bignum.pmc"

    bignum_set_double(interp, pmc, (double)value);
#line 1488 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 884 "./src/pmc/bignum.pmc"

    bignum_set_self(interp, pmc, bignum_get_self(interp, value));
#line 1496 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value)
{
#line 869 "./src/pmc/bignum.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bignum_set_str(interp, pmc, s, base);
    Parrot_str_free_cstring(s);
#line 1506 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 863 "./src/pmc/bignum.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bignum_set_str(interp, pmc, s, 10);
    Parrot_str_free_cstring(s);
#line 1516 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_subtract_BigNum_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Integer:
            return Parrot_BigNum_multi_subtract_Integer_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_BigNum_multi_subtract_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_BigNum_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1132 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_sub_bignum_int(interp, pmc, value, dest);
    return dest;
#line 1555 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_nci_version(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1568 "./src/pmc/bignum.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 797 "./src/pmc/bignum.pmc"

    STRING *version;
#ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
#else
    version = Parrot_str_new(interp, "0.0.0", 5);
#endif
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *version */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)version);
    return;
    /*END RETURN STRING *version */
    }
#line 804 "./src/pmc/bignum.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1600 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_add_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1048 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_add_bignum(interp, pmc, value, dest);
    return dest;
#line 1611 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1055 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_add_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1622 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1062 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'add' for %Ss",
        VTABLE_name(interp, value));
#line 1633 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1076 "./src/pmc/bignum.pmc"

    bignum_add_bignum(interp, pmc, value, pmc);
#line 1641 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1080 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1649 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1084 "./src/pmc/bignum.pmc"

    bignum_add_bignum_float(interp, pmc, VTABLE_get_number(interp, value), pmc);
#line 1657 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1088 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_add' for %Ss",
        VTABLE_name(interp, value));
#line 1668 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1111 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_sub_bignum(interp, pmc, value, dest);
    return dest;
#line 1679 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1118 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_sub_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1690 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1125 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'subtract' for %Ss",
        VTABLE_name(interp, value));
#line 1701 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1139 "./src/pmc/bignum.pmc"

    bignum_sub_bignum(interp, pmc, value, pmc);
#line 1709 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1143 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1717 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1147 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_float(interp, pmc, VTABLE_get_number(interp, value), pmc);
#line 1725 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1151 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_subtract' for %Ss",
        VTABLE_name(interp, value));
#line 1736 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1174 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_mul_bignum(interp, pmc, value, dest);
    return dest;
#line 1747 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1181 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_mul_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1758 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1188 "./src/pmc/bignum.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'multiply' for %Ss",
        VTABLE_name(interp, value));
#line 1769 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1202 "./src/pmc/bignum.pmc"

    bignum_mul_bignum(interp, pmc, value, pmc);
#line 1777 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1206 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_float(interp, pmc, VTABLE_get_number(interp, value), pmc);
#line 1785 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1210 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1793 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1214 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_multiply' for %Ss",
        VTABLE_name(interp, value));
#line 1804 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_nci_pow(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1817 "./src/pmc/bignum.pmc"
PMC* pmc;
PMC* value;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &pmc, &value);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1243 "./src/pmc/bignum.pmc"

    /* only Integer RHS currently. TODO: check number and bignum types */
    INTVAL r = VTABLE_get_integer(interp, value);
    PMC *dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    bignum_pow_bignum_int(interp, pmc, r, dest);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *dest */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)dest);
    return;
    /*END RETURN PMC *dest */
    }
#line 1249 "./src/pmc/bignum.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1849 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_divide_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1260 "./src/pmc/bignum.pmc"

    BIGNUM *bn;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_div_bignum(interp, pmc, value, dest);
#if 0
    /* to downgrade or not that's the question */
    GETATTR_BigNum_bn(interp, dest, bn);
    if (mpf_fits_slong_p(bn->b)) {
        long iresult = mpf_get_si(bn->b);
        VTABLE_morph(interp, dest, enum_class_Integer);
        VTABLE_set_integer_native(interp, dest, iresult);
    }
#endif
    return dest;
#line 1870 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1277 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_div_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1881 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1284 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'divide' for %Ss",
        VTABLE_name(interp, value));
#line 1892 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1305 "./src/pmc/bignum.pmc"

    bignum_div_bignum(interp, pmc, value, pmc);
#line 1900 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1308 "./src/pmc/bignum.pmc"

    bignum_div_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1908 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1311 "./src/pmc/bignum.pmc"

    bignum_div_bignum_float(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1916 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1314 "./src/pmc/bignum.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1927 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1333 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_fdiv_bignum(interp, pmc, value, dest);
    return dest;
#line 1938 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1340 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    bignum_fdiv_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1949 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1347 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1960 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1361 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum(interp, pmc, value, pmc);
#line 1968 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1365 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1976 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1369 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1987 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1388 "./src/pmc/bignum.pmc"

    return bignum_cmp(interp, pmc, value);
#line 1995 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1392 "./src/pmc/bignum.pmc"

    return bignum_cmp_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 2003 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1396 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'cmp' for %Ss",
        VTABLE_name(interp, value));
#line 2014 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1411 "./src/pmc/bignum.pmc"

    return bignum_cmp(interp, pmc, value) == 0;
#line 2022 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1415 "./src/pmc/bignum.pmc"

    return bignum_cmp_int(interp, pmc, VTABLE_get_integer(interp, value)) == 0;
#line 2030 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1419 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'is_equal' for %Ss",
        VTABLE_name(interp, value));
#line 2041 "./src/pmc/bignum.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_BigNum_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_BigNum_absolute;
    vt->add = Parrot_BigNum_add;
    vt->add_int = Parrot_BigNum_add_int;
    vt->clone = Parrot_BigNum_clone;
    vt->cmp = Parrot_BigNum_cmp;
    vt->decrement = Parrot_BigNum_decrement;
    vt->destroy = Parrot_BigNum_destroy;
    vt->divide = Parrot_BigNum_divide;
    vt->divide_float = Parrot_BigNum_divide_float;
    vt->divide_int = Parrot_BigNum_divide_int;
    vt->floor_divide = Parrot_BigNum_floor_divide;
    vt->floor_divide_int = Parrot_BigNum_floor_divide_int;
    vt->get_bool = Parrot_BigNum_get_bool;
    vt->get_integer = Parrot_BigNum_get_integer;
    vt->get_number = Parrot_BigNum_get_number;
    vt->get_repr = Parrot_BigNum_get_repr;
    vt->get_string = Parrot_BigNum_get_string;
    vt->get_string_keyed_int = Parrot_BigNum_get_string_keyed_int;
    vt->i_absolute = Parrot_BigNum_i_absolute;
    vt->i_add = Parrot_BigNum_i_add;
    vt->i_add_float = Parrot_BigNum_i_add_float;
    vt->i_add_int = Parrot_BigNum_i_add_int;
    vt->i_divide = Parrot_BigNum_i_divide;
    vt->i_divide_int = Parrot_BigNum_i_divide_int;
    vt->i_floor_divide = Parrot_BigNum_i_floor_divide;
    vt->i_floor_divide_int = Parrot_BigNum_i_floor_divide_int;
    vt->i_multiply = Parrot_BigNum_i_multiply;
    vt->i_multiply_float = Parrot_BigNum_i_multiply_float;
    vt->i_multiply_int = Parrot_BigNum_i_multiply_int;
    vt->i_neg = Parrot_BigNum_i_neg;
    vt->i_subtract = Parrot_BigNum_i_subtract;
    vt->i_subtract_float = Parrot_BigNum_i_subtract_float;
    vt->i_subtract_int = Parrot_BigNum_i_subtract_int;
    vt->increment = Parrot_BigNum_increment;
    vt->init = Parrot_BigNum_init;
    vt->is_equal = Parrot_BigNum_is_equal;
    vt->multiply = Parrot_BigNum_multiply;
    vt->multiply_int = Parrot_BigNum_multiply_int;
    vt->neg = Parrot_BigNum_neg;
    vt->set_integer_native = Parrot_BigNum_set_integer_native;
    vt->set_number_native = Parrot_BigNum_set_number_native;
    vt->set_pmc = Parrot_BigNum_set_pmc;
    vt->set_string_keyed_int = Parrot_BigNum_set_string_keyed_int;
    vt->set_string_native = Parrot_BigNum_set_string_native;
    vt->subtract = Parrot_BigNum_subtract;
    vt->subtract_int = Parrot_BigNum_subtract_int;
    vt->attr_size = sizeof(Parrot_BigNum_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_BigNum_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_BigNum_absolute;
    vt->add = Parrot_BigNum_add;
    vt->add_int = Parrot_BigNum_add_int;
    vt->clone = Parrot_BigNum_clone;
    vt->cmp = Parrot_BigNum_cmp;
    vt->destroy = Parrot_BigNum_destroy;
    vt->divide = Parrot_BigNum_divide;
    vt->divide_float = Parrot_BigNum_divide_float;
    vt->divide_int = Parrot_BigNum_divide_int;
    vt->floor_divide = Parrot_BigNum_floor_divide;
    vt->floor_divide_int = Parrot_BigNum_floor_divide_int;
    vt->get_bool = Parrot_BigNum_get_bool;
    vt->get_integer = Parrot_BigNum_get_integer;
    vt->get_number = Parrot_BigNum_get_number;
    vt->get_repr = Parrot_BigNum_get_repr;
    vt->get_string = Parrot_BigNum_get_string;
    vt->get_string_keyed_int = Parrot_BigNum_get_string_keyed_int;
    vt->init = Parrot_BigNum_init;
    vt->is_equal = Parrot_BigNum_is_equal;
    vt->multiply = Parrot_BigNum_multiply;
    vt->multiply_int = Parrot_BigNum_multiply_int;
    vt->neg = Parrot_BigNum_neg;
    vt->subtract = Parrot_BigNum_subtract;
    vt->subtract_int = Parrot_BigNum_subtract_int;
    vt->attr_size = sizeof(Parrot_BigNum_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigNum_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_BigNum_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigNum_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_BigNum_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_BigNum_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "BigNum", 6, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_BigNum_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "BigNum")), PMCNULL);
    return isa;
}

void
Parrot_BigNum_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":bn ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_BigNum_get_vtable(interp);
        vt->base_type      = enum_class_BigNum;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "BigNum");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_BigNum_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_BigNum;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_BigNum_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_BigNum_nci_version), CONST_STRING_GEN(interp, "version"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_BigNum_nci_pow), CONST_STRING_GEN(interp, "pow"));
        {
        STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
        STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
        STRING * const mfl_2 = CONST_STRING_GEN(interp, "BigNum,BigNum,PMC");
        STRING * const mfl_3 = CONST_STRING_GEN(interp, "BigNum");
        STRING * const mfl_4 = CONST_STRING_GEN(interp, "BigNum,Integer,PMC");
        STRING * const mfl_5 = CONST_STRING_GEN(interp, "BigNum,DEFAULT,PMC");
        STRING * const mfl_6 = CONST_STRING_GEN(interp, "i_add");
        STRING * const mfl_7 = CONST_STRING_GEN(interp, "vJPP");
        STRING * const mfl_8 = CONST_STRING_GEN(interp, "BigNum,BigNum");
        STRING * const mfl_9 = CONST_STRING_GEN(interp, "BigNum,Integer");
        STRING * const mfl_10 = CONST_STRING_GEN(interp, "BigNum,Float");
        STRING * const mfl_11 = CONST_STRING_GEN(interp, "BigNum,DEFAULT");
        STRING * const mfl_12 = CONST_STRING_GEN(interp, "subtract");
        STRING * const mfl_13 = CONST_STRING_GEN(interp, "i_subtract");
        STRING * const mfl_14 = CONST_STRING_GEN(interp, "multiply");
        STRING * const mfl_15 = CONST_STRING_GEN(interp, "i_multiply");
        STRING * const mfl_16 = CONST_STRING_GEN(interp, "divide");
        STRING * const mfl_17 = CONST_STRING_GEN(interp, "i_divide");
        STRING * const mfl_18 = CONST_STRING_GEN(interp, "floor_divide");
        STRING * const mfl_19 = CONST_STRING_GEN(interp, "i_floor_divide");
        STRING * const mfl_20 = CONST_STRING_GEN(interp, "cmp");
        STRING * const mfl_21 = CONST_STRING_GEN(interp, "IJPP");
        STRING * const mfl_22 = CONST_STRING_GEN(interp, "is_equal");

             const  multi_func_list _temp_multi_func_list[] = {
                        { mfl_0,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_add_BigNum_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_add_Integer_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_add_DEFAULT_PMC }
,
        { mfl_6,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_add_BigNum }
,
        { mfl_6,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_add_Integer }
,
        { mfl_6,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_add_Float }
,
        { mfl_6,
          mfl_7,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_add_DEFAULT }
,
        { mfl_12,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_subtract_BigNum_PMC }
,
        { mfl_12,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_subtract_Integer_PMC }
,
        { mfl_12,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_subtract_DEFAULT_PMC }
,
        { mfl_13,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_subtract_BigNum }
,
        { mfl_13,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_subtract_Integer }
,
        { mfl_13,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_subtract_Float }
,
        { mfl_13,
          mfl_7,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_subtract_DEFAULT }
,
        { mfl_14,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_multiply_BigNum_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_multiply_Integer_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_multiply_DEFAULT_PMC }
,
        { mfl_15,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_multiply_BigNum }
,
        { mfl_15,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_multiply_Float }
,
        { mfl_15,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_multiply_Integer }
,
        { mfl_15,
          mfl_7,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_multiply_DEFAULT }
,
        { mfl_16,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_divide_BigNum_PMC }
,
        { mfl_16,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_divide_Integer_PMC }
,
        { mfl_16,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_divide_DEFAULT_PMC }
,
        { mfl_17,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_divide_BigNum }
,
        { mfl_17,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_divide_Integer }
,
        { mfl_17,
          mfl_7,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_divide_Float }
,
        { mfl_17,
          mfl_7,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_divide_DEFAULT }
,
        { mfl_18,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_floor_divide_BigNum_PMC }
,
        { mfl_18,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_floor_divide_Integer_PMC }
,
        { mfl_18,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_floor_divide_DEFAULT_PMC }
,
        { mfl_19,
          mfl_7,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_floor_divide_BigNum }
,
        { mfl_19,
          mfl_7,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_floor_divide_Integer }
,
        { mfl_19,
          mfl_7,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_i_floor_divide_DEFAULT }
,
        { mfl_20,
          mfl_21,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_cmp_BigNum }
,
        { mfl_20,
          mfl_21,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_cmp_Integer }
,
        { mfl_20,
          mfl_21,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_cmp_DEFAULT }
,
        { mfl_22,
          mfl_21,
          mfl_8,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_is_equal_BigNum }
,
        { mfl_22,
          mfl_21,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_is_equal_Integer }
,
        { mfl_22,
          mfl_21,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_BigNum_multi_is_equal_DEFAULT }

            };
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_BigNum_class_init */
#line 1472 "./src/pmc/bignum.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
