/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/callcontext.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_callcontext.h"
#include "pmc_default.h"
#include "callcontext.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/callcontext.pmc"
/*
Copyright (C) 2008-2009, Parrot Foundation.
$Id: callcontext.pmc 44894 2010-03-12 03:53:04Z chromatic $

=head1 NAME

src/pmc/callcontext.pmc - CallContext PMC

=head1 DESCRIPTION

The CallContext PMC is used to store the argument list and argument meta
information for a multiple dispatch call.

=head2 Functions

=over 4

=cut

*/

typedef struct Pcc_cell
{
    union u {
        PMC     *p;
        STRING  *s;
        INTVAL   i;
        FLOATVAL n;
    } u;
    struct Pcc_cell *next;
} Pcc_cell;

/* mask off lower two bits (1 + 2 = 3) for pointer tags */
#define TAG_BITS 3
#define UNTAG_CELL(c) INTVAL2PTR(Pcc_cell *, (PTR2INTVAL(c)) & ~TAG_BITS)

#define CELL_INT(c)     UNTAG_CELL(c)->u.i
#define CELL_FLOAT(c)   UNTAG_CELL(c)->u.n
#define CELL_STRING(c)  UNTAG_CELL(c)->u.s
#define CELL_PMC(c)     UNTAG_CELL(c)->u.p

#define NEXT_CELL(c) UNTAG_CELL(c)->next
#define FREE_CELL(i, c) \
    Parrot_gc_free_fixed_size_storage((i), sizeof (Pcc_cell), (UNTAG_CELL(c)))

#define CELL_TYPE_MASK(c) (PTR2INTVAL(c)) & 3
#define INTCELL    0
#define FLOATCELL  1
#define STRINGCELL 2
#define PMCCELL    3

#define ALLOC_CELL(i) \
    (Pcc_cell *)Parrot_gc_allocate_fixed_size_storage((i), sizeof (Pcc_cell))

#define INIT_CELL_INT(c)    INTVAL2PTR(Pcc_cell *, PTR2INTVAL(c) | INTCELL)
#define INIT_CELL_FLOAT(c)  INTVAL2PTR(Pcc_cell *, PTR2INTVAL(c) | FLOATCELL)
#define INIT_CELL_STRING(c) INTVAL2PTR(Pcc_cell *, PTR2INTVAL(c) | STRINGCELL)
#define INIT_CELL_PMC(c)    INTVAL2PTR(Pcc_cell *, PTR2INTVAL(c) | PMCCELL)

#define CREATE_INTVAL_CELL(i)   INIT_CELL_INT(ALLOC_CELL(i))

#define CREATE_FLOATVAL_CELL(i) INIT_CELL_FLOAT(ALLOC_CELL(i))

#define CREATE_STRING_CELL(i)   INIT_CELL_STRING(ALLOC_CELL(i))

#define CREATE_PMC_CELL(i)      INIT_CELL_PMC(ALLOC_CELL(i))

#define APPEND_CELL(i, obj, cell) \
    do { \
        INTVAL num_positionals; \
        Pcc_cell *positionals; \
        GETATTR_CallContext_num_positionals((i), (obj), num_positionals); \
        GETATTR_CallContext_positionals((i), (obj), positionals); \
        SETATTR_CallContext_num_positionals((i), (obj), num_positionals+1); \
        NEXT_CELL(cell) = NULL; \
        if (positionals) { \
            while (NEXT_CELL(positionals)) { \
                positionals = NEXT_CELL(positionals); \
            } \
            NEXT_CELL(positionals) = (cell); \
        } \
        else \
            SETATTR_CallContext_positionals((i), (obj), (cell)); \
    } while (0)

#define PREPEND_CELL(i, obj, cell) \
    do { \
        INTVAL num_positionals; \
        Pcc_cell *positionals; \
        GETATTR_CallContext_num_positionals((i), (obj), num_positionals); \
        GETATTR_CallContext_positionals((i), (obj), positionals); \
        SETATTR_CallContext_num_positionals((i), (obj), num_positionals+1); \
        NEXT_CELL(cell) = positionals; \
        SETATTR_CallContext_positionals((i), (obj), (cell)); \
    } while (0)

#define HLL_TYPE(i) Parrot_get_ctx_HLL_type(interp, (i))

/* TODO: could use get_cell_at */
static Pcc_cell *
pop_cell(PARROT_INTERP, ARGIN(PMC *SELF))
{
    INTVAL num_positionals;
    Pcc_cell *cell;
    Pcc_cell *prev = NULL;

    GETATTR_CallContext_positionals(interp, SELF, cell);

    /* no cells */
    if (!cell)
        return NULL;

    GETATTR_CallContext_num_positionals(interp, SELF, num_positionals);
    SETATTR_CallContext_num_positionals(interp, SELF, num_positionals-1);

    /* one cell */
    if (!NEXT_CELL(cell)) {
        SETATTR_CallContext_positionals(interp, SELF, NULL);
        return cell;
    }

    while (cell) {
        if (!NEXT_CELL(cell)) {
            NEXT_CELL(prev) = NULL;
            return cell;
        }

        prev = cell;
        cell = NEXT_CELL(cell);
    }

    /* should abort here */
    SETATTR_CallContext_num_positionals(interp, SELF, num_positionals+1);
    return NULL;
}

static Pcc_cell *
shift_cell(PARROT_INTERP, ARGIN(PMC *SELF))
{
    INTVAL num_positionals;
    Pcc_cell *cell;

    GETATTR_CallContext_positionals(interp, SELF, cell);

    /* no cells */
    if (!cell)
        return NULL;

    GETATTR_CallContext_num_positionals(interp, SELF, num_positionals);
    SETATTR_CallContext_num_positionals(interp, SELF, num_positionals-1);

    /* one cell */
    if (!NEXT_CELL(cell))
        SETATTR_CallContext_positionals(interp, SELF, NULL);
    else
        SETATTR_CallContext_positionals(interp, SELF, NEXT_CELL(cell));

    return cell;
}

static Pcc_cell *
get_cell_at(PARROT_INTERP, ARGIN(PMC *SELF), INTVAL key)
{
    INTVAL    i, num_positionals;
    Pcc_cell *cell;

    GETATTR_CallContext_num_positionals(interp, SELF, num_positionals);

    if (key > num_positionals)
        return NULL;

    GETATTR_CallContext_positionals(interp, SELF, cell);

    while (key) {
        /* XXX: shouldn't happen */
        if (!NEXT_CELL(cell))
            return NULL;

        cell = NEXT_CELL(cell);
        key--;
    }

    return cell;

}

static INTVAL
autobox_intval(PARROT_INTERP, Pcc_cell *cell)
{
    switch (CELL_TYPE_MASK(cell)) {
      case INTCELL:
        return CELL_INT(cell);
      case FLOATCELL:
        return (INTVAL)CELL_FLOAT(cell);
      case STRINGCELL:
        return CELL_STRING(cell) ? Parrot_str_to_int(interp, CELL_STRING(cell)) : 0;
      case PMCCELL:
        return PMC_IS_NULL(CELL_PMC(cell))
                ? 0
                : VTABLE_get_integer(interp, CELL_PMC(cell));
      default:
        break;
    }

    /* exception */
    return 0;
}

static FLOATVAL
autobox_floatval(PARROT_INTERP, Pcc_cell *cell)
{
    switch (CELL_TYPE_MASK(cell)) {
      case INTCELL:
        return (FLOATVAL)CELL_INT(cell);
      case FLOATCELL:
        return CELL_FLOAT(cell);
      case STRINGCELL:
        return CELL_STRING(cell) ? Parrot_str_to_num(interp, CELL_STRING(cell)) : 0.0;
      case PMCCELL:
        return PMC_IS_NULL(CELL_PMC(cell))
                ? 0.0
                : VTABLE_get_number(interp, CELL_PMC(cell));
      default:
        break;
    }

    /* exception */
    return 0.0;
}

static STRING *
autobox_string(PARROT_INTERP, Pcc_cell *cell)
{
    switch (CELL_TYPE_MASK(cell)) {
      case INTCELL:
        return Parrot_str_from_int(interp, CELL_INT(cell));
      case FLOATCELL:
        return Parrot_str_from_num(interp, CELL_FLOAT(cell));
      case STRINGCELL:
        return CELL_STRING(cell);
      case PMCCELL:
        return PMC_IS_NULL(CELL_PMC(cell))
                ? NULL
                : VTABLE_get_string(interp, CELL_PMC(cell));
      default:
        break;
    }

    /* exception */
    return NULL;
}

static PMC *
autobox_pmc(PARROT_INTERP, Pcc_cell *cell)
{
    PMC *result = PMCNULL;

    switch (CELL_TYPE_MASK(cell)) {
      case INTCELL:
        result = Parrot_pmc_new(interp, HLL_TYPE(enum_class_Integer));
        VTABLE_set_integer_native(interp, result, CELL_INT(cell));
        break;
      case FLOATCELL:
        result = Parrot_pmc_new(interp, HLL_TYPE(enum_class_Float));
        VTABLE_set_number_native(interp, result, CELL_FLOAT(cell));
        break;
      case STRINGCELL:
        result = Parrot_pmc_new(interp, HLL_TYPE(enum_class_String));
        VTABLE_set_string_native(interp, result, CELL_STRING(cell));
        break;
      case PMCCELL:
        return CELL_PMC(cell);
      default:
        /* exception */
        break;
    }

    return result;
}

static Hash *
get_hash(PARROT_INTERP, ARGIN(PMC *SELF))
{
    Hash   *hash;

    GETATTR_CallContext_hash(interp, SELF, hash);

    if (!hash) {
        hash = parrot_create_hash(interp,
            enum_type_ptr,
            Hash_key_type_STRING,
            STRING_compare,
            (hash_hash_key_fn)key_hash_STRING);

        SETATTR_CallContext_hash(interp, SELF, hash);
    }

    return hash;
}

static void
mark_positionals(PARROT_INTERP, ARGIN(Pcc_cell *c))
{
    while (c) {
        switch (CELL_TYPE_MASK(c)) {
          case STRINGCELL:
            if (CELL_STRING(c))
                Parrot_gc_mark_STRING_alive(interp, CELL_STRING(c));
            break;
          case PMCCELL:
            if (!PMC_IS_NULL(CELL_PMC(c)))
                Parrot_gc_mark_PMC_alive(interp, CELL_PMC(c));
            break;
          case INTCELL:
          case FLOATCELL:
          default:
            break;
        }

        c = NEXT_CELL(c);
    }
}

/* don't look now, but here goes encapsulation.... */
static void
mark_hash(PARROT_INTERP, ARGIN(Hash *h))
{
    UINTVAL entries = h->entries;
    INTVAL  i;

    for (i = h->mask; i >= 0; --i) {
        HashBucket *b = h->bi[i];

        while (b) {
            Parrot_gc_mark_STRING_alive(interp, (STRING *)b->key);
            mark_positionals(interp, (Pcc_cell *)b->value);
            b = b->next;
        }

    }
}

static PMC *
get_named_names(PARROT_INTERP, ARGIN(PMC *SELF))
{
    Hash *hash;
    PMC  *result = PMCNULL;

    GETATTR_CallContext_hash(interp, SELF, hash);

    /* yes, this *looks* risky, but it's a Parrot STRING hash internally */
    if (hash && hash->entries) {
        UINTVAL i, j = 0;
        result  = Parrot_pmc_new(interp, enum_class_FixedStringArray);
        VTABLE_set_integer_native(interp, result, hash->entries);

        for (i = 0; i <= hash->mask; i++) {
            HashBucket *b = hash->bi[i];

            while (b) {
                VTABLE_set_string_keyed_int(interp, result,
                    j++, (STRING *)b->key);
                b = b->next;
            }
        }
    }

    return result;
}

#include "parrot/packfile.h"
#include "pmc/pmc_sub.h"
#line 396 "./src/pmc/callcontext.c"
static  PMC  * Parrot_CallContext_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_CallContext_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_CallContext_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_CallContext_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_CallContext_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL  Parrot_CallContext_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_CallContext_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  INTVAL  Parrot_CallContext_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_CallContext_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL  Parrot_CallContext_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  FLOATVAL  Parrot_CallContext_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_CallContext_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  FLOATVAL  Parrot_CallContext_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_CallContext_get_pmc(PARROT_INTERP, PMC *pmc);
static  PMC *  Parrot_CallContext_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC *  Parrot_CallContext_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC *  Parrot_CallContext_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING  * Parrot_CallContext_get_string(PARROT_INTERP, PMC *pmc);
static  STRING *  Parrot_CallContext_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING *  Parrot_CallContext_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  STRING *  Parrot_CallContext_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_CallContext_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_CallContext_mark(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_CallContext_pop_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_CallContext_pop_integer(PARROT_INTERP, PMC *pmc);
static  PMC *  Parrot_CallContext_pop_pmc(PARROT_INTERP, PMC *pmc);
static  STRING *  Parrot_CallContext_pop_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_CallContext_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_CallContext_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_CallContext_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_CallContext_push_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_CallContext_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void  Parrot_CallContext_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void  Parrot_CallContext_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void  Parrot_CallContext_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value);
static  void  Parrot_CallContext_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void  Parrot_CallContext_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value);
static  void  Parrot_CallContext_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value);
static  void  Parrot_CallContext_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_CallContext_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_CallContext_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value);
static  void  Parrot_CallContext_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void  Parrot_CallContext_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void  Parrot_CallContext_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value);
static  void  Parrot_CallContext_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  void  Parrot_CallContext_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  FLOATVAL  Parrot_CallContext_shift_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_CallContext_shift_integer(PARROT_INTERP, PMC *pmc);
static  PMC *  Parrot_CallContext_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING *  Parrot_CallContext_shift_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_CallContext_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_CallContext_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_CallContext_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_CallContext_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_CallContext_nci_backtrace(PARROT_INTERP, PMC *pmc);
void    Parrot_CallContext_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_CallContext_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_CallContext_get_vtable(PARROT_INTERP);
void    Parrot_CallContext_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_CallContext_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_CallContext_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_CallContext_clone(PARROT_INTERP, PMC *pmc)
{
#line 1410 "./src/pmc/callcontext.pmc"

    Pcc_cell    *cell;
    STRING      *short_sig;
    PMC         *type_tuple, *arg_flags, *return_flags;
    PMC * const dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    GETATTR_CallContext_positionals(interp, pmc, cell);

    /* Copy all positional cells (thanks to APPEND_CELL, this also
     * sets num_positionals). */
    for (; cell; cell = NEXT_CELL(cell)) {
        Pcc_cell *cloned_cell;

        switch (CELL_TYPE_MASK(cell)) {
          case INTCELL:
            cloned_cell = CREATE_INTVAL_CELL(interp);
            CELL_INT(cloned_cell) = CELL_INT(cell);
            break;
          case FLOATCELL:
            cloned_cell = CREATE_FLOATVAL_CELL(interp);
            CELL_FLOAT(cloned_cell) = CELL_FLOAT(cell);
            break;
          case STRINGCELL:
            cloned_cell = CREATE_STRING_CELL(interp);
            CELL_STRING(cloned_cell) = CELL_STRING(cell);
            break;
          case PMCCELL:
            cloned_cell = CREATE_PMC_CELL(interp);
            CELL_PMC(cloned_cell) = CELL_PMC(cell);
            break;
          default:
            break;
        }
        APPEND_CELL(interp, dest, cloned_cell);
    }


    GETATTR_CallContext_type_tuple(interp, pmc, type_tuple);
    GETATTR_CallContext_short_sig(interp, pmc, short_sig);
    GETATTR_CallContext_arg_flags(interp, pmc, arg_flags);
    GETATTR_CallContext_return_flags(interp, pmc, return_flags);

    /* FIXME
    PMC *results;

    GETATTR_CallContext_results(interp, pmc, results);

    if (!PMC_IS_NULL(results))
        SETATTR_CallContext_results(interp, dest, VTABLE_clone(interp, results));
    */

    if (!PMC_IS_NULL(type_tuple))
        SETATTR_CallContext_type_tuple(interp, dest, VTABLE_clone(interp, type_tuple));

    if (short_sig)
        SETATTR_CallContext_short_sig(interp, dest, Parrot_str_copy(interp, short_sig));

    if (!PMC_IS_NULL(arg_flags))
        SETATTR_CallContext_arg_flags(interp, dest, VTABLE_clone(interp, arg_flags));

    if (!PMC_IS_NULL(return_flags))
        SETATTR_CallContext_return_flags(interp, dest, VTABLE_clone(interp, return_flags));

    parrot_hash_clone(interp, get_hash(interp, pmc),
        get_hash(interp, dest));

    return dest;
#line 529 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_destroy(PARROT_INTERP, PMC *pmc)
{
#line 540 "./src/pmc/callcontext.pmc"

    INTVAL    num_positionals, returns_resize_threshold;
    Hash     *hash;
    void    **returns_values;

    if (!PMC_data(pmc))
        return;

    GETATTR_CallContext_hash(interp, pmc, hash);
    GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);
    GETATTR_CallContext_returns_values(interp, pmc, returns_values);
    GETATTR_CallContext_returns_resize_threshold(interp, pmc, returns_resize_threshold);

    if (num_positionals) {
        Pcc_cell *c;

        GETATTR_CallContext_positionals(interp, pmc, c);

        while (c) {
            Pcc_cell *to_free = c;
            c = NEXT_CELL(c);
            FREE_CELL(interp, to_free);
        }
    }

    if (hash) {
        UINTVAL i;

        for (i = 0; i <= hash->mask; i++) {
            HashBucket *b = hash->bi[i];

            while (b) {
                FREE_CELL(interp, (Pcc_cell *)b->value);
                b = b->next;
            }
        }

        parrot_hash_destroy(interp, hash);
    }

    /* Destroy returns storage */
    if (returns_values) {
        if (returns_resize_threshold == 8)
            Parrot_gc_free_fixed_size_storage(interp,
                8 * sizeof (void *), returns_values);
        else
            mem_gc_free(interp, returns_values);
    }

    Parrot_pcc_free_registers(interp, pmc);
#line 585 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_elements(PARROT_INTERP, PMC *pmc)
{
#line 884 "./src/pmc/callcontext.pmc"

    INTVAL num_positionals;

    if (!PMC_data(pmc))
        return 0;

    GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);

    return num_positionals;
#line 600 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1368 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k = hash_key_from_pmc(interp, hash, key);
        return parrot_hash_exists(interp, hash, k);
    }

    return 0;
#line 615 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1390 "./src/pmc/callcontext.pmc"

    INTVAL num_positionals;

    GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);

    if (num_positionals)
        return key < num_positionals;

    return 0;
#line 630 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 1379 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k = hash_key_from_string(interp, hash, key);
        return parrot_hash_exists(interp, hash, k);
    }

    return 0;
#line 645 "./src/pmc/callcontext.c"
}
static  PMC  *
Parrot_CallContext_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 837 "./src/pmc/callcontext.pmc"

    PMC    *value = PMCNULL;
    INTVAL  hll;

    if (Parrot_str_equal(interp, key, CONST_STRING(interp, "named")))
        value = get_named_names(interp, pmc);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "arg_flags")))
        GETATTR_CallContext_arg_flags(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "return_flags")))
        GETATTR_CallContext_return_flags(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "caller_ctx")))
        GETATTR_CallContext_caller_ctx(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "lex_pad")))
        GETATTR_CallContext_lex_pad(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "outer_ctx")))
        GETATTR_CallContext_outer_ctx(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "current_sub")))
        GETATTR_CallContext_current_sub(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "current_cont")))
        GETATTR_CallContext_current_cont(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "current_object")))
        GETATTR_CallContext_current_object(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "current_namespace")))
        GETATTR_CallContext_current_namespace(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "handlers")))
        GETATTR_CallContext_handlers(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "results_signature")))
        GETATTR_CallContext_results_signature(interp, pmc, value);
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "current_HLL"))) {
        /* This function from src/hash.c. */
        /* We probably have to move it to more suitable place */
        GETATTR_CallContext_current_HLL(interp, pmc, hll);
        value = get_integer_pmc(interp, hll);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "current_hll"))) {
        GETATTR_CallContext_current_HLL(interp, pmc, hll);
        value = get_string_pmc(interp, Parrot_get_HLL_name(interp, hll));
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such attribute '%S'", key);
    }

    return value;
#line 696 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1312 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k    = hash_key_from_pmc(interp, hash, key);
        Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

        if (cell)
            return autobox_intval(interp, cell);
    }

    return 0;
#line 714 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 967 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = get_cell_at(interp, pmc, key);

    if (!cell)
        return 0;

    return autobox_intval(interp, cell);
#line 727 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 1255 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k    = hash_key_from_string(interp, hash, key);
        Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

        if (cell)
            return autobox_intval(interp, cell);
    }

    return 0;
#line 745 "./src/pmc/callcontext.c"
}
static  FLOATVAL 
Parrot_CallContext_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1326 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k    = hash_key_from_pmc(interp, hash, key);
        Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

        if (cell)
            return autobox_floatval(interp, cell);
    }

    return 0.0;
#line 763 "./src/pmc/callcontext.c"
}
static  FLOATVAL 
Parrot_CallContext_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 976 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = get_cell_at(interp, pmc, key);

    if (!cell)
        return 0.0;

    return autobox_floatval(interp, cell);
#line 776 "./src/pmc/callcontext.c"
}
static  FLOATVAL 
Parrot_CallContext_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 1269 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k    = hash_key_from_string(interp, hash, key);
        Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

        if (cell)
            return autobox_floatval(interp, cell);
    }

    return 0.0;
#line 794 "./src/pmc/callcontext.c"
}
static  PMC  *
Parrot_CallContext_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 684 "./src/pmc/callcontext.pmc"

    PMC *type_tuple;

    GETATTR_CallContext_type_tuple(interp, pmc, type_tuple);

    if (PMC_IS_NULL(type_tuple)) {
        Pcc_cell *c;
        INTVAL    num_positionals;
        INTVAL    i = 0;

        GETATTR_CallContext_positionals(interp, pmc, c);
        GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);

        type_tuple = Parrot_pmc_new_init_int(interp,
            enum_class_FixedIntegerArray, num_positionals);

        while (c) {
            INTVAL type;

            switch (CELL_TYPE_MASK(c)) {
                case INTCELL:    type = enum_type_INTVAL;   break;
                case FLOATCELL:  type = enum_type_FLOATVAL; break;
                case STRINGCELL: type = enum_type_STRING;   break;
                case PMCCELL:
                    type = PMC_IS_NULL(CELL_PMC(c))
                         ? enum_type_PMC
                         : VTABLE_type(interp, CELL_PMC(c));
                    break;
                default:
                    Parrot_ex_throw_from_c_args(interp, NULL,
                        EXCEPTION_INVALID_OPERATION,
                        "Multiple Dispatch: invalid argument type!");
            }

            VTABLE_set_integer_keyed_int(interp, type_tuple, i, type);
            i++;
            c = NEXT_CELL(c);
        }

        SETATTR_CallContext_type_tuple(interp, pmc, type_tuple);
    }

    return type_tuple;
#line 843 "./src/pmc/callcontext.c"
}
static  PMC * 
Parrot_CallContext_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1354 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k    = hash_key_from_pmc(interp, hash, key);
        Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

        if (cell)
            return autobox_pmc(interp, cell);
    }

    return PMCNULL;
#line 861 "./src/pmc/callcontext.c"
}
static  PMC * 
Parrot_CallContext_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 994 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = get_cell_at(interp, pmc, key);

    if (!cell)
        return PMCNULL;

    return autobox_pmc(interp, cell);
#line 874 "./src/pmc/callcontext.c"
}
static  PMC * 
Parrot_CallContext_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 1298 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k    = hash_key_from_string(interp, hash, key);
        Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

        if (cell)
            return autobox_pmc(interp, cell);
    }

    return PMCNULL;
#line 892 "./src/pmc/callcontext.c"
}
static  STRING  *
Parrot_CallContext_get_string(PARROT_INTERP, PMC *pmc)
{
#line 616 "./src/pmc/callcontext.pmc"

    INTVAL    num_positionals;
    STRING   *res;
    Pcc_cell *c;

    GETATTR_CallContext_short_sig(interp, pmc, res);

    if (res)
        return res;

    GETATTR_CallContext_positionals(interp, pmc, c);
    GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);

    res = Parrot_str_new(interp, NULL, num_positionals);

    while (c) {
        switch (CELL_TYPE_MASK(c)) {
          case INTCELL:
            res = Parrot_str_append(interp, res, CONST_STRING(interp, "I"));
            break;
          case FLOATCELL:
            res = Parrot_str_append(interp, res, CONST_STRING(interp, "N"));
            break;
          case STRINGCELL:
            res = Parrot_str_append(interp, res, CONST_STRING(interp, "S"));
            break;
          case PMCCELL:
            res = Parrot_str_append(interp, res, CONST_STRING(interp, "P"));
            break;
          default:
            PARROT_FAILURE("Impossible flag");
            break;
        }
        c = NEXT_CELL(c);
    }
    /* TODO Add named args to signature */
    /* After fixind build_MMD_type_tuple to use raw arguments instead of signature */

    SETATTR_CallContext_short_sig(interp, pmc, res);

    return res;
#line 939 "./src/pmc/callcontext.c"
}
static  STRING * 
Parrot_CallContext_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1340 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k    = hash_key_from_pmc(interp, hash, key);
        Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

        if (cell)
            return autobox_string(interp, cell);
    }

    return NULL;
#line 957 "./src/pmc/callcontext.c"
}
static  STRING * 
Parrot_CallContext_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 985 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = get_cell_at(interp, pmc, key);

    if (!cell)
        return NULL;

    return autobox_string(interp, cell);
#line 970 "./src/pmc/callcontext.c"
}
static  STRING * 
Parrot_CallContext_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 1284 "./src/pmc/callcontext.pmc"

    Hash *hash = get_hash(interp, pmc);

    if (hash) {
        void     *k    = hash_key_from_string(interp, hash, key);
        Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

        if (cell)
            return autobox_string(interp, cell);
    }

    return NULL;
#line 988 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_init(PARROT_INTERP, PMC *pmc)
{
#line 436 "./src/pmc/callcontext.pmc"

    SETATTR_CallContext_type_tuple(interp, pmc, PMCNULL);

    SETATTR_CallContext_positionals(interp, pmc, NULL);
    SETATTR_CallContext_returns_values(interp, pmc, NULL);

    SETATTR_CallContext_returns_size(interp, pmc, 0);
    SETATTR_CallContext_num_positionals(interp, pmc, 0);
    SETATTR_CallContext_returns_resize_threshold(interp, pmc, 0);

    PObj_custom_mark_destroy_SETALL(pmc);
#line 1005 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_mark(PARROT_INTERP, PMC *pmc)
{
#line 458 "./src/pmc/callcontext.pmc"

    Hash     *hash;
    STRING   *short_sig;
    Pcc_cell *positionals;
    INTVAL    num_positionals;
    PMC      *arg_flags, *type_tuple, *return_flags, *tmp;
    UINTVAL   i;
    UINTVAL  *n_regs_used;
    Regs_ps   bp_ps;

    if (!PMC_data(pmc))
        return;

    GETATTR_CallContext_type_tuple(interp, pmc, type_tuple);
    GETATTR_CallContext_short_sig(interp, pmc, short_sig);
    GETATTR_CallContext_arg_flags(interp, pmc, arg_flags);
    GETATTR_CallContext_return_flags(interp, pmc, return_flags);
    GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);
    GETATTR_CallContext_positionals(interp, pmc, positionals);
    GETATTR_CallContext_hash(interp, pmc, hash);

    Parrot_gc_mark_PMC_alive(interp, type_tuple);
    Parrot_gc_mark_STRING_alive(interp, short_sig);
    Parrot_gc_mark_PMC_alive(interp, arg_flags);
    Parrot_gc_mark_PMC_alive(interp, return_flags);

    if (num_positionals)
        mark_positionals(interp, positionals);

    if (hash)
        mark_hash(interp, hash);

    GETATTR_CallContext_caller_ctx(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_lex_pad(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_outer_ctx(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_current_sub(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_handlers(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_current_cont(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_current_object(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_current_namespace(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_results_signature(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_current_sig(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_CallContext_n_regs_used(interp, pmc, n_regs_used);
    if (!n_regs_used)
        return;

    GETATTR_CallContext_bp_ps(interp, pmc, bp_ps);
    for (i = 0; i < n_regs_used[REGNO_PMC]; ++i) {
        PMC *p = bp_ps.regs_p[-1L-(i)];
        /* Original code from CTX_REG_PMC */
        if (p)
            Parrot_gc_mark_PMC_alive(interp, p);
    }

    for (i = 0; i < n_regs_used[REGNO_STR]; ++i) {
        STRING *s = bp_ps.regs_s[i];
        if (s)
            Parrot_gc_mark_STRING_alive(interp, s);
    }

#line 1091 "./src/pmc/callcontext.c"
}
static  FLOATVAL 
Parrot_CallContext_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 931 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = pop_cell(interp, pmc);

    if (cell) {
        FLOATVAL result = autobox_floatval(interp, cell);
        FREE_CELL(interp, cell);
        return result;
    }

    return 0.0;
#line 1107 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 919 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = pop_cell(interp, pmc);

    if (cell) {
        INTVAL result = autobox_intval(interp, cell);
        FREE_CELL(interp, cell);
        return result;
    }

    return 0;
#line 1123 "./src/pmc/callcontext.c"
}
static  PMC * 
Parrot_CallContext_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 943 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = pop_cell(interp, pmc);

    if (cell) {
        PMC *result = autobox_pmc(interp, cell);
        FREE_CELL(interp, cell);
        return result;
    }

    return PMCNULL;
#line 1139 "./src/pmc/callcontext.c"
}
static  STRING * 
Parrot_CallContext_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 955 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = pop_cell(interp, pmc);

    if (cell) {
        STRING *result = autobox_string(interp, cell);
        FREE_CELL(interp, cell);
        return result;
    }

    return NULL;
#line 1155 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 901 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = CREATE_FLOATVAL_CELL(interp);
    APPEND_CELL(interp, pmc, cell);
    CELL_FLOAT(cell) = value;
#line 1165 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 895 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = CREATE_INTVAL_CELL(interp);
    APPEND_CELL(interp, pmc, cell);
    CELL_INT(cell) = value;
#line 1175 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 913 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = CREATE_PMC_CELL(interp);
    APPEND_CELL(interp, pmc, cell);
    CELL_PMC(cell) = value;
#line 1185 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 907 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = CREATE_STRING_CELL(interp);
    APPEND_CELL(interp, pmc, cell);
    CELL_STRING(cell) = value;
#line 1195 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 758 "./src/pmc/callcontext.pmc"


    if (Parrot_str_equal(interp, key, CONST_STRING(interp, "arg_flags"))) {
        SETATTR_CallContext_arg_flags(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "return_flags"))) {
        SETATTR_CallContext_return_flags(interp, pmc, value);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such attribute '%S'", key);
    }
#line 1214 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 1199 "./src/pmc/callcontext.pmc"

    Hash     *hash = get_hash(interp, pmc);
    void     *k    = hash_key_from_pmc(interp, hash, key);
    Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

    if (!cell) {
        cell = CREATE_INTVAL_CELL(interp);
        parrot_hash_put(interp, hash, k, (void *)cell);
        NEXT_CELL(cell) = NULL;
    }

    CELL_INT(cell) = value;
#line 1232 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 1075 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = get_cell_at(interp, pmc, key);

    if (!cell) {
        INTVAL num_positionals;

        GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);

        if (key == num_positionals)
            VTABLE_push_integer(interp, pmc, value);

        /* XXX: else throw exception? */
        return;
    }

    CELL_INT(cell) = value;
#line 1254 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
#line 1147 "./src/pmc/callcontext.pmc"

    Hash     *hash = get_hash(interp, pmc);
    Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, (void *)key);

    if (!cell) {
        cell = CREATE_INTVAL_CELL(interp);
        parrot_hash_put(interp, hash, (void *)key, (void *)cell);
        NEXT_CELL(cell) = NULL;
    }

    CELL_INT(cell) = value;
#line 1271 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 1213 "./src/pmc/callcontext.pmc"

    Hash     *hash = get_hash(interp, pmc);
    void     *k    = hash_key_from_pmc(interp, hash, key);
    Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

    if (!cell) {
        cell = CREATE_FLOATVAL_CELL(interp);
        parrot_hash_put(interp, hash, k, (void *)cell);
        NEXT_CELL(cell) = NULL;
    }

    CELL_FLOAT(cell) = value;
#line 1289 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 1093 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = get_cell_at(interp, pmc, key);

    if (!cell) {
        INTVAL num_positionals;

        GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);

        if (key == num_positionals)
            VTABLE_push_float(interp, pmc, value);

        /* XXX: else throw exception? */
        return;
    }

    CELL_FLOAT(cell) = value;
#line 1311 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
#line 1160 "./src/pmc/callcontext.pmc"

    Hash     *hash = get_hash(interp, pmc);
    Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, (void *)key);

    if (!cell) {
        cell = CREATE_FLOATVAL_CELL(interp);
        parrot_hash_put(interp, hash, (void *)key, (void *)cell);
        NEXT_CELL(cell) = NULL;
    }

    CELL_FLOAT(cell) = value;
#line 1328 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 669 "./src/pmc/callcontext.pmc"

    SETATTR_CallContext_type_tuple(interp, pmc, value);
#line 1336 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 1241 "./src/pmc/callcontext.pmc"

    Hash     *hash = get_hash(interp, pmc);
    void     *k    = hash_key_from_pmc(interp, hash, key);
    Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

    if (!cell) {
        cell = CREATE_PMC_CELL(interp);
        parrot_hash_put(interp, hash, k, (void *)cell);
        NEXT_CELL(cell) = NULL;
    }

    CELL_PMC(cell) = value;
#line 1354 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
#line 1129 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = get_cell_at(interp, pmc, key);

    if (!cell) {
        INTVAL num_positionals;

        GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);

        if (key == num_positionals)
            VTABLE_push_pmc(interp, pmc, value);

        /* XXX: else throw exception? */
        return;
    }

    CELL_PMC(cell) = value;
#line 1376 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 1186 "./src/pmc/callcontext.pmc"

    Hash     *hash = get_hash(interp, pmc);
    Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, (void *)key);

    if (!cell) {
        cell = CREATE_PMC_CELL(interp);
        parrot_hash_put(interp, hash, (void *)key, (void *)cell);
        NEXT_CELL(cell) = NULL;
    }

    CELL_PMC(cell) = value;
#line 1393 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 1227 "./src/pmc/callcontext.pmc"

    Hash     *hash = get_hash(interp, pmc);
    void     *k    = hash_key_from_pmc(interp, hash, key);
    Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, k);

    if (!cell) {
        cell = CREATE_STRING_CELL(interp);
        parrot_hash_put(interp, hash, k, (void *)cell);
        NEXT_CELL(cell) = NULL;
    }

    CELL_STRING(cell) = value;
#line 1411 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 1111 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = get_cell_at(interp, pmc, key);

    if (!cell) {
        INTVAL num_positionals;

        GETATTR_CallContext_num_positionals(interp, pmc, num_positionals);

        if (key == num_positionals)
            VTABLE_push_string(interp, pmc, value);

        /* XXX: else throw exception? */
        return;
    }

    CELL_STRING(cell) = value;
#line 1433 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
#line 1173 "./src/pmc/callcontext.pmc"

    Hash     *hash = get_hash(interp, pmc);
    Pcc_cell *cell = (Pcc_cell *)parrot_hash_get(interp, hash, (void *)key);

    if (!cell) {
        cell = CREATE_STRING_CELL(interp);
        parrot_hash_put(interp, hash, (void *)key, (void *)cell);
        NEXT_CELL(cell) = NULL;
    }

    CELL_STRING(cell) = value;
#line 1450 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 602 "./src/pmc/callcontext.pmc"

    SETATTR_CallContext_short_sig(interp, pmc, value);
#line 1458 "./src/pmc/callcontext.c"
}
static  FLOATVAL 
Parrot_CallContext_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 1039 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = shift_cell(interp, pmc);

    if (cell) {
        FLOATVAL result = autobox_floatval(interp, cell);
        FREE_CELL(interp, cell);
        return result;
    }

    return 0.0;
#line 1474 "./src/pmc/callcontext.c"
}
static  INTVAL 
Parrot_CallContext_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 1027 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = shift_cell(interp, pmc);

    if (cell) {
        INTVAL result = autobox_intval(interp, cell);
        FREE_CELL(interp, cell);
        return result;
    }

    return 0;
#line 1490 "./src/pmc/callcontext.c"
}
static  PMC * 
Parrot_CallContext_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 1063 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = shift_cell(interp, pmc);

    if (cell) {
        PMC *result = autobox_pmc(interp, cell);
        FREE_CELL(interp, cell);
        return result;
    }

    return PMCNULL;
#line 1506 "./src/pmc/callcontext.c"
}
static  STRING * 
Parrot_CallContext_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 1051 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = shift_cell(interp, pmc);

    if (cell) {
        STRING *result = autobox_string(interp, cell);
        FREE_CELL(interp, cell);
        return result;
    }

    return NULL;
#line 1522 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1009 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = CREATE_FLOATVAL_CELL(interp);
    PREPEND_CELL(interp, pmc, cell);
    CELL_FLOAT(cell) = value;
#line 1532 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1003 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = CREATE_INTVAL_CELL(interp);
    PREPEND_CELL(interp, pmc, cell);
    CELL_INT(cell) = value;
#line 1542 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1021 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = CREATE_PMC_CELL(interp);
    PREPEND_CELL(interp, pmc, cell);
    CELL_PMC(cell) = value;
#line 1552 "./src/pmc/callcontext.c"
}
static  void 
Parrot_CallContext_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 1015 "./src/pmc/callcontext.pmc"

    Pcc_cell *cell = CREATE_STRING_CELL(interp);
    PREPEND_CELL(interp, pmc, cell);
    CELL_STRING(cell) = value;
#line 1562 "./src/pmc/callcontext.c"
}
static  void
Parrot_CallContext_nci_backtrace(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1575 "./src/pmc/callcontext.pmc"
PMC* pmc;
PMC* resume;
INTVAL has_resume;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPoIp",
            &pmc, &resume, &has_resume);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1495 "./src/pmc/callcontext.pmc"

    PMC *result  = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    PMC *cur_ctx = pmc;
    Parrot_Continuation_attributes *cont = has_resume ? PMC_cont(resume) : NULL;

    /* Get starting context, then loop over them. */
    while (cur_ctx) {
        PMC        *frame       = Parrot_pmc_new(interp, enum_class_Hash);
        PMC        *annotations = NULL;
        Parrot_Sub_attributes *sub;

        /* Get sub and put it in the hash. */
        PMC *sub_pmc = Parrot_pcc_get_sub(interp, cur_ctx);

        if (!sub_pmc)
            sub_pmc = PMCNULL;

        VTABLE_set_pmc_keyed_str(interp, frame, CONST_STRING(interp, "sub"), sub_pmc);

        /* Look up any annotations and put them in the hash. */
        if (!PMC_IS_NULL(sub_pmc)) {
            PMC_get_sub(interp, sub_pmc, sub);

            if (sub->seg->annotations) {
                PackFile_ByteCode *seg = sub->seg;
                opcode_t          *pc  = cont && cur_ctx == cont->to_ctx
                                         ? cont->address
                                         : Parrot_pcc_get_pc(interp, cur_ctx);

                annotations = PackFile_Annotations_lookup(interp,
                    seg->annotations, pc - seg->base.data,
                    NULL);
            }
        }

        if (!annotations)
            annotations = Parrot_pmc_new(interp, enum_class_Hash);

        VTABLE_set_pmc_keyed_str(interp, frame, CONST_STRING(interp, "annotations"), annotations);

        /* Push frame and go to next caller. */
        VTABLE_push_pmc(interp, result, frame);
        cur_ctx = Parrot_pcc_get_caller_ctx(interp, cur_ctx);
    }

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *result */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)result);
    return;
    /*END RETURN PMC *result */
    }
#line 1540 "./src/pmc/callcontext.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1647 "./src/pmc/callcontext.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_CallContext_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_CallContext_clone;
    vt->destroy = Parrot_CallContext_destroy;
    vt->elements = Parrot_CallContext_elements;
    vt->exists_keyed = Parrot_CallContext_exists_keyed;
    vt->exists_keyed_int = Parrot_CallContext_exists_keyed_int;
    vt->exists_keyed_str = Parrot_CallContext_exists_keyed_str;
    vt->get_attr_str = Parrot_CallContext_get_attr_str;
    vt->get_integer_keyed = Parrot_CallContext_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_CallContext_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_CallContext_get_integer_keyed_str;
    vt->get_number_keyed = Parrot_CallContext_get_number_keyed;
    vt->get_number_keyed_int = Parrot_CallContext_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_CallContext_get_number_keyed_str;
    vt->get_pmc = Parrot_CallContext_get_pmc;
    vt->get_pmc_keyed = Parrot_CallContext_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_CallContext_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_CallContext_get_pmc_keyed_str;
    vt->get_string = Parrot_CallContext_get_string;
    vt->get_string_keyed = Parrot_CallContext_get_string_keyed;
    vt->get_string_keyed_int = Parrot_CallContext_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_CallContext_get_string_keyed_str;
    vt->init = Parrot_CallContext_init;
    vt->mark = Parrot_CallContext_mark;
    vt->pop_float = Parrot_CallContext_pop_float;
    vt->pop_integer = Parrot_CallContext_pop_integer;
    vt->pop_pmc = Parrot_CallContext_pop_pmc;
    vt->pop_string = Parrot_CallContext_pop_string;
    vt->push_float = Parrot_CallContext_push_float;
    vt->push_integer = Parrot_CallContext_push_integer;
    vt->push_pmc = Parrot_CallContext_push_pmc;
    vt->push_string = Parrot_CallContext_push_string;
    vt->set_attr_str = Parrot_CallContext_set_attr_str;
    vt->set_integer_keyed = Parrot_CallContext_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_CallContext_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_CallContext_set_integer_keyed_str;
    vt->set_number_keyed = Parrot_CallContext_set_number_keyed;
    vt->set_number_keyed_int = Parrot_CallContext_set_number_keyed_int;
    vt->set_number_keyed_str = Parrot_CallContext_set_number_keyed_str;
    vt->set_pmc = Parrot_CallContext_set_pmc;
    vt->set_pmc_keyed = Parrot_CallContext_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_CallContext_set_pmc_keyed_int;
    vt->set_pmc_keyed_str = Parrot_CallContext_set_pmc_keyed_str;
    vt->set_string_keyed = Parrot_CallContext_set_string_keyed;
    vt->set_string_keyed_int = Parrot_CallContext_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_CallContext_set_string_keyed_str;
    vt->set_string_native = Parrot_CallContext_set_string_native;
    vt->shift_float = Parrot_CallContext_shift_float;
    vt->shift_integer = Parrot_CallContext_shift_integer;
    vt->shift_pmc = Parrot_CallContext_shift_pmc;
    vt->shift_string = Parrot_CallContext_shift_string;
    vt->unshift_float = Parrot_CallContext_unshift_float;
    vt->unshift_integer = Parrot_CallContext_unshift_integer;
    vt->unshift_pmc = Parrot_CallContext_unshift_pmc;
    vt->unshift_string = Parrot_CallContext_unshift_string;
    vt->attr_size = sizeof(Parrot_CallContext_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_CallContext_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_CallContext_clone;
    vt->destroy = Parrot_CallContext_destroy;
    vt->elements = Parrot_CallContext_elements;
    vt->exists_keyed = Parrot_CallContext_exists_keyed;
    vt->exists_keyed_int = Parrot_CallContext_exists_keyed_int;
    vt->exists_keyed_str = Parrot_CallContext_exists_keyed_str;
    vt->get_attr_str = Parrot_CallContext_get_attr_str;
    vt->get_integer_keyed = Parrot_CallContext_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_CallContext_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_CallContext_get_integer_keyed_str;
    vt->get_number_keyed = Parrot_CallContext_get_number_keyed;
    vt->get_number_keyed_int = Parrot_CallContext_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_CallContext_get_number_keyed_str;
    vt->get_pmc = Parrot_CallContext_get_pmc;
    vt->get_pmc_keyed = Parrot_CallContext_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_CallContext_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_CallContext_get_pmc_keyed_str;
    vt->get_string = Parrot_CallContext_get_string;
    vt->get_string_keyed = Parrot_CallContext_get_string_keyed;
    vt->get_string_keyed_int = Parrot_CallContext_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_CallContext_get_string_keyed_str;
    vt->init = Parrot_CallContext_init;
    vt->mark = Parrot_CallContext_mark;
    vt->attr_size = sizeof(Parrot_CallContext_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_CallContext_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_CallContext_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_CallContext_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_CallContext_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_CallContext_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "CallContext", 11, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_CallContext_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "CallContext")), PMCNULL);
    return isa;
}

void
Parrot_CallContext_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fcaller_ctx :registers :bp :bp_ps :n_regs_used Flex_pad Fouter_ctx Fcurrent_sub Fhandlers Fcurrent_cont Fcurrent_object Fcurrent_namespace Fresults_signature :current_pc Fcurrent_sig :constants Icurrent_HLL :warns :errors :trace_flags :recursion_depth :pred_offset :positionals Ftype_tuple Sshort_sig Farg_flags Freturn_flags :hash Inum_positionals :returns_values Ireturns_size Ireturns_resize_threshold ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_CallContext_get_vtable(interp);
        vt->base_type      = enum_class_CallContext;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "CallContext");
        vt->provides_str = CONST_STRING_GEN(interp, "array hash");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_CallContext_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_CallContext;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_CallContext_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_CallContext_nci_backtrace), CONST_STRING_GEN(interp, "backtrace"));
        {
        }
    } /* pass */
} /* Parrot_CallContext_class_init */
#line 1549 "./src/pmc/callcontext.pmc"
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
