/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/default.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_default.h"
#include "pmc_default.h"
#include "default.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/default.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: default.pmc 44190 2010-02-19 19:48:48Z whiteknight $

=head1 NAME

src/pmc/default.pmc - Abstract root class

=head1 DESCRIPTION

These are the vtable functions for the default PMC class.

All methods which are not defined here get a default implementation
generated from F<src/vtable.tbl> by F<tools/build/pmc2c.pl>.

=head2 Functions

=over 4

=cut

*/

#define INT2KEY(i, k) key_new_integer((i), (k))

/* undef 'interface' to keep MSVC happy */
#undef interface

/*

=item C<static STRING *caller(PARROT_INTERP, PMC *pmc)>

Returns a C string for the name of C<*pmc>.

=cut

*/

static STRING *
caller(PARROT_INTERP, PMC *pmc /*NULLOK*/)
{
    STRING * const null_str = CONST_STRING(interp, "(null)");

    return pmc && pmc->vtable && pmc->vtable->whoami
                ? VTABLE_name(interp, pmc) : null_str;
}

/*

=item C<static void cant_do_method(PARROT_INTERP, PMC *pmc,
                                   int index)>

Throws an exception "$methname() not implemented in class '$class'", used by
all unimplemented messages.

=cut

*/

PARROT_DOES_NOT_RETURN
static void
cant_do_method(PARROT_INTERP, PMC *pmc /*NULLOK*/, int index)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ILL_INHERIT,
            "%s() not implemented in class '%Ss'",
            Parrot_get_vtable_name(interp, index),
            caller(interp, pmc));
}


/*

=item C<static void cant_do_write_method(PARROT_INTERP, PMC *pmc,
                                   int index)>

Throws an exception "$methname() on read-only instance of '$class'", used by
all updating messages on read-only instances.

=cut

*/

PARROT_DOES_NOT_RETURN
static void
cant_do_write_method(PARROT_INTERP, PMC *pmc /*NULLOK*/, int index)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "%s() in read-only instance of '%Ss'",
            Parrot_get_vtable_name(interp, index),
            caller(interp, pmc));
}

/*

=item C<static INTVAL
check_set_std_props(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)>

Called from C<setprop()>.

Returns a true value if C<setprop()> can avoid actually setting a property
in the prophash. If it returns true, the property setting will be reflected
in a future call to C<propagate_std_props()>

=cut

*/

static INTVAL
check_set_std_props(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    /*
     * s2 in Parrot_str_equal is freed here
     */
    if (Parrot_str_equal(interp, key, CONST_STRING(interp, "_ro"))) {
        /* pmc should set/clear readonly */
        const INTVAL on = VTABLE_get_bool(interp, value);

        /* morph to Const/normal class or readonly class */
        if (on && (pmc->vtable->flags & VTABLE_HAS_CONST_TOO))
            pmc->vtable = interp->vtables[pmc->vtable->base_type + 1];
        else if (!on && (pmc->vtable->flags & (VTABLE_IS_CONST_FLAG)))
            VTABLE_morph(interp, pmc, interp->vtables[pmc->vtable->base_type - 1]->pmc_class);
        else if (on && (pmc->vtable->flags & VTABLE_HAS_READONLY_FLAG))
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else if (!on && (pmc->vtable->flags & VTABLE_IS_READONLY_FLAG)
                && pmc->vtable->ro_variant_vtable)
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else
            return 0;

        return 1;
    }

    return 0;
}

/*

=item C<static void
propagate_std_props(PARROT_INTERP, PMC *self, PMC *prop_hash)>

Set pending standard properties in C<prop_hash>.

=cut

*/

static void
propagate_std_props(PARROT_INTERP, PMC *self, PMC *prop_hash) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG)){
        PMC * const pmc_true  = Parrot_pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, pmc_true, 1);
        VTABLE_set_pmc_keyed_str(interp, prop_hash, CONST_STRING(interp, "_ro"), pmc_true);
    }
}

/*

=item C<static INTVAL
has_pending_std_props(ARGIN(const PMC *self))>

Returns true if propagate_std_props() would create a non-empty prophash.

=cut

*/

static INTVAL
has_pending_std_props(ARGIN(const PMC *self)) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
        return 1;
    else
        return 0;
}


/*

=item C<static PMC*
check_get_std_props(PARROT_INTERPeter, PMC *self, STRING *key)>

Checks if we can infer the value of C<key> property from C<self> without
looking at its prophash. Returns C<PMCNULL> if not, returns the value otherwise.

=cut
*/

static PMC*
check_get_std_props(PARROT_INTERP, PMC *self, STRING *key) {
    if ((self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
       && Parrot_str_equal(interp, key, CONST_STRING(interp, "_ro"))) {
        PMC * const ret_val  = Parrot_pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, ret_val, 1);
        return ret_val;
    }
    else
        return PMCNULL;
}

/*

=item C<static PMC *
make_prop_hash(PARROT_INTERP, PMC *self)>

Create a property hash for C<self>. Returns the created hash. Inferred
properties will be added to the hash and it will be set as
C<PMC_metadata(self)>.

=cut

*/

static PMC*
make_prop_hash(PARROT_INTERP, PMC *self) {
    PMC *prop;

    PMC_metadata(self) = prop = Parrot_pmc_new(interp, enum_class_Hash);
    propagate_std_props(interp, self, prop);
    return prop;
}

/*

=item C<static INTVAL
does_isa(PARROT_INTERP, STRING *method, STRING *what)>

Compares C<*method> and C<*what>.
Returns true (1) if B<method> is found in B<what>, false (0) otherwise.

=cut

*/

static INTVAL
does_isa(PARROT_INTERP, const STRING *method, const STRING *what)
{
    INTVAL  pos    = 0;
    INTVAL  length = Parrot_str_byte_length(interp, what);

    do {
        INTVAL len;
        INTVAL idx = Parrot_str_find_index(interp, what, method, (INTVAL)pos);

        if (idx < 0)
            return 0;

        pos = idx;

        if (pos >= length)
            return 0;

        len = Parrot_str_byte_length(interp, method);

        if (pos && Parrot_str_indexed(interp, what, pos - 1) != 32) {
            pos += len;
            continue;
        }

        if (pos + len < length && Parrot_str_indexed(interp, what, pos + len) != 32) {
            pos += len;
            continue;
        }

        return 1;
    } while (1);
}
#line 289 "./src/pmc/default.c"
static  PMC * Parrot_default_absolute(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC  * Parrot_default_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void Parrot_default_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type);
static  PMC  * Parrot_default_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc);
static  void  Parrot_default_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent);
static  void Parrot_default_add_role(PARROT_INTERP, PMC *pmc, PMC *role);
static  void Parrot_default_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc);
static  void  Parrot_default_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  INTVAL  Parrot_default_can(PARROT_INTERP, PMC *pmc, STRING *method);
static  PMC*  Parrot_default_clone(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args);
static  INTVAL  Parrot_default_cmp(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_default_cmp_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_default_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  void Parrot_default_decrement(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_default_defined(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_default_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_default_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void Parrot_default_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_default_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void Parrot_default_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_default_delprop(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_default_destroy(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  INTVAL  Parrot_default_does(PARROT_INTERP, PMC *pmc, STRING *_interface);
static  INTVAL  Parrot_default_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role);
static  INTVAL Parrot_default_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_default_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_default_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_default_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name);
static  PMC  * Parrot_default_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_freeze(PARROT_INTERP, PMC *pmc, PMC *info);
static  PMC  * Parrot_default_get_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name);
static  PMC * Parrot_default_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx);
static  INTVAL Parrot_default_get_bool(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_get_class(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_default_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_default_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC * Parrot_default_get_iter(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_get_namespace(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_default_get_number(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_default_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_default_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  FLOATVAL Parrot_default_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC * Parrot_default_get_pmc(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_default_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC * Parrot_default_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  * Parrot_default_get_pointer(PARROT_INTERP, PMC *pmc);
static  void * Parrot_default_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void * Parrot_default_get_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void * Parrot_default_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING * Parrot_default_get_repr(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_default_get_string(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_default_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_default_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  STRING * Parrot_default_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_default_getprop(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_default_getprops(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_default_hashvalue(PARROT_INTERP, PMC *pmc);
static  void Parrot_default_i_absolute(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_i_add(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_default_i_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_i_logical_not(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_i_neg(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_init(PARROT_INTERP, PMC *pmc);
static  void Parrot_default_init_int(PARROT_INTERP, PMC *pmc, INTVAL initializer);
static  void  Parrot_default_init_pmc(PARROT_INTERP, PMC *pmc, PMC *initializer);
static  PMC  * Parrot_default_inspect(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_inspect_str(PARROT_INTERP, PMC *pmc, STRING *name);
static  PMC  * Parrot_default_instantiate(PARROT_INTERP, PMC *pmc, PMC *init);
static  opcode_t * Parrot_default_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  INTVAL  Parrot_default_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_is_same(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_isa(PARROT_INTERP, PMC *pmc, STRING *_class);
static  INTVAL  Parrot_default_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup);
static  PMC  * Parrot_default_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_default_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC  * Parrot_default_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_default_mark(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_morph(PARROT_INTERP, PMC *pmc, PMC *type);
static  PMC  * Parrot_default_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  STRING  * Parrot_default_name(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_neg(PARROT_INTERP, PMC *pmc, PMC *dest);
static  FLOATVAL Parrot_default_pop_float(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_pop_integer(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_pop_pmc(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_default_pop_string(PARROT_INTERP, PMC *pmc);
static  void Parrot_default_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_default_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_default_push_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_default_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name);
static  void Parrot_default_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name);
static  void Parrot_default_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent);
static  void Parrot_default_remove_role(PARROT_INTERP, PMC *pmc, PMC *role);
static  void Parrot_default_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name);
static  PMC  * Parrot_default_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name, PMC *value);
static  void Parrot_default_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value);
static  void Parrot_default_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void  Parrot_default_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void Parrot_default_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value);
static  void Parrot_default_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void  Parrot_default_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value);
static  void Parrot_default_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value);
static  void Parrot_default_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_default_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_default_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_default_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value);
static  void Parrot_default_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void Parrot_default_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void Parrot_default_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value);
static  void Parrot_default_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value);
static  void Parrot_default_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value);
static  void Parrot_default_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void  Parrot_default_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *string);
static  void Parrot_default_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  void Parrot_default_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_default_setprop(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void Parrot_default_share(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_share_ro(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_default_shift_float(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_shift_integer(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_default_shift_string(PARROT_INTERP, PMC *pmc);
static  void Parrot_default_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count);
static  void Parrot_default_substr(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length, PMC *dest);
static  STRING * Parrot_default_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length);
static  PMC  * Parrot_default_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_thaw(PARROT_INTERP, PMC *pmc, PMC *info);
static  void  Parrot_default_thawfinish(PARROT_INTERP, PMC *pmc, PMC *info);
static  INTVAL  Parrot_default_type(PARROT_INTERP, PMC *pmc);
static  void Parrot_default_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_default_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_default_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_default_visit(PARROT_INTERP, PMC *pmc, PMC *info);
void    Parrot_default_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_default_get_vtable(PARROT_INTERP);
static  PMC *
Parrot_default_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    UNUSED(dest)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_ABSOLUTE);
}
static  PMC  *
Parrot_default_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1126 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "add", "PPP->P", pmc, value, dest, &result);
    return result;
#line 493 "./src/pmc/default.c"
}
static  void
Parrot_default_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    UNUSED(name)
    UNUSED(type)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_ADD_ATTRIBUTE);
}
static  PMC  *
Parrot_default_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1160 "./src/pmc/default.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + value);
    return dest;
#line 512 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1143 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "add_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 523 "./src/pmc/default.c"
}
static  void 
Parrot_default_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
#line 501 "./src/pmc/default.pmc"

    VTABLE_set_pmc_keyed_str(interp, pmc->vtable->_namespace,
                             method_name, sub_pmc);
#line 532 "./src/pmc/default.c"
}
static  void 
Parrot_default_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 1034 "./src/pmc/default.pmc"

    UNUSED(parent)
    if (!PObj_is_class_TEST(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "Only classes can be subclassed");

    Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "All classes should override add_parent");
#line 546 "./src/pmc/default.c"
}
static  void
Parrot_default_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    UNUSED(role)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_ADD_ROLE);
}
static  void
Parrot_default_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    UNUSED(vtable_name)
    UNUSED(sub_pmc)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_ADD_VTABLE_OVERRIDE);
}
static  void 
Parrot_default_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 611 "./src/pmc/default.pmc"

    STRING * const undef = CONST_STRING(interp, "Undef");

    if (VTABLE_isa(interp, value, undef))
        Parrot_pmc_reuse(interp, pmc, value->vtable->base_type, 0);
    else
        VTABLE_set_pmc(interp, pmc, value);
#line 572 "./src/pmc/default.c"
}
static  void 
Parrot_default_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 620 "./src/pmc/default.pmc"

    VTABLE_set_string_native(interp, pmc, value);
#line 580 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_can(PARROT_INTERP, PMC *pmc, STRING *method)
{
#line 844 "./src/pmc/default.pmc"

    return !PMC_IS_NULL(VTABLE_find_method(interp, pmc, method));
#line 588 "./src/pmc/default.c"
}
static  PMC* 
Parrot_default_clone(PARROT_INTERP, PMC *pmc)
{
#line 1067 "./src/pmc/default.pmc"

    return Parrot_thaw(interp, Parrot_freeze(interp, pmc));
#line 596 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
    UNUSED(args)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_CLONE_PMC);
}
static  INTVAL 
Parrot_default_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1703 "./src/pmc/default.pmc"

    INTVAL retval;

    /* Don't multidispatch if you've got two pointers to the same PMC. They
     * are equal. */
    if (pmc == value)
        return 0;

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp", "PP->I", pmc, value, &retval);

    return retval;
#line 620 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1727 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_num", "PP->I", pmc, value, &retval);

    return retval;
#line 632 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_cmp_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1763 "./src/pmc/default.pmc"

    PMC *retval;

    /* Don't multidispatch if you've got two pointers to the same PMC. They
     * are equal. */
    if (pmc == value)
        return 0;

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_pmc", "PP->P", pmc, value, &retval);

    return retval;
#line 650 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1745 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_string", "PP->I", pmc, value, &retval);

    return retval;
#line 662 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1837 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "concatenate", "PPP->P", pmc, value, dest, &result);
    return result;
#line 673 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 1854 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "concatenate_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 684 "./src/pmc/default.c"
}
static  void
Parrot_default_decrement(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_DECREMENT);
}
static  INTVAL 
Parrot_default_defined(PARROT_INTERP, PMC *pmc)
{
#line 797 "./src/pmc/default.pmc"

    return 1;
#line 697 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_DEFINED_KEYED);
}
static  INTVAL 
Parrot_default_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 812 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_defined_keyed(interp, pmc, r_key);
#line 712 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_DEFINED_KEYED_STR);
}
static  void
Parrot_default_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_DELETE_KEYED);
}
static  void 
Parrot_default_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 827 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_delete_keyed(interp, pmc, r_key);
#line 733 "./src/pmc/default.c"
}
static  void
Parrot_default_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_DELETE_KEYED_STR);
}
static  void 
Parrot_default_delprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 409 "./src/pmc/default.pmc"

    if (!PMC_IS_NULL(PMC_metadata(pmc)))
        VTABLE_delete_keyed_str(interp, PMC_metadata(pmc), key);
#line 748 "./src/pmc/default.c"
}
static  void 
Parrot_default_destroy(PARROT_INTERP, PMC *pmc)
{
#line 318 "./src/pmc/default.pmc"

#line 755 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1415 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide", "PPP->P", pmc, value, dest, &result);
    return result;
#line 766 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1449 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 777 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1432 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 788 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_does(PARROT_INTERP, PMC *pmc, STRING *_interface)
{
#line 860 "./src/pmc/default.pmc"

    return does_isa(interp, _interface, pmc->vtable->provides_str);
#line 796 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 874 "./src/pmc/default.pmc"

    UNUSED(role)
    /* No C-level roles yet. */
    return 0;
#line 806 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_elements(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_ELEMENTS);
}
static  INTVAL
Parrot_default_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_EXISTS_KEYED);
}
static  INTVAL 
Parrot_default_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 782 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_exists_keyed(interp, pmc, r_key);
#line 826 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_EXISTS_KEYED_STR);
}
static  PMC  *
Parrot_default_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
#line 497 "./src/pmc/default.pmc"

    return Parrot_find_method_with_cache(interp, pmc, method_name);
#line 840 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1511 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide", "PPP->P", pmc, value, dest, &result);
    return result;
#line 851 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1545 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 862 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1528 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 873 "./src/pmc/default.c"
}
static  void 
Parrot_default_freeze(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 1081 "./src/pmc/default.pmc"

    UNUSED(info)
    /* default - no action */
#line 882 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_get_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name)
{
#line 1014 "./src/pmc/default.pmc"

    UNUSED(key)
    return VTABLE_get_attr_str(interp, pmc, name);
#line 891 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx)
{
    UNUSED(idx)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_ATTR_STR);
}
static  INTVAL
Parrot_default_get_bool(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_BOOL);
}
static  PMC  *
Parrot_default_get_class(PARROT_INTERP, PMC *pmc)
{
#line 981 "./src/pmc/default.pmc"

    PMC *ns     = VTABLE_get_namespace(interp, pmc);
    PMC *_class = PMCNULL;

    if (!PMC_IS_NULL(ns))
        _class = VTABLE_get_class(interp, ns);

    if (PMC_IS_NULL(_class)) {
        INTVAL type      = VTABLE_type(interp, pmc);
        PMC   *type_num  = Parrot_pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, type_num, type);
        return Parrot_pmc_new_init(interp, enum_class_PMCProxy, type_num);
    }

    return _class;

#line 924 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_get_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_INTEGER);
}
static  INTVAL
Parrot_default_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_INTEGER_KEYED);
}
static  INTVAL 
Parrot_default_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 516 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_integer_keyed(interp, pmc, r_key);
#line 944 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_INTEGER_KEYED_STR);
}
static  PMC *
Parrot_default_get_iter(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_ITER);
}
static  PMC  *
Parrot_default_get_namespace(PARROT_INTERP, PMC *pmc)
{
#line 483 "./src/pmc/default.pmc"


    /* Because singletons are shared between interpreters, we need to make
     * special effort to use the right namespace for method lookups.
     * Note that this trick won't work if the singleton inherits from
     * something else (because the MRO will still be shared).
     * Having this code here avoids creating a special case for singletons
     * elsewhere.
     */

    return interp->vtables[pmc->vtable->base_type]->_namespace;
#line 972 "./src/pmc/default.c"
}
static  FLOATVAL
Parrot_default_get_number(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_NUMBER);
}
static  FLOATVAL
Parrot_default_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_NUMBER_KEYED);
}
static  FLOATVAL 
Parrot_default_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 532 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_number_keyed(interp, pmc, r_key);
#line 992 "./src/pmc/default.c"
}
static  FLOATVAL
Parrot_default_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_NUMBER_KEYED_STR);
}
static  PMC *
Parrot_default_get_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_PMC);
}
static  PMC *
Parrot_default_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_PMC_KEYED);
}
static  PMC  *
Parrot_default_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 565 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_pmc_keyed(interp, pmc, r_key);
#line 1018 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_PMC_KEYED_STR);
}
static  void  *
Parrot_default_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 580 "./src/pmc/default.pmc"

    return pmc;
#line 1032 "./src/pmc/default.c"
}
static  void *
Parrot_default_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_POINTER_KEYED);
}
static  void *
Parrot_default_get_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_POINTER_KEYED_INT);
}
static  void *
Parrot_default_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_POINTER_KEYED_STR);
}
static  STRING *
Parrot_default_get_repr(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_REPR);
}
static  STRING *
Parrot_default_get_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_STRING);
}
static  STRING *
Parrot_default_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_STRING_KEYED);
}
static  STRING  *
Parrot_default_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 549 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_string_keyed(interp, pmc, r_key);
#line 1075 "./src/pmc/default.c"
}
static  STRING *
Parrot_default_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_GET_STRING_KEYED_STR);
}
static  PMC  *
Parrot_default_getprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 372 "./src/pmc/default.pmc"

    if (PMC_IS_NULL(PMC_metadata(pmc)))
        return check_get_std_props(interp, pmc, key);
    else
        return VTABLE_get_pmc_keyed_str(interp, PMC_metadata(pmc), key);
#line 1092 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_getprops(PARROT_INTERP, PMC *pmc)
{
#line 424 "./src/pmc/default.pmc"

    if (PMC_IS_NULL(PMC_metadata(pmc))) {
        if (has_pending_std_props(pmc))
            return make_prop_hash(interp, pmc);
        else
            return PMCNULL;
    }

    return PMC_metadata(pmc);
#line 1107 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_hashvalue(PARROT_INTERP, PMC *pmc)
{
#line 712 "./src/pmc/default.pmc"

    STRING *s = VTABLE_get_string(interp, pmc);
    return key_hash_STRING(interp, s, 0);
#line 1116 "./src/pmc/default.c"
}
static  void
Parrot_default_i_absolute(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_I_ABSOLUTE);
}
static  void 
Parrot_default_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1178 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add", "PP", pmc, value);
#line 1130 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1208 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add_float", "PN", pmc, value);
#line 1139 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1193 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add_int", "PI", pmc, value);
#line 1148 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1871 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_concatenate", "PP", pmc, value);
#line 1157 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 1886 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_concatenate_str", "PS", pmc, value);
#line 1166 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1466 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide", "PP", pmc, value);
#line 1175 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1496 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide_float", "PN", pmc, value);
#line 1184 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1481 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide_int", "PI", pmc, value);
#line 1193 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1562 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide", "PP", pmc, value);
#line 1202 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1592 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide_float", "PN", pmc, value);
#line 1211 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1577 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide_int", "PI", pmc, value);
#line 1220 "./src/pmc/default.c"
}
static  void
Parrot_default_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_I_LOGICAL_NOT);
}
static  void 
Parrot_default_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1658 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus", "PP", pmc, value);
#line 1234 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1688 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus_float", "PN", pmc, value);
#line 1243 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1673 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus_int", "PI", pmc, value);
#line 1252 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1370 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply", "PP", pmc, value);
#line 1261 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1400 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply_float", "PN", pmc, value);
#line 1270 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1385 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply_int", "PI", pmc, value);
#line 1279 "./src/pmc/default.c"
}
static  void
Parrot_default_i_neg(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_I_NEG);
}
static  void 
Parrot_default_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1935 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_repeat", "PP", pmc, value);
#line 1293 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1950 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_repeat_int", "PI", pmc, value);
#line 1302 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1274 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract", "PP", pmc, value);
#line 1311 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1304 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract_float", "PN", pmc, value);
#line 1320 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1289 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract_int", "PI", pmc, value);
#line 1329 "./src/pmc/default.c"
}
static  void
Parrot_default_increment(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_INCREMENT);
}
static  void 
Parrot_default_init(PARROT_INTERP, PMC *pmc)
{
#line 286 "./src/pmc/default.pmc"

#line 1341 "./src/pmc/default.c"
}
static  void
Parrot_default_init_int(PARROT_INTERP, PMC *pmc, INTVAL initializer)
{
    UNUSED(initializer)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_INIT_INT);
}
static  void 
Parrot_default_init_pmc(PARROT_INTERP, PMC *pmc, PMC *initializer)
{
#line 299 "./src/pmc/default.pmc"

    if (PMC_IS_NULL(initializer))
        VTABLE_init(interp, pmc);
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ILL_INHERIT,
            "init_pmc() not implemented in class '%Ss'",
            caller(interp, pmc));
#line 1360 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_inspect(PARROT_INTERP, PMC *pmc)
{
#line 962 "./src/pmc/default.pmc"

    PMC    *metadata           = Parrot_pmc_new(interp, enum_class_Hash);
    STRING * const flags_str   = CONST_STRING(interp, "flags");

    VTABLE_set_pmc_keyed_str(interp, metadata, flags_str,
        VTABLE_inspect_str(interp, pmc, flags_str));

    return metadata;
#line 1374 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_inspect_str(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 937 "./src/pmc/default.pmc"

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "flags"))) {
        PMC *found = Parrot_pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, found,
                (INTVAL)PObj_get_FLAGS(pmc));
        return found;
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "mro"))) {
        return VTABLE_clone(interp, pmc->vtable->mro);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unknown introspection value '%S'", name);
#line 1393 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_instantiate(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 332 "./src/pmc/default.pmc"

    const INTVAL type = VTABLE_type(interp, pmc);

    /* Ensure no looping, as Parrot_pmc_new calls the instantiate vtable entry for
     * classes. */
    if (PObj_is_class_TEST(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
                "All high-level classes should override instantiate");

    if (!PMC_IS_NULL(init))
        return Parrot_pmc_new_init(interp, type, init);

    return Parrot_pmc_new(interp, type);
#line 1412 "./src/pmc/default.c"
}
static  opcode_t *
Parrot_default_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
    UNUSED(next)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_INVOKE);
}
static  INTVAL 
Parrot_default_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 727 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal", "PP->I", pmc, value, &retval);

    return retval;
#line 1430 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 745 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal_num", "PP->I", pmc, value, &retval);

    return retval;
#line 1442 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 763 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal_string", "PP->I", pmc, value, &retval);

    return retval;
#line 1454 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_is_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 595 "./src/pmc/default.pmc"

    return pmc == value;
#line 1462 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_isa(PARROT_INTERP, PMC *pmc, STRING *_class)
{
#line 919 "./src/pmc/default.pmc"

    Hash * const isa_hash = pmc->vtable->isa_hash;
    if (!isa_hash)
        return Parrot_str_equal(interp, pmc->vtable->whoami, _class);

    return parrot_hash_exists(interp, isa_hash, (void *)_class);
#line 1474 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup)
{
#line 892 "./src/pmc/default.pmc"

    Hash   * const isa_hash = pmc->vtable->isa_hash;
    STRING *pmc_name;

    if (PMC_IS_NULL(lookup))
        return 0;

    pmc_name = VTABLE_get_string(interp, lookup);

    if (!isa_hash)
        return Parrot_str_equal(interp, pmc->vtable->whoami, pmc_name);

    return parrot_hash_exists(interp, isa_hash, (void *)pmc_name);
#line 1493 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1803 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_and", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1504 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    UNUSED(dest)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_LOGICAL_NOT);
}
static  PMC  *
Parrot_default_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1786 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_or", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1521 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1820 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_xor", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1532 "./src/pmc/default.c"
}
static  void 
Parrot_default_mark(PARROT_INTERP, PMC *pmc)
{
#line 357 "./src/pmc/default.pmc"

    PANIC(interp, "custom_mark flag set but no custom mark routine defined");
#line 1540 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1607 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1551 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1641 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 1562 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1624 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1573 "./src/pmc/default.c"
}
static  void 
Parrot_default_morph(PARROT_INTERP, PMC *pmc, PMC *type)
{
#line 634 "./src/pmc/default.pmc"

    Parrot_pmc_reuse(interp, pmc, VTABLE_get_integer(interp, type), 0);
#line 1581 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1319 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1592 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1353 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 1603 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1336 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1614 "./src/pmc/default.c"
}
static  STRING  *
Parrot_default_name(PARROT_INTERP, PMC *pmc)
{
#line 459 "./src/pmc/default.pmc"

    return pmc->vtable->whoami;
#line 1622 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    UNUSED(dest)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_NEG);
}
static  FLOATVAL
Parrot_default_pop_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_POP_FLOAT);
}
static  INTVAL
Parrot_default_pop_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_POP_INTEGER);
}
static  PMC *
Parrot_default_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_POP_PMC);
}
static  STRING *
Parrot_default_pop_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_POP_STRING);
}
static  void
Parrot_default_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_PUSH_FLOAT);
}
static  void
Parrot_default_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_PUSH_INTEGER);
}
static  void
Parrot_default_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_PUSH_PMC);
}
static  void
Parrot_default_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_PUSH_STRING);
}
static  void
Parrot_default_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    UNUSED(name)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_ATTRIBUTE);
}
static  void
Parrot_default_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    UNUSED(method_name)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_METHOD);
}
static  void
Parrot_default_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    UNUSED(parent)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_PARENT);
}
static  void
Parrot_default_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    UNUSED(role)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_ROLE);
}
static  void
Parrot_default_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    UNUSED(vtable_name)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_VTABLE_OVERRIDE);
}
static  PMC  *
Parrot_default_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1901 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "repeat", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1713 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1918 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "repeat_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1724 "./src/pmc/default.c"
}
static  void 
Parrot_default_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name, PMC *value)
{
#line 1019 "./src/pmc/default.pmc"

    UNUSED(key)
    VTABLE_set_attr_str(interp, pmc, name, value);
#line 1733 "./src/pmc/default.c"
}
static  void
Parrot_default_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    UNUSED(idx)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_ATTR_STR);
}
static  void
Parrot_default_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_BOOL);
}
static  void
Parrot_default_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_INTEGER_KEYED);
}
static  void 
Parrot_default_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 649 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_integer_keyed(interp, pmc, r_key, value);
#line 1762 "./src/pmc/default.c"
}
static  void
Parrot_default_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_INTEGER_KEYED_STR);
}
static  void
Parrot_default_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_INTEGER_NATIVE);
}
static  void
Parrot_default_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_NUMBER_KEYED);
}
static  void 
Parrot_default_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 665 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_number_keyed(interp, pmc, r_key, value);
#line 1791 "./src/pmc/default.c"
}
static  void
Parrot_default_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_NUMBER_KEYED_STR);
}
static  void
Parrot_default_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_NUMBER_NATIVE);
}
static  void
Parrot_default_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_PMC);
}
static  void
Parrot_default_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_PMC_KEYED);
}
static  void 
Parrot_default_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
#line 697 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_pmc_keyed(interp, pmc, r_key, value);
#line 1826 "./src/pmc/default.c"
}
static  void
Parrot_default_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_PMC_KEYED_STR);
}
static  void
Parrot_default_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_POINTER);
}
static  void
Parrot_default_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_POINTER_KEYED);
}
static  void
Parrot_default_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_POINTER_KEYED_INT);
}
static  void
Parrot_default_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_POINTER_KEYED_STR);
}
static  void
Parrot_default_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_STRING_KEYED);
}
static  void 
Parrot_default_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *string)
{
#line 681 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_string_keyed(interp, pmc, r_key, string);
#line 1876 "./src/pmc/default.c"
}
static  void
Parrot_default_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_STRING_KEYED_STR);
}
static  void
Parrot_default_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SET_STRING_NATIVE);
}
static  void 
Parrot_default_setprop(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 389 "./src/pmc/default.pmc"

    if (check_set_std_props(interp, pmc, key, value))
        return;

    if (PMC_IS_NULL(PMC_metadata(pmc)))
        make_prop_hash(interp, pmc);

    VTABLE_set_pmc_keyed_str(interp, PMC_metadata(pmc), key, value);
#line 1903 "./src/pmc/default.c"
}
static  void
Parrot_default_share(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SHARE);
}
static  PMC *
Parrot_default_share_ro(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SHARE_RO);
}
static  FLOATVAL
Parrot_default_shift_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SHIFT_FLOAT);
}
static  INTVAL
Parrot_default_shift_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SHIFT_INTEGER);
}
static  PMC *
Parrot_default_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SHIFT_PMC);
}
static  STRING *
Parrot_default_shift_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SHIFT_STRING);
}
static  void
Parrot_default_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    UNUSED(value)
    UNUSED(offset)
    UNUSED(count)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SPLICE);
}
static  void
Parrot_default_substr(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length, PMC *dest)
{
    UNUSED(offset)
    UNUSED(length)
    UNUSED(dest)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SUBSTR);
}
static  STRING *
Parrot_default_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length)
{
    UNUSED(offset)
    UNUSED(length)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_SUBSTR_STR);
}
static  PMC  *
Parrot_default_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1223 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1967 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1257 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 1978 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1240 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1989 "./src/pmc/default.c"
}
static  void 
Parrot_default_thaw(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 1096 "./src/pmc/default.pmc"

    /* default - initialize the PMC */
    VTABLE_init(interp, pmc);
#line 1998 "./src/pmc/default.c"
}
static  void 
Parrot_default_thawfinish(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 1111 "./src/pmc/default.pmc"

    UNUSED(info)
    /* default - no action */
#line 2007 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_type(PARROT_INTERP, PMC *pmc)
{
#line 445 "./src/pmc/default.pmc"

    return pmc->vtable->base_type;
#line 2015 "./src/pmc/default.c"
}
static  void
Parrot_default_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_UNSHIFT_FLOAT);
}
static  void
Parrot_default_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_UNSHIFT_INTEGER);
}
static  void
Parrot_default_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_UNSHIFT_PMC);
}
static  void
Parrot_default_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, PARROT_VTABLE_SLOT_UNSHIFT_STRING);
}
static  void 
Parrot_default_visit(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 1054 "./src/pmc/default.pmc"

#line 2046 "./src/pmc/default.c"
}
static  void
Parrot_default_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    UNUSED(name)
    UNUSED(type)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_ADD_ATTRIBUTE);
}
static  void
Parrot_default_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    UNUSED(method_name)
    UNUSED(sub_pmc)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_ADD_METHOD);
}
static  void
Parrot_default_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    UNUSED(parent)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_ADD_PARENT);
}
static  void
Parrot_default_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    UNUSED(role)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_ADD_ROLE);
}
static  void
Parrot_default_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    UNUSED(vtable_name)
    UNUSED(sub_pmc)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_ADD_VTABLE_OVERRIDE);
}
static  void
Parrot_default_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_ASSIGN_PMC);
}
static  void
Parrot_default_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_ASSIGN_STRING_NATIVE);
}
static  void
Parrot_default_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_DECREMENT);
}
static  void
Parrot_default_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_DELETE_KEYED);
}
static  void
Parrot_default_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    UNUSED(key)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_DELETE_KEYED_INT);
}
static  void
Parrot_default_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_DELETE_KEYED_STR);
}
static  PMC *
Parrot_default_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name) {
    /* Use non-readonly find_method. Current vtable is ro variant. So ro_variant contains non-ro variant */
    PMC *const method = pmc->vtable->ro_variant_vtable->find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
static  void
Parrot_default_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_ABSOLUTE);
}
static  void
Parrot_default_ro_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_ADD);
}
static  void
Parrot_default_ro_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_ADD_FLOAT);
}
static  void
Parrot_default_ro_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_ADD_INT);
}
static  void
Parrot_default_ro_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_CONCATENATE);
}
static  void
Parrot_default_ro_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_CONCATENATE_STR);
}
static  void
Parrot_default_ro_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_DIVIDE);
}
static  void
Parrot_default_ro_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_DIVIDE_FLOAT);
}
static  void
Parrot_default_ro_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_DIVIDE_INT);
}
static  void
Parrot_default_ro_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_FLOOR_DIVIDE);
}
static  void
Parrot_default_ro_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_FLOOR_DIVIDE_FLOAT);
}
static  void
Parrot_default_ro_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_FLOOR_DIVIDE_INT);
}
static  void
Parrot_default_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_LOGICAL_NOT);
}
static  void
Parrot_default_ro_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_MODULUS);
}
static  void
Parrot_default_ro_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_MODULUS_FLOAT);
}
static  void
Parrot_default_ro_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_MODULUS_INT);
}
static  void
Parrot_default_ro_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_MULTIPLY);
}
static  void
Parrot_default_ro_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_MULTIPLY_FLOAT);
}
static  void
Parrot_default_ro_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_MULTIPLY_INT);
}
static  void
Parrot_default_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_NEG);
}
static  void
Parrot_default_ro_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_REPEAT);
}
static  void
Parrot_default_ro_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_REPEAT_INT);
}
static  void
Parrot_default_ro_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_SUBTRACT);
}
static  void
Parrot_default_ro_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_SUBTRACT_FLOAT);
}
static  void
Parrot_default_ro_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_I_SUBTRACT_INT);
}
static  void
Parrot_default_ro_increment(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_INCREMENT);
}
static  void
Parrot_default_ro_morph(PARROT_INTERP, PMC *pmc, PMC *type)
{
    UNUSED(type)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_MORPH);
}
static  FLOATVAL
Parrot_default_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_POP_FLOAT);
}
static  INTVAL
Parrot_default_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_POP_INTEGER);
}
static  PMC *
Parrot_default_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_POP_PMC);
}
static  STRING *
Parrot_default_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_POP_STRING);
}
static  void
Parrot_default_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_PUSH_FLOAT);
}
static  void
Parrot_default_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_PUSH_INTEGER);
}
static  void
Parrot_default_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_PUSH_PMC);
}
static  void
Parrot_default_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_PUSH_STRING);
}
static  void
Parrot_default_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    UNUSED(name)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_ATTRIBUTE);
}
static  void
Parrot_default_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    UNUSED(method_name)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_METHOD);
}
static  void
Parrot_default_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    UNUSED(parent)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_PARENT);
}
static  void
Parrot_default_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    UNUSED(role)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_ROLE);
}
static  void
Parrot_default_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    UNUSED(vtable_name)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_REMOVE_VTABLE_OVERRIDE);
}
static  void
Parrot_default_ro_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *idx, PMC *value)
{
    UNUSED(key)
    UNUSED(idx)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_ATTR_KEYED);
}
static  void
Parrot_default_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    UNUSED(idx)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_ATTR_STR);
}
static  void
Parrot_default_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_BOOL);
}
static  void
Parrot_default_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_INTEGER_KEYED);
}
static  void
Parrot_default_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_INTEGER_KEYED_INT);
}
static  void
Parrot_default_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_INTEGER_KEYED_STR);
}
static  void
Parrot_default_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_INTEGER_NATIVE);
}
static  void
Parrot_default_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_NUMBER_KEYED);
}
static  void
Parrot_default_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_NUMBER_KEYED_INT);
}
static  void
Parrot_default_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_NUMBER_KEYED_STR);
}
static  void
Parrot_default_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_NUMBER_NATIVE);
}
static  void
Parrot_default_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_PMC);
}
static  void
Parrot_default_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_PMC_KEYED);
}
static  void
Parrot_default_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_PMC_KEYED_INT);
}
static  void
Parrot_default_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_PMC_KEYED_STR);
}
static  void
Parrot_default_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_POINTER);
}
static  void
Parrot_default_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_POINTER_KEYED);
}
static  void
Parrot_default_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_POINTER_KEYED_INT);
}
static  void
Parrot_default_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_POINTER_KEYED_STR);
}
static  void
Parrot_default_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_STRING_KEYED);
}
static  void
Parrot_default_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_STRING_KEYED_INT);
}
static  void
Parrot_default_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_STRING_KEYED_STR);
}
static  void
Parrot_default_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SET_STRING_NATIVE);
}
static  FLOATVAL
Parrot_default_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SHIFT_FLOAT);
}
static  INTVAL
Parrot_default_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SHIFT_INTEGER);
}
static  PMC *
Parrot_default_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SHIFT_PMC);
}
static  STRING *
Parrot_default_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SHIFT_STRING);
}
static  void
Parrot_default_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    UNUSED(value)
    UNUSED(offset)
    UNUSED(count)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_SPLICE);
}
static  void
Parrot_default_ro_thaw(PARROT_INTERP, PMC *pmc, PMC *info)
{
    UNUSED(info)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_THAW);
}
static  void
Parrot_default_ro_thawfinish(PARROT_INTERP, PMC *pmc, PMC *info)
{
    UNUSED(info)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_THAWFINISH);
}
static  void
Parrot_default_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_UNSHIFT_FLOAT);
}
static  void
Parrot_default_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_UNSHIFT_INTEGER);
}
static  void
Parrot_default_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_UNSHIFT_PMC);
}
static  void
Parrot_default_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, PARROT_VTABLE_SLOT_UNSHIFT_STRING);
}
#include "pmc/pmc_default.h"

PARROT_EXPORT VTABLE* Parrot_default_get_vtable(PARROT_INTERP) {

    static const char attr_defs [] = "";

    const VTABLE temp_vtable = {
        NULL,       /* namespace */
        enum_class_default, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        NULL,       /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hashvalue,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_default_init,
        Parrot_default_init_int,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit,
	0           /* attr size */
    };


    return Parrot_clone_vtable(interp, &temp_vtable);
}


PARROT_EXPORT VTABLE* Parrot_default_ro_get_vtable(PARROT_INTERP) {

    VTABLE * vt = Parrot_default_get_vtable(interp);

    vt->add_attribute = Parrot_default_ro_add_attribute;
    vt->add_method = Parrot_default_ro_add_method;
    vt->add_parent = Parrot_default_ro_add_parent;
    vt->add_role = Parrot_default_ro_add_role;
    vt->add_vtable_override = Parrot_default_ro_add_vtable_override;
    vt->assign_pmc = Parrot_default_ro_assign_pmc;
    vt->assign_string_native = Parrot_default_ro_assign_string_native;
    vt->decrement = Parrot_default_ro_decrement;
    vt->delete_keyed = Parrot_default_ro_delete_keyed;
    vt->delete_keyed_int = Parrot_default_ro_delete_keyed_int;
    vt->delete_keyed_str = Parrot_default_ro_delete_keyed_str;
    vt->find_method = Parrot_default_ro_find_method;
    vt->i_absolute = Parrot_default_ro_i_absolute;
    vt->i_add = Parrot_default_ro_i_add;
    vt->i_add_float = Parrot_default_ro_i_add_float;
    vt->i_add_int = Parrot_default_ro_i_add_int;
    vt->i_concatenate = Parrot_default_ro_i_concatenate;
    vt->i_concatenate_str = Parrot_default_ro_i_concatenate_str;
    vt->i_divide = Parrot_default_ro_i_divide;
    vt->i_divide_float = Parrot_default_ro_i_divide_float;
    vt->i_divide_int = Parrot_default_ro_i_divide_int;
    vt->i_floor_divide = Parrot_default_ro_i_floor_divide;
    vt->i_floor_divide_float = Parrot_default_ro_i_floor_divide_float;
    vt->i_floor_divide_int = Parrot_default_ro_i_floor_divide_int;
    vt->i_logical_not = Parrot_default_ro_i_logical_not;
    vt->i_modulus = Parrot_default_ro_i_modulus;
    vt->i_modulus_float = Parrot_default_ro_i_modulus_float;
    vt->i_modulus_int = Parrot_default_ro_i_modulus_int;
    vt->i_multiply = Parrot_default_ro_i_multiply;
    vt->i_multiply_float = Parrot_default_ro_i_multiply_float;
    vt->i_multiply_int = Parrot_default_ro_i_multiply_int;
    vt->i_neg = Parrot_default_ro_i_neg;
    vt->i_repeat = Parrot_default_ro_i_repeat;
    vt->i_repeat_int = Parrot_default_ro_i_repeat_int;
    vt->i_subtract = Parrot_default_ro_i_subtract;
    vt->i_subtract_float = Parrot_default_ro_i_subtract_float;
    vt->i_subtract_int = Parrot_default_ro_i_subtract_int;
    vt->increment = Parrot_default_ro_increment;
    vt->morph = Parrot_default_ro_morph;
    vt->pop_float = Parrot_default_ro_pop_float;
    vt->pop_integer = Parrot_default_ro_pop_integer;
    vt->pop_pmc = Parrot_default_ro_pop_pmc;
    vt->pop_string = Parrot_default_ro_pop_string;
    vt->push_float = Parrot_default_ro_push_float;
    vt->push_integer = Parrot_default_ro_push_integer;
    vt->push_pmc = Parrot_default_ro_push_pmc;
    vt->push_string = Parrot_default_ro_push_string;
    vt->remove_attribute = Parrot_default_ro_remove_attribute;
    vt->remove_method = Parrot_default_ro_remove_method;
    vt->remove_parent = Parrot_default_ro_remove_parent;
    vt->remove_role = Parrot_default_ro_remove_role;
    vt->remove_vtable_override = Parrot_default_ro_remove_vtable_override;
    vt->set_attr_keyed = Parrot_default_ro_set_attr_keyed;
    vt->set_attr_str = Parrot_default_ro_set_attr_str;
    vt->set_bool = Parrot_default_ro_set_bool;
    vt->set_integer_keyed = Parrot_default_ro_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_default_ro_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_default_ro_set_integer_keyed_str;
    vt->set_integer_native = Parrot_default_ro_set_integer_native;
    vt->set_number_keyed = Parrot_default_ro_set_number_keyed;
    vt->set_number_keyed_int = Parrot_default_ro_set_number_keyed_int;
    vt->set_number_keyed_str = Parrot_default_ro_set_number_keyed_str;
    vt->set_number_native = Parrot_default_ro_set_number_native;
    vt->set_pmc = Parrot_default_ro_set_pmc;
    vt->set_pmc_keyed = Parrot_default_ro_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_default_ro_set_pmc_keyed_int;
    vt->set_pmc_keyed_str = Parrot_default_ro_set_pmc_keyed_str;
    vt->set_pointer = Parrot_default_ro_set_pointer;
    vt->set_pointer_keyed = Parrot_default_ro_set_pointer_keyed;
    vt->set_pointer_keyed_int = Parrot_default_ro_set_pointer_keyed_int;
    vt->set_pointer_keyed_str = Parrot_default_ro_set_pointer_keyed_str;
    vt->set_string_keyed = Parrot_default_ro_set_string_keyed;
    vt->set_string_keyed_int = Parrot_default_ro_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_default_ro_set_string_keyed_str;
    vt->set_string_native = Parrot_default_ro_set_string_native;
    vt->shift_float = Parrot_default_ro_shift_float;
    vt->shift_integer = Parrot_default_ro_shift_integer;
    vt->shift_pmc = Parrot_default_ro_shift_pmc;
    vt->shift_string = Parrot_default_ro_shift_string;
    vt->splice = Parrot_default_ro_splice;
    vt->thaw = Parrot_default_ro_thaw;
    vt->thawfinish = Parrot_default_ro_thawfinish;
    vt->unshift_float = Parrot_default_ro_unshift_float;
    vt->unshift_integer = Parrot_default_ro_unshift_integer;
    vt->unshift_pmc = Parrot_default_ro_unshift_pmc;
    vt->unshift_string = Parrot_default_ro_unshift_string;


    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_default_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "default", 7, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_default_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "default")), PMCNULL);
    return isa;
}

void
Parrot_default_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_default_get_vtable(interp);
        vt->base_type      = enum_class_default;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "default");
        vt->provides_str = CONST_STRING_GEN(interp, "");
        vt->isa_hash     = NULL;
    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_default_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_default_class_init */
#line 1953 "./src/pmc/default.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
