/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/env.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_env.h"
#include "pmc_default.h"
#include "env.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/env.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: env.pmc 44190 2010-02-19 19:48:48Z whiteknight $

=head1 NAME

src/pmc/env.pmc - System Environment

=head1 DESCRIPTION

C<Env> is a singleton class which provides access to the system environment.

XXX Think about returning Pair back. Currently there is no way to iterate over
environment I<keys>.

=head2 Methods

=over 4

=cut

*/

/* array of environment variables,
   speced in POSIX.1, but not in ISO-C
   MS C compilers know about environ, as it is declared in stdlib.h.
   OS X doesn't allow access to "environ" from within shared libraries.
*/
#ifndef WIN32
#  ifdef __APPLE_CC__
#    include <crt_externs.h>
#    define environ (*_NSGetEnviron())
#  else /* !__APPLE_CC__ */
extern char **environ;
#  endif /* __APPLE_CC__ */
#endif /* !WIN32 */

static PMC *Env_PMC;
#line 61 "./src/pmc/env.c"
static  void  Parrot_Env_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Env_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Env_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *pmckey);
static  INTVAL  Parrot_Env_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Env_get_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Env_get_iter(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Env_get_number(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Env_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  * Parrot_Env_get_pointer(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Env_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_Env_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL pos);
static  STRING  * Parrot_Env_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_Env_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_Env_set_pointer(PARROT_INTERP, PMC *pmc, void *ptr);
static  void  Parrot_Env_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
void    Parrot_Env_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Env_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Env_get_vtable(PARROT_INTERP);
static  void 
Parrot_Env_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 293 "./src/pmc/env.pmc"

    STRING *keyname = VTABLE_get_string(interp, key);

    if (!STRING_IS_EMPTY(keyname)) {
        char * const val = Parrot_getenv(interp, keyname);

        if (val) {
            Parrot_unsetenv(interp, keyname);
        }
    }
#line 94 "./src/pmc/env.c"
}
static  INTVAL 
Parrot_Env_elements(PARROT_INTERP, PMC *pmc)
{
#line 91 "./src/pmc/env.pmc"

    INTVAL rv = 0;

    while (environ[rv] != NULL)
        rv++;

    return rv;
#line 107 "./src/pmc/env.c"
}
static  INTVAL 
Parrot_Env_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *pmckey)
{
#line 269 "./src/pmc/env.pmc"

    STRING *keyname = VTABLE_get_string(interp, pmckey);

    if (!STRING_IS_EMPTY(keyname)) {
        char * const val = Parrot_getenv(interp, keyname);

        if (val) {
            return 1;
        }
    }

    return 0;
#line 125 "./src/pmc/env.c"
}
static  INTVAL 
Parrot_Env_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 109 "./src/pmc/env.pmc"

    return VTABLE_elements(interp, pmc) ? 1 : 0;
#line 133 "./src/pmc/env.c"
}
static  INTVAL 
Parrot_Env_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 123 "./src/pmc/env.pmc"

    return VTABLE_elements(interp, pmc);
#line 141 "./src/pmc/env.c"
}
static  PMC  *
Parrot_Env_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 76 "./src/pmc/env.pmc"

    return Parrot_pmc_new_init(interp, enum_class_ArrayIterator, pmc);
#line 149 "./src/pmc/env.c"
}
static  FLOATVAL 
Parrot_Env_get_number(PARROT_INTERP, PMC *pmc)
{
#line 136 "./src/pmc/env.pmc"

    return VTABLE_elements(interp, pmc);
#line 157 "./src/pmc/env.c"
}
static  PMC  *
Parrot_Env_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 200 "./src/pmc/env.pmc"

    STRING *keyname = VTABLE_get_string(interp, key);

    char   *val     = NULL;
    STRING *retval  = NULL;
    PMC    *return_pmc;

    if (!STRING_IS_EMPTY(keyname)) {
        val         = Parrot_getenv(interp, keyname);

        if (val) {
            retval = Parrot_str_new(interp, val, 0);
        }
    }

    if (!retval)
        retval = string_from_literal(interp, "");

    return_pmc = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, return_pmc, retval);
    return return_pmc;
#line 185 "./src/pmc/env.c"
}
static  void  *
Parrot_Env_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 57 "./src/pmc/env.pmc"

    return Env_PMC;
#line 193 "./src/pmc/env.c"
}
static  STRING  *
Parrot_Env_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 163 "./src/pmc/env.pmc"

    return VTABLE_get_string_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
#line 201 "./src/pmc/env.c"
}
static  STRING  *
Parrot_Env_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL pos)
{
#line 179 "./src/pmc/env.pmc"

    if (pos < 0 || pos >= VTABLE_elements(interp, pmc)) {
        return string_from_literal(interp, "");
    }
    else {
        const char * const envp = environ[pos];
        const char * const p    = strchr(envp, '=');
        return Parrot_str_new(interp, envp, (UINTVAL)(p - envp));
    }
#line 216 "./src/pmc/env.c"
}
static  STRING  *
Parrot_Env_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 150 "./src/pmc/env.pmc"

    if (!STRING_IS_EMPTY(key)) {
        char * const val = Parrot_getenv(interp, key);

        if (val) {
            STRING * const retval = Parrot_str_new(interp, val, 0);
            return retval;
        }
    }

    return string_from_literal(interp, "");
#line 233 "./src/pmc/env.c"
}
static  void 
Parrot_Env_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 251 "./src/pmc/env.pmc"

    STRING * keyname   = VTABLE_get_string(interp, key);
    STRING * str_value = VTABLE_get_string(interp, value);

    if (keyname && str_value)
        Parrot_setenv(interp, keyname, str_value);
#line 245 "./src/pmc/env.c"
}
static  void 
Parrot_Env_set_pointer(PARROT_INTERP, PMC *pmc, void *ptr)
{
#line 61 "./src/pmc/env.pmc"

    Env_PMC = (PMC *)ptr;
#line 253 "./src/pmc/env.c"
}
static  void 
Parrot_Env_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 234 "./src/pmc/env.pmc"

    STRING *keyname = VTABLE_get_string(interp, key);

    if (keyname && value)
        Parrot_setenv(interp, keyname, value);
#line 264 "./src/pmc/env.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Env_update_vtable(VTABLE *vt) {
    vt->delete_keyed = Parrot_Env_delete_keyed;
    vt->elements = Parrot_Env_elements;
    vt->exists_keyed = Parrot_Env_exists_keyed;
    vt->get_bool = Parrot_Env_get_bool;
    vt->get_integer = Parrot_Env_get_integer;
    vt->get_iter = Parrot_Env_get_iter;
    vt->get_number = Parrot_Env_get_number;
    vt->get_pmc_keyed = Parrot_Env_get_pmc_keyed;
    vt->get_pointer = Parrot_Env_get_pointer;
    vt->get_string_keyed = Parrot_Env_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Env_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Env_get_string_keyed_str;
    vt->set_pmc_keyed = Parrot_Env_set_pmc_keyed;
    vt->set_pointer = Parrot_Env_set_pointer;
    vt->set_string_keyed = Parrot_Env_set_string_keyed;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Env_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->elements = Parrot_Env_elements;
    vt->exists_keyed = Parrot_Env_exists_keyed;
    vt->get_bool = Parrot_Env_get_bool;
    vt->get_integer = Parrot_Env_get_integer;
    vt->get_iter = Parrot_Env_get_iter;
    vt->get_number = Parrot_Env_get_number;
    vt->get_pmc_keyed = Parrot_Env_get_pmc_keyed;
    vt->get_pointer = Parrot_Env_get_pointer;
    vt->get_string_keyed = Parrot_Env_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Env_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Env_get_string_keyed_str;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Env_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Env_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Env_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Env_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Env_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Env", 3, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Env_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Env")), PMCNULL);
    return isa;
}

static void thispmc_class_init(PARROT_INTERP, int entry)
{
    
        Env_PMC = NULL;

}
void
Parrot_Env_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Env_get_vtable(interp);
        vt->base_type      = enum_class_Env;
        vt->flags          = 0|VTABLE_PMC_IS_SINGLETON;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Env");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = NULL;
    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Env_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);

        /* class_init */
        thispmc_class_init(interp, entry);


        {
        }
    } /* pass */
} /* Parrot_Env_class_init */
#line 303 "./src/pmc/env.pmc"


/*

=back

=head1 SEE ALS0

PDD -
L<http://docs.parrot.org/parrot/latest/html/docs/pdds/pdd17_pmc.pod.html#Hash_types>

Environment in Perl 6 - L<http://dev.perl.org/perl6/rfc/318.html>

Module for Perl 5 - L<http://search.cpan.org/~stas/Env-C-0.06/>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
