/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/eventhandler.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_eventhandler.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "eventhandler.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/eventhandler.pmc"
/*
Copyright (C) 2007-2010, Parrot Foundation.
$Id: eventhandler.pmc 44917 2010-03-14 03:35:42Z petdance $

=head1 NAME

src/pmc/eventhandler.pmc - a handler for events

=head1 DESCRIPTION

A PMC that captures the state of the interpreter to invoke when handling an
Event.

=head2 Vtable Functions

=over 4

=cut

*/
#line 45 "./src/pmc/eventhandler.c"
static  PMC  * Parrot_EventHandler_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *name);
static  STRING  * Parrot_EventHandler_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_EventHandler_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_EventHandler_init_pmc(PARROT_INTERP, PMC *pmc, PMC *data);
static  opcode_t  * Parrot_EventHandler_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  void  Parrot_EventHandler_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_EventHandler_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL priority);
static  void  Parrot_EventHandler_set_pmc(PARROT_INTERP, PMC *pmc, PMC *interpreter);
static  void Parrot_EventHandler_nci_can_handle(PARROT_INTERP, PMC *pmc);
void    Parrot_EventHandler_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_EventHandler_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_EventHandler_get_vtable(PARROT_INTERP);
void    Parrot_EventHandler_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_EventHandler_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_EventHandler_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_EventHandler_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 211 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(pmc);
    PMC *value = PMCNULL;

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "code"))) {
        value = e->code;
    }

    return value;
#line 74 "./src/pmc/eventhandler.c"
}
static  STRING  *
Parrot_EventHandler_get_string(PARROT_INTERP, PMC *pmc)
{
#line 161 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(pmc);

    if (e)
        return Parrot_str_copy(interp, e->type);

    return string_from_literal(interp, "");
#line 87 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_init(PARROT_INTERP, PMC *pmc)
{
#line 40 "./src/pmc/eventhandler.pmc"

    PObj_custom_mark_SET(pmc);
    PObj_custom_destroy_SET(pmc);
#line 96 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_init_pmc(PARROT_INTERP, PMC *pmc, PMC *data)
{
#line 77 "./src/pmc/eventhandler.pmc"

    PMC                 *code        = NULL;
    PMC                 *interpreter = PMCNULL;
    STRING              *type        = NULL;
    INTVAL               priority    = 0;
    Parrot_EventHandler_attributes *e =
            (Parrot_EventHandler_attributes *) PMC_data(pmc);

    if (VTABLE_isa(interp, data, CONST_STRING(interp, "Sub"))) {
        code = data;
    }
    else if (VTABLE_isa(interp, data, CONST_STRING(interp, "Hash"))) {
        code = VTABLE_get_pmc_keyed_str(interp, data, CONST_STRING(interp, "code"));
        interpreter = VTABLE_get_pmc_keyed_str(interp, data, CONST_STRING(interp, "interp"));
        type = VTABLE_get_string_keyed_str(interp, data, CONST_STRING(interp, "type"));
        priority = VTABLE_get_integer_keyed_str(interp, data, CONST_STRING(interp, "priority"));
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "EventHandler initializer must be Sub or Hash");
    }

    if (PMC_IS_NULL(interpreter))
        interpreter = VTABLE_get_pmc_keyed_int(interp,
                interp->iglobals, IGLOBALS_INTERPRETER);

    PObj_custom_mark_SET(pmc);
    PObj_custom_destroy_SET(pmc);

    e->type        = type;
    e->code        = code;
    e->interp      = interpreter;
    e->priority    = priority;
#line 135 "./src/pmc/eventhandler.c"
}
static  opcode_t  *
Parrot_EventHandler_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 231 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(pmc);

    /* can't invoke on interp and can't return its result; this may not be
     * the right interpreter */
    if (e) {
        void *unused;

        unused = VTABLE_invoke(PMC_data_typed(e->interp, Parrot_Interp),
                e->code, next);
        UNUSED(unused);
    }

    return (opcode_t *)next;
#line 155 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_mark(PARROT_INTERP, PMC *pmc)
{
#line 122 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(pmc);

    if (e) {
        Parrot_gc_mark_STRING_alive(interp, e->type);
        Parrot_gc_mark_PMC_alive(interp, e->interp);
        Parrot_gc_mark_PMC_alive(interp, e->code);

        interp->vtables[enum_class_Sub]->mark(interp, pmc);
    }
#line 171 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL priority)
{
#line 179 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(pmc);

    if (e)
        e->priority = priority;
#line 182 "./src/pmc/eventhandler.c"
}
static  void 
Parrot_EventHandler_set_pmc(PARROT_INTERP, PMC *pmc, PMC *interpreter)
{
#line 196 "./src/pmc/eventhandler.pmc"

    Parrot_EventHandler_attributes * const e = PARROT_EVENTHANDLER(pmc);

    if (e)
        e->interp = interpreter;
#line 193 "./src/pmc/eventhandler.c"
}
static  void
Parrot_EventHandler_nci_can_handle(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 206 "./src/pmc/eventhandler.pmc"
PMC* pmc;
PMC* event;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &pmc, &event);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 269 "./src/pmc/eventhandler.pmc"


    if (event->vtable->base_type == enum_class_Task) {
        PMC    * const type     = VTABLE_get_attr_str(interp, event, CONST_STRING(interp, "type"));
        STRING * const type_str = VTABLE_get_string(interp, type);

        if (Parrot_str_equal(interp, type_str, CONST_STRING(interp, "event"))) {
            Parrot_EventHandler_attributes * const handler_struct = PARROT_EVENTHANDLER(pmc);
            PMC    * const subtype     = VTABLE_get_attr_str(interp, event, CONST_STRING(interp, "subtype"));
            STRING * const subtype_str = VTABLE_get_string(interp, subtype);

            if (Parrot_str_equal(interp, subtype_str, handler_struct->type)) {
                #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 1 */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)1);
    return;
    /*END RETURN INTVAL 1 */
    }
#line 281 "./src/pmc/eventhandler.pmc"

            }
        }
    }

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)0);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 286 "./src/pmc/eventhandler.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 259 "./src/pmc/eventhandler.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_EventHandler_update_vtable(VTABLE *vt) {
    vt->get_attr_str = Parrot_EventHandler_get_attr_str;
    vt->get_string = Parrot_EventHandler_get_string;
    vt->init = Parrot_EventHandler_init;
    vt->init_pmc = Parrot_EventHandler_init_pmc;
    vt->invoke = Parrot_EventHandler_invoke;
    vt->mark = Parrot_EventHandler_mark;
    vt->set_integer_native = Parrot_EventHandler_set_integer_native;
    vt->set_pmc = Parrot_EventHandler_set_pmc;
    vt->attr_size = sizeof(Parrot_EventHandler_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_EventHandler_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->get_attr_str = Parrot_EventHandler_get_attr_str;
    vt->get_string = Parrot_EventHandler_get_string;
    vt->init = Parrot_EventHandler_init;
    vt->init_pmc = Parrot_EventHandler_init_pmc;
    vt->invoke = Parrot_EventHandler_invoke;
    vt->mark = Parrot_EventHandler_mark;
    vt->attr_size = sizeof(Parrot_EventHandler_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_EventHandler_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_get_vtable(interp);
    Parrot_EventHandler_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_EventHandler_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_ro_get_vtable(interp);
    Parrot_EventHandler_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_EventHandler_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Sub_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "EventHandler", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_EventHandler_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Sub_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "EventHandler")), PMCNULL);
    return isa;
}

void
Parrot_EventHandler_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":seg :start_offs :end_offs IHLL_id Fnamespace_name Fnamespace_stash Sname Smethod_name Sns_entry_name Ssubid Ivtable_index Fmulti_signature :n_regs_used Flex_info Fouter_sub Feval_pmc Fctx :comp_flags :arg_info Fouter_ctx Stype Fcode Finterp Ipriority ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_EventHandler_get_vtable(interp);
        vt->base_type      = enum_class_EventHandler;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "EventHandler");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_EventHandler_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_EventHandler_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_EventHandler;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_EventHandler_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_EventHandler_nci_can_handle), CONST_STRING_GEN(interp, "can_handle"));
        {
        }
    } /* pass */
} /* Parrot_EventHandler_class_init */
#line 288 "./src/pmc/eventhandler.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
