/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/filehandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_filehandle.h"
#include "pmc_handle.h"
#include "pmc_default.h"
#include "filehandle.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/filehandle.pmc"
/*
Copyright (C) 2008-2009, Parrot Foundation.
$Id: filehandle.pmc 44371 2010-02-23 07:40:47Z bacek $

=head1 NAME

src/pmc/filehandle.pmc - FileHandle PMC

=head1 DESCRIPTION

The FileHandle PMC performs I/O operations on a source or destination file.

=head2 Vtable Functions

=over 4

=cut

*/

#include "../src/io/io_private.h"

#ifdef PARROT_HAS_READLINE
#ifdef __cplusplus
extern "C" {
#endif
    char *readline(const char *);
    void add_history(const char*);
#ifdef __cplusplus
}
#endif
#endif
#line 57 "./src/pmc/filehandle.c"
static  PMC  * Parrot_FileHandle_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_FileHandle_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_FileHandle_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_FileHandle_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  Parrot_FileHandle_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_FileHandle_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_FileHandle_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void Parrot_FileHandle_nci_open(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_isatty(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_close(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_is_closed(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_read(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_readline(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_readline_interactive(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_readall(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_flush(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_print(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_puts(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_buffer_type(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_buffer_size(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_mode(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_encoding(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_eof(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_exit_status(PARROT_INTERP, PMC *pmc);
static  void Parrot_FileHandle_nci_get_fd(PARROT_INTERP, PMC *pmc);
void    Parrot_FileHandle_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_FileHandle_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_FileHandle_get_vtable(PARROT_INTERP);
void    Parrot_FileHandle_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_FileHandle_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_FileHandle_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_FileHandle_clone(PARROT_INTERP, PMC *pmc)
{
#line 102 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes * const old_struct
        = PARROT_FILEHANDLE(pmc);
    PMC * const copy = Parrot_io_new_pmc(interp, old_struct->flags);
    Parrot_FileHandle_attributes * const data_struct
        = PARROT_FILEHANDLE(copy);

    data_struct->os_handle = (PIOHANDLE)Parrot_dup(old_struct->os_handle);

    return copy;
#line 103 "./src/pmc/filehandle.c"
}
static  void 
Parrot_FileHandle_destroy(PARROT_INTERP, PMC *pmc)
{
#line 144 "./src/pmc/filehandle.pmc"

    if (PARROT_FILEHANDLE(pmc)) {
        Parrot_FileHandle_attributes *data_struct = PARROT_FILEHANDLE(pmc);

        if (!Parrot_io_is_closed_filehandle(interp, pmc)) {
            if (data_struct->flags & PIO_F_SHARED)
                Parrot_io_flush_filehandle(interp, pmc);
            else
                Parrot_io_close_filehandle(interp, pmc);
        }

        if (data_struct->buffer_start)
            mem_gc_free(interp, data_struct->buffer_start);
    }
#line 123 "./src/pmc/filehandle.c"
}
static  INTVAL 
Parrot_FileHandle_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 218 "./src/pmc/filehandle.pmc"

    return !Parrot_io_eof(interp, pmc);
#line 131 "./src/pmc/filehandle.c"
}
static  INTVAL 
Parrot_FileHandle_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 172 "./src/pmc/filehandle.pmc"

    INTVAL result;
    switch (key) {
      case 0:
        GETATTR_FileHandle_process_id(interp, pmc, result);
        break;
      default:
        result = 0;
    }

    return result;
#line 148 "./src/pmc/filehandle.c"
}
static  void 
Parrot_FileHandle_init(PARROT_INTERP, PMC *pmc)
{
#line 65 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes * const data_struct =
        PMC_data_typed(pmc, Parrot_FileHandle_attributes *);

    data_struct->flags         = 0;
    data_struct->filename      = NULL;
    data_struct->mode          = NULL;
    data_struct->encoding      = NULL;
    data_struct->process_id    = 0;
    data_struct->exit_status   = 0;
    data_struct->file_size     = 0;
    data_struct->file_pos      = piooffsetzero;
    data_struct->last_pos      = piooffsetzero;
    data_struct->buffer_size   = 0;
    data_struct->buffer_flags  = 0;
    data_struct->buffer_start  = NULL;
    data_struct->buffer_end    = NULL;
    data_struct->buffer_next   = NULL;

    /* Initialize the os_handle to the platform-specific value for closed */
    data_struct->os_handle     = (PIOHANDLE) PIO_INVALID_HANDLE;

    PObj_custom_mark_SET(pmc);
    PObj_custom_destroy_SET(pmc);
#line 178 "./src/pmc/filehandle.c"
}
static  void 
Parrot_FileHandle_mark(PARROT_INTERP, PMC *pmc)
{
#line 125 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes * const data_struct
        = PARROT_FILEHANDLE(pmc);

    Parrot_gc_mark_STRING_alive(interp, data_struct->mode);
    Parrot_gc_mark_STRING_alive(interp, data_struct->filename);
    Parrot_gc_mark_STRING_alive(interp, data_struct->encoding);
#line 191 "./src/pmc/filehandle.c"
}
static  void 
Parrot_FileHandle_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 197 "./src/pmc/filehandle.pmc"

    switch (key) {
      case 0:
        SETATTR_FileHandle_process_id(interp, pmc, value);
        break;
      default:
        break;
    }
#line 205 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_open(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 218 "./src/pmc/filehandle.pmc"
PMC* pmc;
STRING* filename;
INTVAL got_filename;
STRING* mode;
INTVAL got_mode;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIpSoIp",
            &pmc, &filename, &got_filename, &mode, &got_mode);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 243 "./src/pmc/filehandle.pmc"

    PMC    *filehandle;
    STRING *open_filename, *open_mode;

    if (!Parrot_io_is_closed_filehandle(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                            "Cannot reopen already open filehandle");

    if (got_mode && !STRING_IS_NULL(mode))
        SETATTR_FileHandle_mode(interp, pmc, Parrot_str_copy(interp, mode));

    if (got_filename && !STRING_IS_NULL(filename))
        SETATTR_FileHandle_filename(interp, pmc, Parrot_str_copy(interp, filename));

    /* Open the file. With no options, reopen the same file as before */
    GETATTR_FileHandle_filename(interp, pmc, open_filename);
    GETATTR_FileHandle_mode(interp, pmc, open_mode);

    if (STRING_IS_NULL(open_filename))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                        "Cannot open filehandle, no filename");

    if (STRING_IS_NULL(open_mode)) {
        open_mode = CONST_STRING(interp, "r");
        SETATTR_FileHandle_mode(interp, pmc, open_mode);
    }

    filehandle = Parrot_io_open(interp, pmc, open_filename, open_mode);

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *filehandle */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)filehandle);
    return;
    /*END RETURN PMC *filehandle */
    }
#line 272 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 276 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_isatty(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 289 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 283 "./src/pmc/filehandle.pmc"

    const INTVAL isatty =
        (PARROT_FILEHANDLE(pmc)->flags & PIO_F_CONSOLE) == PIO_F_CONSOLE;
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL isatty */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)isatty);
    return;
    /*END RETURN INTVAL isatty */
    }
#line 286 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 317 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_close(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 330 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 299 "./src/pmc/filehandle.pmc"

    const INTVAL status = Parrot_io_close(interp, pmc);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)status);
    return;
    /*END RETURN INTVAL status */
    }
#line 301 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 357 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_is_closed(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 370 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 315 "./src/pmc/filehandle.pmc"

    const INTVAL status = Parrot_io_is_closed(interp, pmc);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)status);
    return;
    /*END RETURN INTVAL status */
    }
#line 317 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 397 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_read(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 410 "./src/pmc/filehandle.pmc"
PMC* pmc;
INTVAL length;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &pmc, &length);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 331 "./src/pmc/filehandle.pmc"

    STRING * const string_result = Parrot_io_reads(interp, pmc, length);

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)string_result);
    return;
    /*END RETURN STRING *string_result */
    }
#line 334 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 439 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_readline(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 452 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 348 "./src/pmc/filehandle.pmc"

    STRING * const string_result = Parrot_io_readline(interp, pmc);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)string_result);
    return;
    /*END RETURN STRING *string_result */
    }
#line 350 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 479 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_readline_interactive(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 492 "./src/pmc/filehandle.pmc"
PMC* pmc;
STRING* prompt;
INTVAL got_prompt;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &pmc, &prompt, &got_prompt);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 365 "./src/pmc/filehandle.pmc"

    STRING *string_result = NULL;

#ifdef PARROT_HAS_READLINE
/* 4-column indent to get c_indent.t to DTRT */
    char * const r = readline(got_prompt ? prompt->strstart : NULL);

    if (r) {
        if (*r)
            add_history(r);

        string_result = Parrot_str_new(interp, r, 0);
        mem_internal_free(r);
    }
#else
    if (got_prompt)
        fprintf(stderr, "%s", prompt->strstart);

    if (!(PARROT_FILEHANDLE(pmc)->flags & PIO_F_LINEBUF))
        Parrot_io_setlinebuf(interp, pmc);

    string_result = Parrot_io_reads(interp, pmc, 0);

    if (string_result) {
        UINTVAL len = Parrot_str_byte_length(interp, string_result);
        if (len < 1)
            string_result = NULL;
        else {
            while (len > 0
            &&    (((char *)string_result->strstart)[len - 1] == '\n'
              ||   ((char *)string_result->strstart)[len - 1] == '\r')) {
                    --len;
                    --string_result->strlen;
                    --string_result->bufused;
            }
        }
    }
#endif

    if (string_result)
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)string_result);
    return;
    /*END RETURN STRING *string_result */
    }
#line 405 "./src/pmc/filehandle.pmc"

    else
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 407 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 571 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_readall(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 584 "./src/pmc/filehandle.pmc"
PMC* pmc;
STRING* name;
INTVAL got_name;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &pmc, &name, &got_name);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 434 "./src/pmc/filehandle.pmc"

    STRING *result;

    if (got_name) {
        /* called as class method - open, slurp, close file */
        PMC    *filehandle;
        STRING *encoding;
        size_t  size;

        GETATTR_FileHandle_encoding(interp, pmc, encoding);

        if (!Parrot_io_is_closed_filehandle(interp, pmc))
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                "Cannot readall on a new file from an already open filehandle");

        filehandle  = Parrot_io_open(interp, PMCNULL, name, NULL);

        PARROT_ASSERT(filehandle->vtable->base_type == enum_class_FileHandle);

        SETATTR_FileHandle_encoding(interp, filehandle, encoding);
        size = (size_t)(Parrot_stat_info_intval(interp, name, STAT_FILESIZE));

        result = Parrot_io_reads(interp, filehandle, size);
        Parrot_io_close(interp, filehandle);
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 458 "./src/pmc/filehandle.pmc"

    }
    else {
        /* slurp open file */
        if (Parrot_io_is_closed_filehandle(interp, pmc))
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                "Cannot readall without a file name or open filehandle");

        result = Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

        /* Do line buffering on the filehandle */
        if (!(PARROT_FILEHANDLE(pmc)->flags & PIO_F_LINEBUF))
            Parrot_io_setlinebuf(interp, pmc);

        do {
            STRING * const part = Parrot_io_reads(interp, pmc, 0);
            result = Parrot_str_append(interp, result, part);

            if (Parrot_io_eof(interp, pmc))
                break;
        } while (1);
    }

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 481 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 668 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_flush(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 681 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 495 "./src/pmc/filehandle.pmc"

    Parrot_io_flush(interp, pmc);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 697 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_print(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 710 "./src/pmc/filehandle.pmc"
PMC* pmc;
PMC* to_print;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &pmc, &to_print);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 510 "./src/pmc/filehandle.pmc"

    STRING * const string_to_print = VTABLE_get_string(interp, to_print);

    Parrot_io_putps(interp, pmc, string_to_print);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 729 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_puts(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 742 "./src/pmc/filehandle.pmc"
PMC* pmc;
STRING* to_print;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &to_print);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 527 "./src/pmc/filehandle.pmc"

    const INTVAL status = Parrot_io_putps(interp, pmc, to_print);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)status);
    return;
    /*END RETURN INTVAL status */
    }
#line 529 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 770 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_buffer_type(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 783 "./src/pmc/filehandle.pmc"
PMC* pmc;
STRING* new_type;
INTVAL got_type;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &pmc, &new_type, &got_type);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 558 "./src/pmc/filehandle.pmc"

    STRING * const nobuffer_string   = CONST_STRING(interp, "unbuffered");
    STRING * const linebuffer_string = CONST_STRING(interp, "line-buffered");
    STRING * const fullbuffer_string = CONST_STRING(interp, "full-buffered");
    INTVAL flags;

    if (got_type) {
        if (Parrot_str_equal(interp, new_type, nobuffer_string))
            Parrot_io_setbuf(interp, pmc, PIOCTL_NONBUF);
        else if (Parrot_str_equal(interp, new_type, linebuffer_string))
            Parrot_io_setlinebuf(interp, pmc);
        else if (Parrot_str_equal(interp, new_type, fullbuffer_string))
            Parrot_io_setbuf(interp, pmc, PIO_UNBOUND);
    }

    GETATTR_FileHandle_flags(interp, pmc, flags);

    if (flags & PIO_F_LINEBUF)
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *linebuffer_string */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)linebuffer_string);
    return;
    /*END RETURN STRING *linebuffer_string */
    }
#line 576 "./src/pmc/filehandle.pmc"

    else if (flags & PIO_F_BLKBUF)
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *fullbuffer_string */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)fullbuffer_string);
    return;
    /*END RETURN STRING *fullbuffer_string */
    }
#line 578 "./src/pmc/filehandle.pmc"


    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *nobuffer_string */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)nobuffer_string);
    return;
    /*END RETURN STRING *nobuffer_string */
    }
#line 580 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 852 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_buffer_size(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 865 "./src/pmc/filehandle.pmc"
PMC* pmc;
INTVAL new_size;
INTVAL got_size;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIp",
            &pmc, &new_size, &got_size);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 594 "./src/pmc/filehandle.pmc"

    INTVAL buffer_size;

    if (got_size)
        Parrot_io_setbuf(interp, pmc, (size_t)new_size);

    buffer_size = (INTVAL)Parrot_io_get_buffer_size(interp, pmc);

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL buffer_size */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)buffer_size);
    return;
    /*END RETURN INTVAL buffer_size */
    }
#line 602 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 900 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_mode(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 913 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 616 "./src/pmc/filehandle.pmc"

    STRING *mode, *mode_copy;

    GETATTR_FileHandle_mode(interp, pmc, mode);
    mode_copy = Parrot_str_copy(interp, mode);

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *mode_copy */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)mode_copy);
    return;
    /*END RETURN STRING *mode_copy */
    }
#line 622 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 944 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_encoding(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 957 "./src/pmc/filehandle.pmc"
PMC* pmc;
STRING* new_encoding;
INTVAL got_encoding;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &pmc, &new_encoding, &got_encoding);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 637 "./src/pmc/filehandle.pmc"

    STRING *encoding;
    STRING *encoding_copy = NULL;

    if (got_encoding) {
        if (!STRING_IS_NULL(new_encoding))
            encoding_copy = Parrot_str_copy(interp, new_encoding);
        SETATTR_FileHandle_encoding(interp, pmc, encoding_copy);
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *new_encoding */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)new_encoding);
    return;
    /*END RETURN STRING *new_encoding */
    }
#line 645 "./src/pmc/filehandle.pmc"

    }

    GETATTR_FileHandle_encoding(interp, pmc, encoding);
    if (!STRING_IS_NULL(encoding))
        encoding_copy = Parrot_str_copy(interp, encoding);

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *encoding_copy */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)encoding_copy);
    return;
    /*END RETURN STRING *encoding_copy */
    }
#line 652 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1009 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_eof(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1022 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 666 "./src/pmc/filehandle.pmc"

    const INTVAL flags = Parrot_io_eof(interp, pmc);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL flags */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)flags);
    return;
    /*END RETURN INTVAL flags */
    }
#line 668 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1049 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_exit_status(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1062 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 680 "./src/pmc/filehandle.pmc"

    INTVAL exit_status;
    GETATTR_FileHandle_exit_status(interp, pmc, exit_status);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL exit_status */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)exit_status);
    return;
    /*END RETURN INTVAL exit_status */
    }
#line 683 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1090 "./src/pmc/filehandle.c"
}
static  void
Parrot_FileHandle_nci_get_fd(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1103 "./src/pmc/filehandle.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 698 "./src/pmc/filehandle.pmc"

#ifndef PIO_OS_STDIO
    PIOHANDLE os_handle;
    INTVAL    fd;
    GETATTR_FileHandle_os_handle(interp, pmc, os_handle);
    fd = (INTVAL)os_handle;
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL fd */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)fd);
    return;
    /*END RETURN INTVAL fd */
    }
#line 704 "./src/pmc/filehandle.pmc"

#endif /*PIO_OS_STDIO*/

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL -1 */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)-1);
    return;
    /*END RETURN INTVAL -1 */
    }
#line 707 "./src/pmc/filehandle.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1147 "./src/pmc/filehandle.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_FileHandle_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_FileHandle_clone;
    vt->destroy = Parrot_FileHandle_destroy;
    vt->get_bool = Parrot_FileHandle_get_bool;
    vt->get_integer_keyed_int = Parrot_FileHandle_get_integer_keyed_int;
    vt->init = Parrot_FileHandle_init;
    vt->mark = Parrot_FileHandle_mark;
    vt->set_integer_keyed_int = Parrot_FileHandle_set_integer_keyed_int;
    vt->attr_size = sizeof(Parrot_FileHandle_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_FileHandle_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_FileHandle_clone;
    vt->destroy = Parrot_FileHandle_destroy;
    vt->get_bool = Parrot_FileHandle_get_bool;
    vt->get_integer_keyed_int = Parrot_FileHandle_get_integer_keyed_int;
    vt->init = Parrot_FileHandle_init;
    vt->mark = Parrot_FileHandle_mark;
    vt->attr_size = sizeof(Parrot_FileHandle_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_FileHandle_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_get_vtable(interp);
    Parrot_FileHandle_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_FileHandle_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_ro_get_vtable(interp);
    Parrot_FileHandle_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_FileHandle_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Handle_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "FileHandle", 10, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_FileHandle_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Handle_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "FileHandle")), PMCNULL);
    return isa;
}

void
Parrot_FileHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":os_handle Iflags Sfilename Smode Sencoding Iprocess_id Iexit_status :file_size :file_pos :last_pos :buffer_size Ibuffer_flags :buffer_start :buffer_end :buffer_next ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_FileHandle_get_vtable(interp);
        vt->base_type      = enum_class_FileHandle;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "FileHandle");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_FileHandle_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_FileHandle_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_FileHandle;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_FileHandle_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_open), CONST_STRING_GEN(interp, "open"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_isatty), CONST_STRING_GEN(interp, "isatty"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_close), CONST_STRING_GEN(interp, "close"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_is_closed), CONST_STRING_GEN(interp, "is_closed"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_read), CONST_STRING_GEN(interp, "read"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_readline), CONST_STRING_GEN(interp, "readline"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_readline_interactive), CONST_STRING_GEN(interp, "readline_interactive"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_readall), CONST_STRING_GEN(interp, "readall"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_flush), CONST_STRING_GEN(interp, "flush"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_print), CONST_STRING_GEN(interp, "print"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_puts), CONST_STRING_GEN(interp, "puts"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_buffer_type), CONST_STRING_GEN(interp, "buffer_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_buffer_size), CONST_STRING_GEN(interp, "buffer_size"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_mode), CONST_STRING_GEN(interp, "mode"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_encoding), CONST_STRING_GEN(interp, "encoding"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_eof), CONST_STRING_GEN(interp, "eof"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_exit_status), CONST_STRING_GEN(interp, "exit_status"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_FileHandle_nci_get_fd), CONST_STRING_GEN(interp, "get_fd"));
        {
        }
    } /* pass */
} /* Parrot_FileHandle_class_init */
#line 718 "./src/pmc/filehandle.pmc"
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
