/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/imageio.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_imageio.h"
#include "pmc_default.h"
#include "imageio.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/imageio.pmc"
/*
Copyright (C) 2010, Parrot Foundation.
$Id: imageio.pmc 44214 2010-02-20 02:01:10Z plobsing $

=head1 NAME

src/pmc/imageio.pmc - ImageIO PMC

=head1 DESCRIPTION

Freezes and thaws other PMCs.

=cut

*/

#define GROW_TO_16_BYTE_BOUNDARY(size) ((size) + ((size) % 16 ? 16 - (size) % 16 : 0))

/* preallocate freeze image for aggregates with this estimation */
#define FREEZE_BYTES_PER_ITEM 9

/* macros/constants to handle packing/unpacking of PMC IDs and flags
 * the 2 LSBs are used for flags, all other bits are used for PMC ID
 */
#define PackID_new(id, flags)       (((UINTVAL)(id) * 4) | ((UINTVAL)(flags) & 3))
#define PackID_get_PMCID(id)        ((UINTVAL)(id) / 4)
#define PackID_set_PMCID(lv, id)    (lv) = PackID_new((id), PackID_get_FLAGS(lv))
#define PackID_get_FLAGS(id)        ((UINTVAL)(id) & 3)
#define PackID_set_FLAGS(lv, flags) (lv) = PackID_new(PackID_get_PMCID(lv), (flags))

enum {
    enum_PackID_normal     = 0,
    enum_PackID_seen       = 1,
};

PARROT_INLINE
static opcode_t *
GET_VISIT_CURSOR(PMC *pmc){
    char  *buf = (char *)Buffer_bufstart(PARROT_IMAGEIO(pmc)->buffer);
    size_t pos = PARROT_IMAGEIO(pmc)->pos;
    return (opcode_t *)(buf + pos);
}

PARROT_INLINE
static void
SET_VISIT_CURSOR(PMC *pmc, char *cursor) {
    char *bufstart  = (char *)Buffer_bufstart(PARROT_IMAGEIO(pmc)->buffer);
    PARROT_IMAGEIO(pmc)->pos = (cursor - bufstart);
}

PARROT_INLINE
static void
INC_VISIT_CURSOR(PMC *pmc, UINTVAL inc) {
    PARROT_IMAGEIO(pmc)->pos += inc;
}

#define BYTECODE_SHIFT_OK(pmc) PARROT_ASSERT( \
    PARROT_IMAGEIO(pmc)->pos <= PARROT_IMAGEIO(pmc)->input_length)



static void
create_buffer(PARROT_INTERP, PMC *pmc, PMC *info)
{
    INTVAL  len;

    if (!PMC_IS_NULL(pmc)) {
        STRING *array = CONST_STRING(interp, "array");
        STRING *hash  = CONST_STRING(interp, "hash");
        INTVAL  items = 1;

        if (VTABLE_does(interp, pmc, array) || VTABLE_does(interp, pmc, hash)) {
            items += VTABLE_elements(interp, pmc);
        }
        len = items * FREEZE_BYTES_PER_ITEM;
    }
    else
        len = FREEZE_BYTES_PER_ITEM;

    PARROT_IMAGEIO(info)->buffer =
        Parrot_gc_new_bufferlike_header(interp, sizeof (Buffer));
    Parrot_gc_allocate_buffer_storage_aligned(interp,
        PARROT_IMAGEIO(info)->buffer, len);
    SET_VISIT_CURSOR(info, (char *)Buffer_bufstart(PARROT_IMAGEIO(info)->buffer));
}


/*
static void ensure_buffer_size(PARROT_INTERP, PMC *io, size_t len)

Checks the size of the buffer to see if it can accommodate 'len' more
bytes. If not, expands the buffer.

*/

PARROT_INLINE
static void
ensure_buffer_size(PARROT_INTERP, ARGIN(PMC *io), size_t len)
{
    Buffer *buf         = PARROT_IMAGEIO(io)->buffer;
    const size_t used   = PARROT_IMAGEIO(io)->pos;
    const int need_free = Buffer_buflen(buf) - used - len;

    /* grow by factor 1.5 or such */
    if (need_free <= 16) {
        size_t new_size = (size_t) (Buffer_buflen(buf) * 1.5);
        if (new_size < Buffer_buflen(buf) - need_free + 512)
            new_size = Buffer_buflen(buf) - need_free + 512;
        Parrot_gc_reallocate_buffer_storage(interp, buf, new_size);
        PARROT_ASSERT(Buffer_buflen(buf) - used - len >= 15);
    }

#ifndef DISABLE_GC_DEBUG
    Parrot_gc_compact_memory_pool(INTERP);
#endif

}

PARROT_INLINE
static INTVAL
INFO_HAS_DATA(ARGIN(PMC *io)) {
    return PARROT_IMAGEIO(io)->pos < PARROT_IMAGEIO(io)->input_length;
}

PARROT_INLINE
static PMC*
id_list_get(PARROT_INTERP, PMC *io, UINTVAL id) {
    return VTABLE_get_pmc_keyed_int(interp, PARROT_IMAGEIO(io)->todo, id - 1);
}

PARROT_INLINE
static PMC *
visit_todo_list_thaw(PARROT_INTERP, ARGIN(PMC* info))
{
    UINTVAL  n            = VTABLE_shift_integer(interp, info);
    UINTVAL  id           = PackID_get_PMCID(n);
    int      packid_flags = PackID_get_FLAGS(n);
    PMC     *pmc          = PMCNULL;

    PARROT_ASSERT(PARROT_IMAGEIO(info)->what == VISIT_THAW_NORMAL);

    switch (packid_flags) {
      case enum_PackID_seen:
        if (id) /* got a non-NULL PMC */
            pmc = id_list_get(interp, info, id);
        break;
      case enum_PackID_normal:
        {
            INTVAL type = VTABLE_shift_integer(interp, info);
            if (type <= 0 || type > interp->n_vtable_max)
                Parrot_ex_throw_from_c_args(interp, NULL, 1, "Unknown PMC type to thaw %d", type);

            pmc = Parrot_pmc_new_noinit(interp, type);
            VTABLE_thaw(interp, pmc, info);

            {
                PMC * const todo    = PARROT_IMAGEIO(info)->todo;
                VTABLE_set_pmc_keyed_int(interp, todo, id - 1, pmc);
            }
        }
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL, 1, "Unknown PMC id args thaw %d", packid_flags);
        break;
    }

    return pmc;
}

static void
visit_todo_list_freeze(PARROT_INTERP, PMC* pmc, PMC* info)
{
    UINTVAL id;
    int packid_type;

    PARROT_ASSERT(PARROT_IMAGEIO(info)->what == VISIT_FREEZE_NORMAL);

    if (PMC_IS_NULL(pmc)) {
        id   = 0;
        packid_type = enum_PackID_seen;
    }
    else {
        Hash *hash = (Hash *)VTABLE_get_pointer(interp, PARROT_IMAGEIO(info)->seen);
        HashBucket * const b = parrot_hash_get_bucket(interp, hash, pmc);
        if (b) {
            id = (UINTVAL) b->value;
            packid_type = enum_PackID_seen;
        }
        else {
            PARROT_IMAGEIO(info)->id++; /* next id to freeze */
            id = PARROT_IMAGEIO(info)->id;
            packid_type = enum_PackID_normal;
        }
    }

    VTABLE_push_integer(interp, info, PackID_new(id, packid_type));

    if (packid_type == enum_PackID_normal) {
        Hash *hash = (Hash *)VTABLE_get_pointer(interp, PARROT_IMAGEIO(info)->seen);
        PARROT_ASSERT(pmc);
        VTABLE_push_integer(interp, info,
                PObj_is_object_TEST(pmc) ? enum_class_Object : pmc->vtable->base_type);
        parrot_hash_put(interp, hash, pmc, (void *)id);
        VTABLE_push_pmc(interp, PARROT_IMAGEIO(info)->todo, pmc);
        VTABLE_freeze(interp, pmc, info);
    }
}
#line 230 "./src/pmc/imageio.c"
static  void  Parrot_ImageIO_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ImageIO_get_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ImageIO_get_iter(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ImageIO_get_pmc(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_ImageIO_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ImageIO_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ImageIO_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ImageIO_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL v);
static  void  Parrot_ImageIO_push_integer(PARROT_INTERP, PMC *pmc, INTVAL v);
static  void  Parrot_ImageIO_push_pmc(PARROT_INTERP, PMC *pmc, PMC *v);
static  void  Parrot_ImageIO_push_string(PARROT_INTERP, PMC *pmc, STRING *v);
static  void  Parrot_ImageIO_set_pmc(PARROT_INTERP, PMC *pmc, PMC *p);
static  void  Parrot_ImageIO_set_string_native(PARROT_INTERP, PMC *pmc, STRING *image);
static  FLOATVAL  Parrot_ImageIO_shift_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ImageIO_shift_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ImageIO_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_ImageIO_shift_string(PARROT_INTERP, PMC *pmc);
void    Parrot_ImageIO_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ImageIO_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ImageIO_get_vtable(PARROT_INTERP);
void    Parrot_ImageIO_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ImageIO_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ImageIO_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_ImageIO_destroy(PARROT_INTERP, PMC *pmc)
{
#line 258 "./src/pmc/imageio.pmc"

    PackFile_destroy(interp, PARROT_IMAGEIO(pmc)->pf);
#line 260 "./src/pmc/imageio.c"
}
static  INTVAL 
Parrot_ImageIO_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 333 "./src/pmc/imageio.pmc"

    return PARROT_IMAGEIO(pmc)->what;
#line 268 "./src/pmc/imageio.c"
}
static  PMC  *
Parrot_ImageIO_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 319 "./src/pmc/imageio.pmc"

    return PARROT_IMAGEIO(pmc)->todo;
#line 276 "./src/pmc/imageio.c"
}
static  PMC  *
Parrot_ImageIO_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 305 "./src/pmc/imageio.pmc"

    return VTABLE_get_pmc_keyed_int(interp, (PARROT_IMAGEIO(pmc))->todo, 0);
#line 284 "./src/pmc/imageio.c"
}
static  STRING  *
Parrot_ImageIO_get_string(PARROT_INTERP, PMC *pmc)
{
#line 289 "./src/pmc/imageio.pmc"

    return Parrot_str_new_from_buffer(interp,
                                      PARROT_IMAGEIO(pmc)->buffer,
                                      PARROT_IMAGEIO(pmc)->pos);
#line 294 "./src/pmc/imageio.c"
}
static  void 
Parrot_ImageIO_init(PARROT_INTERP, PMC *pmc)
{
#line 238 "./src/pmc/imageio.pmc"

    PARROT_IMAGEIO(pmc)->buffer      = NULL;
    PARROT_IMAGEIO(pmc)->todo        = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    PARROT_IMAGEIO(pmc)->seen        = PMCNULL;
    PARROT_IMAGEIO(pmc)->id          = 0;
    PARROT_IMAGEIO(pmc)->pf          = PackFile_new(interp, 0);

    PObj_custom_mark_destroy_SETALL(pmc);
#line 308 "./src/pmc/imageio.c"
}
static  void 
Parrot_ImageIO_mark(PARROT_INTERP, PMC *pmc)
{
#line 271 "./src/pmc/imageio.pmc"

    PObj * const buffer = (PObj *)(PARROT_IMAGEIO(pmc)->buffer);
    if (buffer)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)(PARROT_IMAGEIO(pmc)->buffer));
    Parrot_gc_mark_PMC_alive(interp, PARROT_IMAGEIO(pmc)->todo);
    Parrot_gc_mark_PMC_alive(interp, PARROT_IMAGEIO(pmc)->seen);
#line 320 "./src/pmc/imageio.c"
}
static  void 
Parrot_ImageIO_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL v)
{
#line 365 "./src/pmc/imageio.pmc"

    size_t len = PF_size_number() * sizeof (opcode_t);
    ensure_buffer_size(interp, pmc, len);
    SET_VISIT_CURSOR(pmc, (char *)PF_store_number(GET_VISIT_CURSOR(pmc), &v));
#line 330 "./src/pmc/imageio.c"
}
static  void 
Parrot_ImageIO_push_integer(PARROT_INTERP, PMC *pmc, INTVAL v)
{
#line 347 "./src/pmc/imageio.pmc"

    size_t len = PF_size_integer() * sizeof (opcode_t);
    ensure_buffer_size(interp, pmc, len);
    SET_VISIT_CURSOR(pmc, (char *)PF_store_integer(GET_VISIT_CURSOR(pmc), v));
#line 340 "./src/pmc/imageio.c"
}
static  void 
Parrot_ImageIO_push_pmc(PARROT_INTERP, PMC *pmc, PMC *v)
{
#line 400 "./src/pmc/imageio.pmc"

    visit_todo_list_freeze(interp, v, pmc);
#line 348 "./src/pmc/imageio.c"
}
static  void 
Parrot_ImageIO_push_string(PARROT_INTERP, PMC *pmc, STRING *v)
{
#line 383 "./src/pmc/imageio.pmc"

    size_t len = PF_size_string(v) * sizeof (opcode_t);
    ensure_buffer_size(interp, pmc, len);
    SET_VISIT_CURSOR(pmc, (char *)PF_store_string(GET_VISIT_CURSOR(pmc), v));
#line 358 "./src/pmc/imageio.c"
}
static  void 
Parrot_ImageIO_set_pmc(PARROT_INTERP, PMC *pmc, PMC *p)
{
#line 478 "./src/pmc/imageio.pmc"

    UINTVAL header_length = GROW_TO_16_BYTE_BOUNDARY(PACKFILE_HEADER_BYTES);

    PARROT_IMAGEIO(pmc)->what = VISIT_FREEZE_NORMAL;
    create_buffer(interp, p, pmc);
    ensure_buffer_size(interp, pmc, header_length);
    mem_sys_memcopy(GET_VISIT_CURSOR(pmc),
        PARROT_IMAGEIO(pmc)->pf->header, PACKFILE_HEADER_BYTES);
    INC_VISIT_CURSOR(pmc, header_length);

    PARROT_IMAGEIO(pmc)->seen = Parrot_pmc_new(interp, enum_class_Hash);
    VTABLE_set_pointer(interp, PARROT_IMAGEIO(pmc)->seen,
        parrot_new_intval_hash(interp));

    visit_todo_list_freeze(interp, p, pmc);
    Parrot_visit_loop_visit(interp, pmc);
#line 380 "./src/pmc/imageio.c"
}
static  void 
Parrot_ImageIO_set_string_native(PARROT_INTERP, PMC *pmc, STRING *image)
{
#line 496 "./src/pmc/imageio.pmc"

    UINTVAL header_length = GROW_TO_16_BYTE_BOUNDARY(PACKFILE_HEADER_BYTES);
    int unpacked_length;

    PARROT_IMAGEIO(pmc)->what          = VISIT_THAW_NORMAL;
    PARROT_IMAGEIO(pmc)->buffer        = (Buffer *)image;

    PARROT_ASSERT(image->_bufstart == image->strstart);

    SET_VISIT_CURSOR(pmc, (char *)Buffer_bufstart(PARROT_IMAGEIO(pmc)->buffer));
    PARROT_IMAGEIO(pmc)->input_length = image->strlen;

    PARROT_IMAGEIO(pmc)->pf->options |= PFOPT_PMC_FREEZE_ONLY;
    unpacked_length = PackFile_unpack(interp, PARROT_IMAGEIO(pmc)->pf,
        GET_VISIT_CURSOR(pmc), PARROT_IMAGEIO(pmc)->input_length);

    if (!unpacked_length) {
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_STRING_REPRESENTATION,
                "PackFile header failed during unpack");
    }
    else {
        INC_VISIT_CURSOR(pmc, header_length);
    }

    visit_todo_list_thaw(interp, pmc);
    Parrot_visit_loop_visit(interp, pmc);

    /* we're done reading the image */
    PARROT_ASSERT(!INFO_HAS_DATA(pmc));
    Parrot_visit_loop_thawfinish(interp, pmc);
#line 417 "./src/pmc/imageio.c"
}
static  FLOATVAL 
Parrot_ImageIO_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 434 "./src/pmc/imageio.pmc"

    opcode_t *pos    = GET_VISIT_CURSOR(pmc);
    const FLOATVAL f = PF_fetch_number(PARROT_IMAGEIO(pmc)->pf, (const opcode_t **)&pos);
    SET_VISIT_CURSOR(pmc, (char *)pos);
    BYTECODE_SHIFT_OK(pmc);
    return f;
#line 429 "./src/pmc/imageio.c"
}
static  INTVAL 
Parrot_ImageIO_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 415 "./src/pmc/imageio.pmc"

    opcode_t *pos  = GET_VISIT_CURSOR(pmc);
    const INTVAL i = PF_fetch_integer(PARROT_IMAGEIO(pmc)->pf, (const opcode_t **)&pos);
    SET_VISIT_CURSOR(pmc, (char *)pos);
    BYTECODE_SHIFT_OK(pmc);
    return i;
#line 441 "./src/pmc/imageio.c"
}
static  PMC  *
Parrot_ImageIO_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 473 "./src/pmc/imageio.pmc"

    return visit_todo_list_thaw(interp, pmc);
#line 449 "./src/pmc/imageio.c"
}
static  STRING  *
Parrot_ImageIO_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 454 "./src/pmc/imageio.pmc"

    opcode_t *pos    = GET_VISIT_CURSOR(pmc);
    STRING * const s = PF_fetch_string(interp, PARROT_IMAGEIO(pmc)->pf,
                                       (const opcode_t **)&pos);
    SET_VISIT_CURSOR(pmc, (char *)pos);
    BYTECODE_SHIFT_OK(pmc);
    return s;
#line 462 "./src/pmc/imageio.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ImageIO_update_vtable(VTABLE *vt) {
    vt->destroy = Parrot_ImageIO_destroy;
    vt->get_integer = Parrot_ImageIO_get_integer;
    vt->get_iter = Parrot_ImageIO_get_iter;
    vt->get_pmc = Parrot_ImageIO_get_pmc;
    vt->get_string = Parrot_ImageIO_get_string;
    vt->init = Parrot_ImageIO_init;
    vt->mark = Parrot_ImageIO_mark;
    vt->push_float = Parrot_ImageIO_push_float;
    vt->push_integer = Parrot_ImageIO_push_integer;
    vt->push_pmc = Parrot_ImageIO_push_pmc;
    vt->push_string = Parrot_ImageIO_push_string;
    vt->set_pmc = Parrot_ImageIO_set_pmc;
    vt->set_string_native = Parrot_ImageIO_set_string_native;
    vt->shift_float = Parrot_ImageIO_shift_float;
    vt->shift_integer = Parrot_ImageIO_shift_integer;
    vt->shift_pmc = Parrot_ImageIO_shift_pmc;
    vt->shift_string = Parrot_ImageIO_shift_string;
    vt->attr_size = sizeof(Parrot_ImageIO_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ImageIO_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_ImageIO_destroy;
    vt->get_integer = Parrot_ImageIO_get_integer;
    vt->get_iter = Parrot_ImageIO_get_iter;
    vt->get_pmc = Parrot_ImageIO_get_pmc;
    vt->get_string = Parrot_ImageIO_get_string;
    vt->init = Parrot_ImageIO_init;
    vt->mark = Parrot_ImageIO_mark;
    vt->attr_size = sizeof(Parrot_ImageIO_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ImageIO_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_ImageIO_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ImageIO_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_ImageIO_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ImageIO_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "ImageIO", 7, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ImageIO_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ImageIO")), PMCNULL);
    return isa;
}

void
Parrot_ImageIO_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":buffer :pos :input_length Iwhat Fseen Ftodo :id :pf ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ImageIO_get_vtable(interp);
        vt->base_type      = enum_class_ImageIO;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ImageIO");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ImageIO_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ImageIO;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ImageIO_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ImageIO_class_init */
#line 536 "./src/pmc/imageio.pmc"


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
