/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/namespace.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_namespace.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "namespace.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/namespace.pmc"
/*
Copyright (C) 2005-2009, Parrot Foundation.
$Id: namespace.pmc 44279 2010-02-21 19:41:12Z whiteknight $

=head1 NAME

src/pmc/namespace.pmc - NameSpace PMC

=head1 DESCRIPTION

These are the vtable functions for the namespace PMC.

=head2 Functions

=over 4

=cut

*/

#include "pmc/pmc_sub.h"

static void add_to_class(
        Interp *interp,
        Parrot_NameSpace_attributes * const nsinfo,
        PMC * const classobj,
        STRING *key,
        PMC *value)
{
    /* Insert it in class, if there is a class */
    if (!PMC_IS_NULL(classobj) && PObj_is_class_TEST(classobj))
        VTABLE_add_method(interp, classobj, key, value);

    /* Otherwise, store it in the namespace for the class to
     * retrieve later */
    else {
        /* If we don't have a place to hang methods, make one. */
        if (PMC_IS_NULL(nsinfo->methods))
            nsinfo->methods = Parrot_pmc_new(interp, enum_class_Hash);

        /* Insert it. */
        VTABLE_set_pmc_keyed_str(interp, nsinfo->methods, key, value);
    }
}

static int
ns_insert_sub_keyed_str(PARROT_INTERP, PMC *self, STRING *key, PMC *value)
{
    Parrot_NameSpace_attributes * const nsinfo   = PARROT_NAMESPACE(self);
    PMC              *       vtable   = nsinfo->vtable;
    PMC              * const classobj = VTABLE_get_class(interp, self);
    STRING           * vtable_key     = NULL;
    Parrot_Sub_attributes *sub;

    PMC_get_sub(interp, value, sub);

    if (sub->vtable_index != -1) {
        /* Insert it in class, if there is a class */
        if (!PMC_IS_NULL(classobj) && PObj_is_class_TEST(classobj)) {
            const char * const vtable_key_c =
                Parrot_get_vtable_name(interp, sub->vtable_index);
            PARROT_ASSERT(vtable_key_c);
            vtable_key = Parrot_str_new(interp, vtable_key_c,
                strlen(vtable_key_c));
            VTABLE_add_vtable_override(interp, classobj, vtable_key, value);
        }

        /* Otherwise, store it in the namespace for the class to
         * retrieve later */
        else {
            /* If we don't have a place to hang vtable methods, make one. */
            if (PMC_IS_NULL(vtable))
                nsinfo->vtable = vtable = Parrot_pmc_new(interp, enum_class_Hash);

            /* Insert it. */
            VTABLE_set_pmc_keyed_int(interp, vtable, sub->vtable_index, value);
        }
    }

    if (sub->comp_flags & SUB_COMP_FLAG_METHOD) {
        STRING *method_name = key;

        if (Parrot_str_equal(interp, sub->method_name, CONST_STRING(interp, ""))) {
            if (sub->vtable_index != -1 && vtable_key != NULL) {
                method_name = Parrot_str_copy(interp, vtable_key);
            }
        }
        else {
            method_name = sub->method_name;
        }
        add_to_class(interp, nsinfo, classobj, method_name, value);
    }

    return 0;
}

static int
maybe_add_sub_to_namespace(PARROT_INTERP, PMC *SELF, STRING *key, PMC *value)
{
    STRING *sub_str = CONST_STRING(interp, "Sub");

    if (!PMC_IS_NULL(value)
    &&   VTABLE_isa(interp, value, sub_str)
    &&   value->vtable->base_type != enum_class_Object)
        return ns_insert_sub_keyed_str(interp, SELF, key, value);

    return 0;
}

static void
add_nci_to_namespace(PARROT_INTERP, PMC *SELF, STRING *key, PMC *value)
{
    STRING *nci_str = CONST_STRING(interp, "NCI");

    if (!PMC_IS_NULL(value)
    &&   VTABLE_isa(interp, value, nci_str)) {
        Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(SELF);
        PMC * const classobj = VTABLE_get_class(interp, SELF);

        /* Insert it in class, if there is a class */
        add_to_class(interp, nsinfo, classobj, key, value);
    }
}

static void
add_multi_to_namespace(PARROT_INTERP, PMC *SELF, STRING *key, PMC *value)
{
    STRING *multi_str = CONST_STRING(interp, "MultiSub");

    if (!PMC_IS_NULL(value)
    &&   VTABLE_isa(interp, value, multi_str)) {

        /* TT #10; work around that Sub doesn't use PMC ATTRs */
        if (value->vtable->base_type != enum_class_Object
        &&  VTABLE_elements(interp, value) > 0) {
            Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(SELF);
            PMC * const classobj = VTABLE_get_class(interp, SELF);

            /* Extract the first alternate and check if it is a method */
            PMC *pmc_sub = VTABLE_get_pmc_keyed_int(interp, value, 0);
            Parrot_Sub_attributes *sub;
            PMC_get_sub(interp, pmc_sub, sub);

            if (sub->comp_flags & SUB_COMP_FLAG_METHOD) {
                STRING *empty_str   = CONST_STRING(interp, "");
                STRING *method_name = key;
                Hash   *hash;

                if (Parrot_str_not_equal(interp, sub->method_name, empty_str))
                    method_name = sub->method_name;

                add_to_class(interp, nsinfo, classobj, method_name, value);

                GETATTR_NameSpace_hash(interp, SELF, hash);

                parrot_hash_put(interp, hash,
                    hash_key_from_string(interp, hash, key),
                    hash_value_from_pmc(interp, hash, value));
            }
        }
    }
}


/*
 * Typically a named slot contains either another namespace or a
 * var/sub (not both).
 * In case that the bucket->value is occupied, a FixedPMCArray is
 * created, and the items are moved over to that extra storage.
 * The array is flagged with FPA_is_ns_ext to distinguish it from a
 * plain array variable.
 *
 * This could easily expand to a full-fledged typed namespace if needed.
 */

typedef enum {
    NS_slot_ns,
    NS_slot_var_sub,         /* unspecified ~half-raw slot */
    NS_max_slots
} NS_slot_enum;

#define FPA_is_ns_ext PObj_private0_FLAG
#line 207 "./src/pmc/namespace.c"
static  PMC  * Parrot_NameSpace_get_class(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_NameSpace_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_NameSpace_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC  * Parrot_NameSpace_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  * Parrot_NameSpace_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  * Parrot_NameSpace_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING  * Parrot_NameSpace_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_NameSpace_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_NameSpace_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_NameSpace_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_NameSpace_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void Parrot_NameSpace_nci_make_namespace(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_add_namespace(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_add_sub(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_add_var(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_name(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_find_namespace(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_find_sub(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_find_var(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_del_namespace(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_del_sub(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_del_var(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_sym(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_export_to(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_parent(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_class(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_set_class(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_associated_methods(PARROT_INTERP, PMC *pmc);
static  void Parrot_NameSpace_nci_get_associated_vtable_methods(PARROT_INTERP, PMC *pmc);
void    Parrot_NameSpace_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_NameSpace_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_NameSpace_get_vtable(PARROT_INTERP);
void    Parrot_NameSpace_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_NameSpace_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_NameSpace_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_NameSpace_get_class(PARROT_INTERP, PMC *pmc)
{
#line 243 "./src/pmc/namespace.pmc"

    return PARROT_NAMESPACE(pmc)->_class;
#line 249 "./src/pmc/namespace.c"
}
static  PMC  *
Parrot_NameSpace_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 403 "./src/pmc/namespace.pmc"

    PMC *ns = interp->vtables[enum_class_Hash]->get_pmc_keyed(interp, pmc, key);
    /* Is this equivalent?
    PMC    *ns = interp->vtables[enum_class_Hash]->get_pmc_keyed(interp, pmc, key);
    */

    if (!PMC_IS_NULL(ns))
        return ns;

    ns = pmc;

    if (key->vtable->base_type == enum_class_Key) {
        STRING * const part = VTABLE_get_string(interp, key);
        key                 = VTABLE_shift_pmc(interp, key);

        if (!key)
            return VTABLE_get_pmc_keyed_str(interp, ns, part);

        ns = Parrot_get_namespace_keyed_str(interp, ns, part);

        if (PMC_IS_NULL(ns))
            return PMCNULL;

        return VTABLE_get_pmc_keyed(interp, ns, key);
    }
    else if (VTABLE_does(interp, key, CONST_STRING(interp, "array"))) {
        INTVAL i = 0;
        while (!PMC_IS_NULL(ns) && VTABLE_elements(interp, key)) {
            STRING * const name = VTABLE_get_string_keyed_int(interp, key, i);
            if (name == NULL || name == STRINGNULL) {
                ns = PMCNULL;
                /* What to do here? Throw an exception or something? */
                break;
            }
            ns = Parrot_get_namespace_keyed_str(interp, ns, name);
            i++;
        }
        return ns;
    }
    else {
        STRING * const name = VTABLE_get_string(interp, key);
        ns = Parrot_get_namespace_keyed_str(interp, ns, name);
        return ns;
    }
    /* If we get the wrong type, should we throw an exception?
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_GLOBAL_NOT_FOUND,
        "Invalid namespace key in get_pmc_keyed_str");
    */
#line 303 "./src/pmc/namespace.c"
}
static  PMC  *
Parrot_NameSpace_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 453 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
    PMC              * const vtable = nsinfo->vtable;

    if (PMC_IS_NULL(vtable))
        return PMCNULL;

    return VTABLE_get_pmc_keyed_int(interp, vtable, key);
#line 317 "./src/pmc/namespace.c"
}
static  PMC  *
Parrot_NameSpace_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 389 "./src/pmc/namespace.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    PMC *ns = (PMC *)parrot_hash_get(interp, hash, key);

    if (!ns)
        return PMCNULL;

    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
            ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_ns);

    return ns;
#line 335 "./src/pmc/namespace.c"
}
static  void  *
Parrot_NameSpace_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 493 "./src/pmc/namespace.pmc"

    PMC    *ns = pmc;

    if (PMC_IS_NULL(key))
        return PMCNULL;

    switch (key->vtable->base_type) {
        case enum_class_String:
            return VTABLE_get_pointer_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
        case enum_class_Key: {
            /* this loop (and function) could use a rewrite for clarity */
            while (1) {
                STRING * const part = VTABLE_get_string(interp, key);
                key                 = VTABLE_shift_pmc(interp, key);

                if (!key)
                    return VTABLE_get_pointer_keyed_str(interp, ns, part);

                ns = Parrot_get_namespace_keyed_str(interp, ns, part);

                if (PMC_IS_NULL(ns))
                    return PMCNULL;
            }
        }
        case enum_class_ResizableStringArray: {
            const INTVAL elements = VTABLE_elements(interp, key);
            INTVAL i;
            for (i = 0; i < elements; ++i)  {
                STRING * const part = VTABLE_get_string_keyed_int(interp, key, i);

                /* Last entry in the array */
                if ((i + 1) >= elements)
                    return VTABLE_get_pointer_keyed_str(interp, ns, part);

                ns = Parrot_get_namespace_keyed_str(interp, ns, part);

                if (PMC_IS_NULL(ns))
                    return PMCNULL;
            }
            return ns;
        }
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_GLOBAL_NOT_FOUND,
                "Invalid namespace key of type '%S' in get_pointer_keyed",
                key->vtable->whoami);
    }
#line 387 "./src/pmc/namespace.c"
}
static  void  *
Parrot_NameSpace_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 479 "./src/pmc/namespace.pmc"

    PMC *ns = (PMC *)parrot_hash_get(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key);

    /* Be extra careful about returning PMCNULL */
    if (! PMC_IS_NULL(ns)) {
        if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext) &&
                ns->vtable->base_type == enum_class_FixedPMCArray)
            ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_var_sub);
    }
    if (PMC_IS_NULL(ns))
        ns = PMCNULL;
    return ns;
#line 405 "./src/pmc/namespace.c"
}
static  STRING  *
Parrot_NameSpace_get_string(PARROT_INTERP, PMC *pmc)
{
#line 551 "./src/pmc/namespace.pmc"

    const Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
    return nsinfo->name;
#line 414 "./src/pmc/namespace.c"
}
static  void 
Parrot_NameSpace_init(PARROT_INTERP, PMC *pmc)
{
#line 204 "./src/pmc/namespace.pmc"

    PARROT_NAMESPACE(pmc)->vtable = PMCNULL;
    PARROT_NAMESPACE(pmc)->_class = PMCNULL;
    VTABLE_set_pointer(interp, pmc, parrot_new_hash(interp));
    PObj_custom_mark_destroy_SETALL(pmc);
#line 425 "./src/pmc/namespace.c"
}
static  void 
Parrot_NameSpace_mark(PARROT_INTERP, PMC *pmc)
{
#line 220 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);

    if (nsinfo->hash)
        parrot_mark_hash(interp, nsinfo->hash);

    Parrot_gc_mark_PMC_alive(interp, nsinfo->parent);
    Parrot_gc_mark_PMC_alive(interp, nsinfo->_class);
    Parrot_gc_mark_PMC_alive(interp, nsinfo->vtable);
    Parrot_gc_mark_PMC_alive(interp, nsinfo->methods);
    Parrot_gc_mark_STRING_alive(interp, nsinfo->name);
#line 442 "./src/pmc/namespace.c"
}
static  void 
Parrot_NameSpace_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 348 "./src/pmc/namespace.pmc"

    PMC *ns = pmc;

    if (key->vtable->base_type == enum_class_String) {
        VTABLE_set_pmc_keyed_str(interp, pmc, VTABLE_get_string(interp, key), value);
        return;
    }

    if (key->vtable->base_type == enum_class_Key) {
        while (1) {
            STRING * const part = VTABLE_get_string(interp, key);
            key                 = VTABLE_shift_pmc(interp, key);

            if (!key) {
                Parrot_set_global(interp, ns, part, value);
                return;
            }

            ns = Parrot_make_namespace_keyed_str(interp, ns, part);
        }
    }

    if (key->vtable->base_type == enum_class_ResizableStringArray) {
        const INTVAL elements = VTABLE_elements(interp, key);
        INTVAL i;
        for (i = 0; i < elements; ++i)  {
            STRING * const part = VTABLE_get_string_keyed_int(interp, key, i);

            if ((i + 1) >= elements) { /* Last entry in the array */
                Parrot_set_global(interp, ns, part, value);
                return;
            }

            ns = Parrot_make_namespace_keyed_str(interp, ns, part);
        }
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_GLOBAL_NOT_FOUND,
        "Invalid namespace key in set_pmc_keyed");
#line 487 "./src/pmc/namespace.c"
}
static  void 
Parrot_NameSpace_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 280 "./src/pmc/namespace.pmc"

    PMC        *new_tuple = NULL;
    const int   val_is_NS = PMC_IS_NULL(value)
                          ? 0
                          :value->vtable->base_type == enum_class_NameSpace;

    /* don't need this everywhere yet */
    PMC * const old = (PMC *)parrot_hash_get(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key);

    /* If it's a sub... */
    if (maybe_add_sub_to_namespace(interp, pmc, key, value))
        return;

    /* If it's an NCI method */
    add_nci_to_namespace(interp, pmc, key, value);

    /* If it's a multi-sub and the first in this NS... */
    add_multi_to_namespace(interp, pmc, key, value);

    if (!old)
        interp->vtables[enum_class_Hash]->set_pmc_keyed_str(interp, pmc, key, value);
    else {
        if ((old->vtable->base_type == enum_class_NameSpace) == val_is_NS) {
            /* simple ns or simple var/sub changed */
            interp->vtables[enum_class_Hash]->set_pmc_keyed_str(interp, pmc, key, value);
        }
        else if ((PObj_get_FLAGS(old) & FPA_is_ns_ext) &&
                old->vtable->base_type == enum_class_FixedPMCArray) {
            /* we have a tuple extension already */
            VTABLE_set_pmc_keyed_int(interp, old,
                    val_is_NS ? NS_slot_ns : NS_slot_var_sub,
                    value);
        }
        else {
            /* create new tuple */
            new_tuple = Parrot_pmc_new(interp, enum_class_FixedPMCArray);

            /* flag it as special */
            PObj_get_FLAGS(new_tuple) |= FPA_is_ns_ext;

            /* for a fully typed namespace, we'd need 3 or 4 */
            VTABLE_set_integer_native(interp, new_tuple, NS_max_slots);
        }
    }

    if (val_is_NS) {
        /* TODO - this hack needs to go */
        Parrot_NameSpace_attributes *nsinfo = PARROT_NAMESPACE(value);
        nsinfo->parent = pmc;  /* set parent */
        nsinfo->name   = key;   /* and name */

        if (new_tuple) {
            VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_ns, value);
            VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_var_sub,
                                     old);

            parrot_hash_put(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key, new_tuple);
            /* distinction from a plain FPA, which doesn't extend the
             * namespace storage */
        }
    }
    else if (new_tuple) {
        VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_ns, old);
        VTABLE_set_pmc_keyed_int(interp, new_tuple, NS_slot_var_sub, value);
        parrot_hash_put(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key, new_tuple);
    }
#line 559 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_make_namespace(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 572 "./src/pmc/namespace.pmc"
PMC* pmc;
PMC* key;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &pmc, &key);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 579 "./src/pmc/namespace.pmc"

    PMC *ns = Parrot_get_namespace_keyed(interp, pmc, key);
    if (PMC_IS_NULL(ns)) {
        ns = Parrot_make_namespace_keyed(interp, pmc, key);
    }
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ns */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)ns);
    return;
    /*END RETURN PMC *ns */
    }
#line 584 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 603 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_add_namespace(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 616 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* name;
PMC* _namespace;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSP",
            &pmc, &name, &_namespace);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 598 "./src/pmc/namespace.pmc"

    STRING * const s_ns = CONST_STRING(interp, "NameSpace");

    if (!VTABLE_isa(interp, _namespace, s_ns))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Invalid type %d in add_namespace()",
            _namespace->vtable->base_type);

    VTABLE_set_pmc_keyed_str(interp, pmc, name, _namespace);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 641 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_add_sub(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 654 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* name;
PMC* sub;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSP",
            &pmc, &name, &sub);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 620 "./src/pmc/namespace.pmc"

    STRING * const s_sub      = CONST_STRING(interp, "Sub");
    STRING * const s_multisub = CONST_STRING(interp, "MultiSub");

    if (!VTABLE_isa(interp, sub, s_sub)
    &&  !VTABLE_isa(interp, sub, s_multisub))
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION,
            "Invalid type %d in add_sub()", sub->vtable->base_type);

    VTABLE_set_pmc_keyed_str(interp, pmc, name, sub);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 681 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_add_var(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 694 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* name;
PMC* var;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSP",
            &pmc, &name, &var);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 643 "./src/pmc/namespace.pmc"

    VTABLE_set_pmc_keyed_str(interp, pmc, name, var);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 712 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_name(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 725 "./src/pmc/namespace.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 660 "./src/pmc/namespace.pmc"

    PMC * const ar = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    INTVAL elements = 0;
    PMC *ns        = pmc;

    while (ns) {
        Parrot_NameSpace_attributes *nsinfo = PARROT_NAMESPACE(ns);
        VTABLE_unshift_string(interp, ar, nsinfo->name);
        ns = nsinfo->parent;
        elements++;
    }

    /* remove the NULL string of the namespace root */
    if (elements > 0)
        VTABLE_shift_string(interp, ar);

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ar */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)ar);
    return;
    /*END RETURN PMC *ar */
    }
#line 676 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 766 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_find_namespace(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 779 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* key;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &key);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 688 "./src/pmc/namespace.pmc"

    STRING * const s_ns = CONST_STRING(interp, "NameSpace");
    PMC    * const ns   = (PMC *)parrot_hash_get(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc),
                                                 key);

    if (!ns)
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 694 "./src/pmc/namespace.pmc"


    /* it's a NameSpace */
    if (VTABLE_isa(interp, ns, s_ns))
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ns */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)ns);
    return;
    /*END RETURN PMC *ns */
    }
#line 698 "./src/pmc/namespace.pmc"


    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 700 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 837 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_find_sub(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 850 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* key;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &key);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 713 "./src/pmc/namespace.pmc"

    STRING * const s_sub = CONST_STRING(interp, "Sub");
    PMC    * const sub   = (PMC *)parrot_hash_get(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc),
                                                  key);

    if (!sub)
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 719 "./src/pmc/namespace.pmc"


    /* it's a Sub */
    if (VTABLE_isa(interp, sub, s_sub))
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *sub */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)sub);
    return;
    /*END RETURN PMC *sub */
    }
#line 723 "./src/pmc/namespace.pmc"


    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 725 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 908 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_find_var(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 921 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* key;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &key);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 738 "./src/pmc/namespace.pmc"

    PMC * const val = (PMC *)parrot_hash_get(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc), key);

    if (!val)
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 742 "./src/pmc/namespace.pmc"


    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *val */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)val);
    return;
    /*END RETURN PMC *val */
    }
#line 744 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 963 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_del_namespace(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 976 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* name;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &name);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 759 "./src/pmc/namespace.pmc"

    Hash   * const hash = (Hash *)pmc->vtable->get_pointer(interp, pmc);
    PMC    * const ns   = (PMC *)parrot_hash_get(interp, hash, name);
    STRING * const s_ns = CONST_STRING(interp, "NameSpace");

    if (PMC_IS_NULL(ns))
        #line 247 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*BEGIN RETURN void */
    return;
    /*END RETURN void */
#line 765 "./src/pmc/namespace.pmc"


    if (!VTABLE_isa(interp, ns, s_ns))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Invalid type %d for '%Ss' in del_namespace()",
            ns->vtable->base_type, name);

    parrot_hash_delete(interp, hash, name);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1010 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_del_sub(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1023 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* name;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &name);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 787 "./src/pmc/namespace.pmc"

    Hash   * const hash  = (Hash *)pmc->vtable->get_pointer(interp, pmc);
    PMC    * const sub   = (PMC *)parrot_hash_get(interp, hash, name);
    STRING * const s_sub = CONST_STRING(interp, "Sub");

    if (PMC_IS_NULL(sub))
        #line 247 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*BEGIN RETURN void */
    return;
    /*END RETURN void */
#line 793 "./src/pmc/namespace.pmc"


    if (!VTABLE_isa(interp, sub, s_sub))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Invalid type %d for '%Ss' in del_sub()",
            sub->vtable->base_type, name);

    parrot_hash_delete(interp, hash, name);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1057 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_del_var(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1070 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* name;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &name);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 813 "./src/pmc/namespace.pmc"

    parrot_hash_delete(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc), name);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1087 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_sym(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1100 "./src/pmc/namespace.pmc"
PMC* pmc;
STRING* key;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &key);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 828 "./src/pmc/namespace.pmc"

    PMC *ns = (PMC *)parrot_hash_get(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc), key);

    if (!ns)
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 832 "./src/pmc/namespace.pmc"


    /* it's a NameSpace */
    if (ns->vtable == pmc->vtable)
        #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 836 "./src/pmc/namespace.pmc"


    if ((PObj_get_FLAGS(ns) & FPA_is_ns_ext)
    &&  ns->vtable->base_type == enum_class_FixedPMCArray)
        ns = VTABLE_get_pmc_keyed_int(interp, ns, NS_slot_var_sub);

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ns */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)ns);
    return;
    /*END RETURN PMC *ns */
    }
#line 842 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1160 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_export_to(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1173 "./src/pmc/namespace.pmc"
PMC* pmc;
PMC* dest;
PMC* what;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPP",
            &pmc, &dest, &what);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 865 "./src/pmc/namespace.pmc"

    STRING * const s_hash  = CONST_STRING(interp, "hash");
    STRING * const s_array = CONST_STRING(interp, "array");

    if (PMC_IS_NULL(dest))
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "destination namespace not specified");

    if (PMC_IS_NULL(what) || !VTABLE_elements(interp, what))
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "exporting default object set not yet implemented");

    /* if "what" does "hash", we extract string key/value pairs,
     * lookup the object with the name specified in the key,
     * and export it with the name specified as value. */
    if (VTABLE_does(interp, what, s_hash)) {
        PMC * const  iter = VTABLE_get_iter(interp, what);
        const INTVAL n    = VTABLE_elements(interp, what);
        INTVAL       i;

        for (i = 0; i < n; ++i) {
            STRING *dest_name;
            PMC    *object;
            STRING * const src_name = VTABLE_shift_string(interp, iter);

            if (STRING_IS_NULL(src_name) || STRING_IS_EMPTY(src_name))
                Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "source object name not specified");

            if (PMC_IS_NULL(VTABLE_get_pmc_keyed_str(interp, what, src_name))) {
                dest_name = src_name;
            }
            else {
                dest_name = VTABLE_get_string_keyed_str(interp, what, src_name);
                if (STRING_IS_NULL(dest_name) || STRING_IS_EMPTY(dest_name))
                    dest_name = src_name;
            }

            object = VTABLE_get_pmc_keyed_str(interp, pmc, src_name);

            if (PMC_IS_NULL(object))
                Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "object '%Ss' not found in current namespace", src_name);

            VTABLE_set_pmc_keyed_str(interp, dest, dest_name, object);
        }
    }
    else if (VTABLE_does(interp, what, s_array)) {
        const INTVAL n = VTABLE_elements(interp, what);
        INTVAL       i;

        for (i = 0; i < n; ++i) {
            PMC    *object;
            STRING * const name = VTABLE_get_string_keyed_int(interp, what, i);

            if (STRING_IS_NULL(name) || STRING_IS_EMPTY(name))
                Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "object name not specified");

            object = VTABLE_get_pmc_keyed_str(interp, pmc, name);

            if (PMC_IS_NULL(object))
                Parrot_ex_throw_from_c_args(interp, NULL, 0,
                    "object '%Ss' not found in current namespace", name);

            VTABLE_set_pmc_keyed_str(interp, dest, name, object);
        }
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "can't handle argument of type %s", what->vtable->base_type);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1260 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_parent(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1273 "./src/pmc/namespace.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 948 "./src/pmc/namespace.pmc"

    PMC *parent = PARROT_NAMESPACE(pmc)->parent ? PARROT_NAMESPACE(pmc)->parent : PMCNULL;
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *parent */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)parent);
    return;
    /*END RETURN PMC *parent */
    }
#line 950 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1300 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_class(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1313 "./src/pmc/namespace.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 963 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo = PARROT_NAMESPACE(pmc);
    PMC              *ret_class     = nsinfo->_class;

    if (PMC_IS_NULL(ret_class))
        ret_class = PMCNULL;

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_class */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)ret_class);
    return;
    /*END RETURN PMC *ret_class */
    }
#line 970 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1345 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_set_class(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1358 "./src/pmc/namespace.pmc"
PMC* pmc;
PMC* class_or_role;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &pmc, &class_or_role);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 983 "./src/pmc/namespace.pmc"

    PARROT_NAMESPACE(pmc)->_class = class_or_role;
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1375 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_associated_methods(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1388 "./src/pmc/namespace.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 998 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo      = PARROT_NAMESPACE(pmc);
    PMC              * const ret_methods = nsinfo->methods;

    nsinfo->methods = PMCNULL;

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_methods */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)ret_methods);
    return;
    /*END RETURN PMC *ret_methods */
    }
#line 1004 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1419 "./src/pmc/namespace.c"
}
static  void
Parrot_NameSpace_nci_get_associated_vtable_methods(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 1432 "./src/pmc/namespace.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1018 "./src/pmc/namespace.pmc"

    Parrot_NameSpace_attributes * const nsinfo      = PARROT_NAMESPACE(pmc);
    PMC              * const ret_methods = nsinfo->vtable;

    nsinfo->vtable = PMCNULL;

    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_methods */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)ret_methods);
    return;
    /*END RETURN PMC *ret_methods */
    }
#line 1024 "./src/pmc/namespace.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1463 "./src/pmc/namespace.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_NameSpace_update_vtable(VTABLE *vt) {
    vt->get_class = Parrot_NameSpace_get_class;
    vt->get_pmc_keyed = Parrot_NameSpace_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_NameSpace_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_NameSpace_get_pmc_keyed_str;
    vt->get_pointer_keyed = Parrot_NameSpace_get_pointer_keyed;
    vt->get_pointer_keyed_str = Parrot_NameSpace_get_pointer_keyed_str;
    vt->get_string = Parrot_NameSpace_get_string;
    vt->init = Parrot_NameSpace_init;
    vt->mark = Parrot_NameSpace_mark;
    vt->set_pmc_keyed = Parrot_NameSpace_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_NameSpace_set_pmc_keyed_str;
    vt->attr_size = sizeof(Parrot_NameSpace_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_NameSpace_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->get_class = Parrot_NameSpace_get_class;
    vt->get_pmc_keyed = Parrot_NameSpace_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_NameSpace_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_NameSpace_get_pmc_keyed_str;
    vt->get_pointer_keyed = Parrot_NameSpace_get_pointer_keyed;
    vt->get_pointer_keyed_str = Parrot_NameSpace_get_pointer_keyed_str;
    vt->get_string = Parrot_NameSpace_get_string;
    vt->init = Parrot_NameSpace_init;
    vt->mark = Parrot_NameSpace_mark;
    vt->attr_size = sizeof(Parrot_NameSpace_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_NameSpace_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_get_vtable(interp);
    Parrot_NameSpace_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_NameSpace_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_ro_get_vtable(interp);
    Parrot_NameSpace_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_NameSpace_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Hash_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "NameSpace", 9, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_NameSpace_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Hash_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "NameSpace")), PMCNULL);
    return isa;
}

void
Parrot_NameSpace_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":hash Sname F_class Fmethods Fvtable Fparent ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_NameSpace_get_vtable(interp);
        vt->base_type      = enum_class_NameSpace;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "NameSpace");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_NameSpace_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_NameSpace_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_NameSpace;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_NameSpace_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_make_namespace), CONST_STRING_GEN(interp, "make_namespace"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_add_namespace), CONST_STRING_GEN(interp, "add_namespace"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_add_sub), CONST_STRING_GEN(interp, "add_sub"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_add_var), CONST_STRING_GEN(interp, "add_var"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_name), CONST_STRING_GEN(interp, "get_name"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_find_namespace), CONST_STRING_GEN(interp, "find_namespace"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_find_sub), CONST_STRING_GEN(interp, "find_sub"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_find_var), CONST_STRING_GEN(interp, "find_var"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_del_namespace), CONST_STRING_GEN(interp, "del_namespace"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_del_sub), CONST_STRING_GEN(interp, "del_sub"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_del_var), CONST_STRING_GEN(interp, "del_var"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_sym), CONST_STRING_GEN(interp, "get_sym"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_export_to), CONST_STRING_GEN(interp, "export_to"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_parent), CONST_STRING_GEN(interp, "get_parent"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_class), CONST_STRING_GEN(interp, "get_class"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_set_class), CONST_STRING_GEN(interp, "set_class"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_associated_methods), CONST_STRING_GEN(interp, "get_associated_methods"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_NameSpace_nci_get_associated_vtable_methods), CONST_STRING_GEN(interp, "get_associated_vtable_methods"));
        {
        }
    } /* pass */
} /* Parrot_NameSpace_class_init */
#line 1026 "./src/pmc/namespace.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd21_namespaces.pod>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
