/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/orderedhash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_orderedhash.h"
#include "pmc_default.h"
#include "orderedhash.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/orderedhash.pmc"
/*
Copyright (C) 2001-2010, Parrot Foundation.
$Id: orderedhash.pmc 44649 2010-03-05 16:20:00Z tene $

=head1 NAME

src/pmc/orderedhash.pmc - Ordered Hash

=head1 DESCRIPTION

C<OrderedHash> provide the interfaces of C<array> and
C<hash>.

Some limitations:

=over 4

=item *

Keys are always STRING*.

=item *

Values are always PMC*.

=back

To archive ordering for each item we store:

=over 4

=item * C<key>

Original key

=item * C<value>

Original value

=item * C<next>

Pointer to next C<item>

=item * C<prev>

Pointer to previous C<item>

=back

OrderedHash stores next things:

=over 4

=item * C<hash>

Lookup hash for values.

=item * C<first>

Pointer to first inserted value.

=item * C<last>

Pointer to last inserter value.

=back

See F<t/pmc/orderedhash.t> for test cases.

Overall design heavily inspired by C<Tie::StoredOrderHash>.

=head2 Methods

=over 4

=cut

*/

/* Get list_item by index */
static PMC*
get_list_item(PARROT_INTERP, ARGIN(PMC *self), INTVAL idx) {
    Parrot_OrderedHash_attributes *attrs = PARROT_ORDEREDHASH(self);
    INTVAL                         n = VTABLE_elements(interp, attrs->hash);
    INTVAL                         pos;
    PMC                           *list_entry = attrs->first;

    if (idx < -n)
        idx = -idx - n - 1;
    else if (idx < 0)
        idx += n;

    /* Iterate over linked list to get list_item */
    for (pos = 0; pos < idx; ++pos) {
        list_entry = VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_NEXT);
    }
    return list_entry;
}

/* Find first/last in cloned/thawed OrderedHash */
/* Parameter C<pmc_hash> is Hash, not OrderedHash */
static void
find_bounds(PARROT_INTERP, PMC *pmc_hash, PMC **first, PMC **last) {
    PMC *iter = VTABLE_get_iter(interp, pmc_hash);
    while (VTABLE_get_bool(interp, iter)) {
        PMC *item  = VTABLE_shift_pmc(interp, iter);
        PMC *entry = VTABLE_get_pmc_keyed(interp, pmc_hash, item);
        /* First entry doesn't have prev */
        PMC *tmp   = VTABLE_get_pmc_keyed_int(interp, entry, ORDERED_HASH_ITEM_PREV);
        if (PMC_IS_NULL(tmp))
            *first = entry;
        /* Last entry doesn't have next */
        tmp   = VTABLE_get_pmc_keyed_int(interp, entry, ORDERED_HASH_ITEM_NEXT);
        if (PMC_IS_NULL(tmp))
            *last = entry;
    }
}

/* Helpers for boxing values */
static PMC*
box_string(PARROT_INTERP, STRING *str) {
    PMC * const ret = Parrot_pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));
    VTABLE_set_string_native(interp, ret, str);
    return ret;
}

static PMC*
box_integer(PARROT_INTERP, INTVAL val) {
    PMC * const ret = Parrot_pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));
    VTABLE_set_integer_native(interp, ret, val);
    return ret;
}

static PMC*
box_number(PARROT_INTERP, FLOATVAL val) {
    PMC * const ret = Parrot_pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Float));
    VTABLE_set_number_native(interp, ret, val);
    return ret;
}
#line 165 "./src/pmc/orderedhash.c"
static  PMC  * Parrot_OrderedHash_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_OrderedHash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_OrderedHash_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  INTVAL  Parrot_OrderedHash_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_OrderedHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_OrderedHash_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  void  Parrot_OrderedHash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  INTVAL  Parrot_OrderedHash_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_OrderedHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_OrderedHash_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  INTVAL  Parrot_OrderedHash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  INTVAL  Parrot_OrderedHash_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_OrderedHash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_OrderedHash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  PMC  * Parrot_OrderedHash_get_iter(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_OrderedHash_get_number(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_OrderedHash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_OrderedHash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  PMC*  Parrot_OrderedHash_get_pmc(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_OrderedHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_OrderedHash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  PMC  * Parrot_OrderedHash_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING  * Parrot_OrderedHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_OrderedHash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  void  Parrot_OrderedHash_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_OrderedHash_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_OrderedHash_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_OrderedHash_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_OrderedHash_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_OrderedHash_push_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_OrderedHash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void  Parrot_OrderedHash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, INTVAL value);
static  void  Parrot_OrderedHash_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value);
static  void  Parrot_OrderedHash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void  Parrot_OrderedHash_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, FLOATVAL value);
static  void  Parrot_OrderedHash_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value);
static  void  Parrot_OrderedHash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_OrderedHash_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *val);
static  void  Parrot_OrderedHash_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void  Parrot_OrderedHash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void  Parrot_OrderedHash_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, STRING *value);
static  void  Parrot_OrderedHash_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  void  Parrot_OrderedHash_thawfinish(PARROT_INTERP, PMC *pmc, PMC *info);
static  void  Parrot_OrderedHash_visit(PARROT_INTERP, PMC *pmc, PMC *info);
void    Parrot_OrderedHash_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_OrderedHash_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_OrderedHash_get_vtable(PARROT_INTERP);
void    Parrot_OrderedHash_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_OrderedHash_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_OrderedHash_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_OrderedHash_clone(PARROT_INTERP, PMC *pmc)
{
#line 705 "./src/pmc/orderedhash.pmc"

    PMC  * const dest   = Parrot_pmc_new(interp, pmc->vtable->base_type);
    Parrot_OrderedHash_attributes *clone_attrs =
            PARROT_ORDEREDHASH(dest);

    clone_attrs->hash   = VTABLE_clone(interp, PARROT_ORDEREDHASH(pmc)->hash);
    find_bounds(interp, clone_attrs->hash, &clone_attrs->first, &clone_attrs->last);

    return dest;
#line 229 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 597 "./src/pmc/orderedhash.pmc"

    /* We store list_item (which is defined). So fetch original PMC and check it */
    PMC * const item = Parrot_OrderedHash_get_pmc_keyed(interp, pmc, key);
    if (PMC_IS_NULL(item))
        return 0;
    return VTABLE_defined(interp, item);
#line 241 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 612 "./src/pmc/orderedhash.pmc"

    PMC * item;
    /* If item doesn't exists it's undefined */
    if (!Parrot_OrderedHash_exists_keyed_int(interp, pmc, idx))
        return 0;

    /* Null is undefined */
    item = Parrot_OrderedHash_get_pmc_keyed_int(interp, pmc, idx);
    if (PMC_IS_NULL(item))
        return 0;

    return VTABLE_defined(interp, item);
#line 259 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 605 "./src/pmc/orderedhash.pmc"

    PMC * const item = Parrot_OrderedHash_get_pmc_keyed_str(interp, pmc, key);
    if (PMC_IS_NULL(item))
        return 0;
    return VTABLE_defined(interp, item);
#line 270 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 640 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes *attrs =
            PARROT_ORDEREDHASH(pmc);
    PMC *list_entry, *prev, *next;
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        INTVAL    intval = VTABLE_get_integer(interp, key);
        PMC * const next = VTABLE_shift_pmc(interp, key);

        if (next)
            VTABLE_delete_keyed(interp, Parrot_OrderedHash_get_pmc_keyed_int(interp, pmc, intval), next);
        else
            Parrot_OrderedHash_delete_keyed_int(interp, pmc, intval);

        return;
    }

    list_entry = VTABLE_get_pmc_keyed(interp, attrs->hash, key);
    if (PMC_IS_NULL(list_entry))
        return;

    /* Unlink entry */
    next = VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_NEXT);
    prev = VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_PREV);

    if (attrs->first == list_entry)
        attrs->first = next;

    if (attrs->last == list_entry)
        attrs->last = prev;

    /* C<prev> and C<next> are list entries (FPA) */
    if (!PMC_IS_NULL(prev))
        VTABLE_set_pmc_keyed_int(interp, prev, ORDERED_HASH_ITEM_NEXT, next);
    if (!PMC_IS_NULL(next))
        VTABLE_set_pmc_keyed_int(interp, next, ORDERED_HASH_ITEM_PREV, prev);

    /* And finally delete it */
    VTABLE_delete_keyed(interp, PARROT_ORDEREDHASH(pmc)->hash, key);
#line 314 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 684 "./src/pmc/orderedhash.pmc"

    PMC *list_entry;
    if (!Parrot_OrderedHash_exists_keyed_int(interp, pmc, idx))
        return;

    list_entry = get_list_item(interp, pmc, idx);
    Parrot_OrderedHash_delete_keyed(interp, pmc, VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_KEY));
#line 327 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 680 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_delete_keyed(interp, pmc, box_string(interp, key));
#line 335 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_elements(PARROT_INTERP, PMC *pmc)
{
#line 227 "./src/pmc/orderedhash.pmc"

    return VTABLE_elements(interp, PARROT_ORDEREDHASH(pmc)->hash);
#line 343 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 566 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        /* Don't fetch item prematurely. It's costy */
        INTVAL    intval = VTABLE_get_integer(interp, key);
        PMC * const next = VTABLE_shift_pmc(interp, key);

        if (!next)
            return Parrot_OrderedHash_exists_keyed_int(interp, pmc, intval);

        return VTABLE_exists_keyed(interp, Parrot_OrderedHash_get_pmc_keyed_int(interp, pmc, intval), next);
    }

    return VTABLE_exists_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
#line 362 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 562 "./src/pmc/orderedhash.pmc"

    return (idx >= 0) && (idx < Parrot_OrderedHash_elements(interp, pmc));
#line 370 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 581 "./src/pmc/orderedhash.pmc"

    return VTABLE_exists_keyed_str(interp, PARROT_ORDEREDHASH(pmc)->hash, key);
#line 378 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 219 "./src/pmc/orderedhash.pmc"

    return Parrot_OrderedHash_elements(interp, pmc);
#line 386 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 427 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_integer(interp, item);
#line 395 "./src/pmc/orderedhash.c"
}
static  INTVAL 
Parrot_OrderedHash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 422 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, idx);
    return VTABLE_get_integer(interp, item);
#line 404 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 201 "./src/pmc/orderedhash.pmc"

    return Parrot_pmc_new_init(interp, enum_class_OrderedHashIterator, pmc);
#line 412 "./src/pmc/orderedhash.c"
}
static  FLOATVAL 
Parrot_OrderedHash_get_number(PARROT_INTERP, PMC *pmc)
{
#line 223 "./src/pmc/orderedhash.pmc"

    return VTABLE_get_integer(interp, pmc);
#line 420 "./src/pmc/orderedhash.c"
}
static  FLOATVAL 
Parrot_OrderedHash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 451 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_number(interp, item);
#line 429 "./src/pmc/orderedhash.c"
}
static  FLOATVAL 
Parrot_OrderedHash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 446 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, idx);
    return VTABLE_get_number(interp, item);
#line 438 "./src/pmc/orderedhash.c"
}
static  PMC* 
Parrot_OrderedHash_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 754 "./src/pmc/orderedhash.pmc"

    PMC *hash;
    GETATTR_OrderedHash_hash(interp, pmc, hash);
    return hash;
#line 448 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 369 "./src/pmc/orderedhash.pmc"

    PMC * item;
    /* Access by integer index */
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        return VTABLE_get_pmc_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
    }

    item = VTABLE_get_pmc_keyed(interp, PARROT_ORDEREDHASH(pmc)->hash, key);
    if (PMC_IS_NULL(item))
        return PMCNULL;
    return VTABLE_get_pmc_keyed_int(interp, item, ORDERED_HASH_ITEM_VALUE);
#line 465 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 360 "./src/pmc/orderedhash.pmc"

    PMC *list_entry = get_list_item(interp, pmc, idx);

    if (PMC_IS_NULL(list_entry))
        return PMCNULL;

    return VTABLE_get_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_VALUE);
#line 478 "./src/pmc/orderedhash.c"
}
static  PMC  *
Parrot_OrderedHash_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 382 "./src/pmc/orderedhash.pmc"

    PMC *pkey = Parrot_pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_String));
    VTABLE_set_string_native(interp, pkey, key);
    return Parrot_OrderedHash_get_pmc_keyed(interp, pmc, pkey);
#line 488 "./src/pmc/orderedhash.c"
}
static  STRING  *
Parrot_OrderedHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 404 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_string(interp, item);
#line 497 "./src/pmc/orderedhash.c"
}
static  STRING  *
Parrot_OrderedHash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 399 "./src/pmc/orderedhash.pmc"

    PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, idx);
    return VTABLE_get_string(interp, item);
#line 506 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_init(PARROT_INTERP, PMC *pmc)
{
#line 160 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes * const attrs =
            (Parrot_OrderedHash_attributes*) PMC_data(pmc);

    attrs->hash     = Parrot_pmc_new(interp, enum_class_Hash);
    attrs->first    = PMCNULL;
    attrs->last     = PMCNULL;

    PObj_custom_mark_destroy_SETALL(pmc);
#line 521 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_mark(PARROT_INTERP, PMC *pmc)
{
#line 181 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes * const attrs =
            PARROT_ORDEREDHASH(pmc);

    if (attrs->hash)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)attrs->hash);

    /* Don't mark C<first> and C<last>. They are in lookup hash anyway */
#line 535 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 535 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_number_keyed_int(interp, pmc, n, value);
#line 544 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 540 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, n, value);
#line 553 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 530 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_pmc_keyed_int(interp, pmc, n, value);
#line 562 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 545 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_string_keyed_int(interp, pmc, n, value);
#line 571 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 291 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_integer(interp, value);
    VTABLE_set_pmc_keyed(interp, pmc, key, v);
#line 580 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, INTVAL value)
{
#line 496 "./src/pmc/orderedhash.pmc"

    PMC * const v = Parrot_pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));
    VTABLE_set_integer_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 591 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
#line 338 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_integer(interp, value);
    Parrot_OrderedHash_set_pmc_keyed_str(interp, pmc, key, v);
#line 600 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 296 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_number(interp, value);
    VTABLE_set_pmc_keyed(interp, pmc, key, v);
#line 609 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, FLOATVAL value)
{
#line 503 "./src/pmc/orderedhash.pmc"

    PMC * const v = Parrot_pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Float));
    VTABLE_set_number_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 620 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
#line 343 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_number(interp, value);
    Parrot_OrderedHash_set_pmc_keyed_str(interp, pmc, key, v);
#line 629 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 240 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes *attrs =
            PARROT_ORDEREDHASH(pmc);

    /* Check for old entry */
    PMC *list_entry = VTABLE_get_pmc_keyed(interp, attrs->hash, key);
    if (!PMC_IS_NULL(list_entry)) {
        /* We have old entry. Just update value */
        PMC *nextkey = key_next(interp, key);
        if (nextkey) {
            PMC *old_value = VTABLE_get_pmc_keyed_int(interp, list_entry,
                    ORDERED_HASH_ITEM_VALUE);
            VTABLE_set_pmc_keyed(interp, value, nextkey, value);
        }
        else
            VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_VALUE, value);
        return;
    }

    /* Create new entry */
    list_entry = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, list_entry, ORDERED_HASH_ITEM_MAX);
    VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_VALUE, value);
    VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_KEY, key);

    /* .. and link it */
    if (!PMC_IS_NULL(attrs->last)) {
        VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_PREV, attrs->last);
        VTABLE_set_pmc_keyed_int(interp, attrs->last, ORDERED_HASH_ITEM_NEXT, list_entry);
    }
    attrs->last = list_entry;
    if (PMC_IS_NULL(attrs->first))
        attrs->first = list_entry;

    /* .. and store it */
    VTABLE_set_pmc_keyed(interp, attrs->hash, key, list_entry);
#line 671 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *val)
{
#line 473 "./src/pmc/orderedhash.pmc"

    const INTVAL   n   = Parrot_OrderedHash_elements(interp, pmc);
    STRING * const fmt = CONST_STRING(interp, "\1%d");
    PMC           *list_entry;
    INTVAL         pos;

    if (idx < -n)
        idx = -idx - n - 1;
    else if (idx < 0)
        idx += n;

    if (idx >= n) {
        /* TODO warn or fill if there are holes */
        STRING * const key = Parrot_sprintf_s(interp, fmt, idx);
        VTABLE_set_pmc_keyed_str(interp, pmc, key, val);
    }
    else {
        list_entry = get_list_item(interp, pmc, idx);
        PARROT_ASSERT(!PMC_IS_NULL(list_entry));
        VTABLE_set_pmc_keyed_int(interp, list_entry, ORDERED_HASH_ITEM_VALUE, val);
    }
#line 698 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 322 "./src/pmc/orderedhash.pmc"

    /* Wallpapering problem with HLL Strings as keys */
    /* Apparently HLL registry in Parrot uses OrderedHash */
    /* Now we have chicken and egg problem during freeze/thaw */
    /* When we try to thaw OrderedHash which stores HLL mapping */
    /* Reported by François Perrad */
    PMC *pkey = Parrot_pmc_new(interp, enum_class_String);
    VTABLE_set_string_native(interp, pkey, key);
    VTABLE_set_pmc_keyed(interp, pmc, pkey, value);
#line 713 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 301 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_string(interp, value);
    VTABLE_set_pmc_keyed(interp, pmc, key, v);
#line 722 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, STRING *value)
{
#line 510 "./src/pmc/orderedhash.pmc"

    PMC * const v = Parrot_pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));
    VTABLE_set_string_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 733 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
#line 333 "./src/pmc/orderedhash.pmc"

    PMC * const v = box_string(interp, value);
    Parrot_OrderedHash_set_pmc_keyed_str(interp, pmc, key, v);
#line 742 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_thawfinish(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 738 "./src/pmc/orderedhash.pmc"

    Parrot_OrderedHash_attributes *attrs = PARROT_ORDEREDHASH(pmc);
    find_bounds(interp, attrs->hash, &attrs->first, &attrs->last);
    interp->vtables[enum_class_default]->thawfinish(interp, pmc, info);
#line 752 "./src/pmc/orderedhash.c"
}
static  void 
Parrot_OrderedHash_visit(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 733 "./src/pmc/orderedhash.pmc"

    VISIT_PMC_ATTR(interp, info, pmc, OrderedHash, hash);
    interp->vtables[enum_class_default]->visit(interp, pmc, info);
#line 761 "./src/pmc/orderedhash.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_OrderedHash_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_OrderedHash_clone;
    vt->defined_keyed = Parrot_OrderedHash_defined_keyed;
    vt->defined_keyed_int = Parrot_OrderedHash_defined_keyed_int;
    vt->defined_keyed_str = Parrot_OrderedHash_defined_keyed_str;
    vt->delete_keyed = Parrot_OrderedHash_delete_keyed;
    vt->delete_keyed_int = Parrot_OrderedHash_delete_keyed_int;
    vt->delete_keyed_str = Parrot_OrderedHash_delete_keyed_str;
    vt->elements = Parrot_OrderedHash_elements;
    vt->exists_keyed = Parrot_OrderedHash_exists_keyed;
    vt->exists_keyed_int = Parrot_OrderedHash_exists_keyed_int;
    vt->exists_keyed_str = Parrot_OrderedHash_exists_keyed_str;
    vt->get_integer = Parrot_OrderedHash_get_integer;
    vt->get_integer_keyed = Parrot_OrderedHash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_OrderedHash_get_integer_keyed_int;
    vt->get_iter = Parrot_OrderedHash_get_iter;
    vt->get_number = Parrot_OrderedHash_get_number;
    vt->get_number_keyed = Parrot_OrderedHash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_OrderedHash_get_number_keyed_int;
    vt->get_pmc = Parrot_OrderedHash_get_pmc;
    vt->get_pmc_keyed = Parrot_OrderedHash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_OrderedHash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_OrderedHash_get_pmc_keyed_str;
    vt->get_string_keyed = Parrot_OrderedHash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_OrderedHash_get_string_keyed_int;
    vt->init = Parrot_OrderedHash_init;
    vt->mark = Parrot_OrderedHash_mark;
    vt->push_float = Parrot_OrderedHash_push_float;
    vt->push_integer = Parrot_OrderedHash_push_integer;
    vt->push_pmc = Parrot_OrderedHash_push_pmc;
    vt->push_string = Parrot_OrderedHash_push_string;
    vt->set_integer_keyed = Parrot_OrderedHash_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_OrderedHash_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_OrderedHash_set_integer_keyed_str;
    vt->set_number_keyed = Parrot_OrderedHash_set_number_keyed;
    vt->set_number_keyed_int = Parrot_OrderedHash_set_number_keyed_int;
    vt->set_number_keyed_str = Parrot_OrderedHash_set_number_keyed_str;
    vt->set_pmc_keyed = Parrot_OrderedHash_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_OrderedHash_set_pmc_keyed_int;
    vt->set_pmc_keyed_str = Parrot_OrderedHash_set_pmc_keyed_str;
    vt->set_string_keyed = Parrot_OrderedHash_set_string_keyed;
    vt->set_string_keyed_int = Parrot_OrderedHash_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_OrderedHash_set_string_keyed_str;
    vt->thawfinish = Parrot_OrderedHash_thawfinish;
    vt->visit = Parrot_OrderedHash_visit;
    vt->attr_size = sizeof(Parrot_OrderedHash_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_OrderedHash_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_OrderedHash_clone;
    vt->defined_keyed = Parrot_OrderedHash_defined_keyed;
    vt->defined_keyed_int = Parrot_OrderedHash_defined_keyed_int;
    vt->defined_keyed_str = Parrot_OrderedHash_defined_keyed_str;
    vt->elements = Parrot_OrderedHash_elements;
    vt->exists_keyed = Parrot_OrderedHash_exists_keyed;
    vt->exists_keyed_int = Parrot_OrderedHash_exists_keyed_int;
    vt->exists_keyed_str = Parrot_OrderedHash_exists_keyed_str;
    vt->get_integer = Parrot_OrderedHash_get_integer;
    vt->get_integer_keyed = Parrot_OrderedHash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_OrderedHash_get_integer_keyed_int;
    vt->get_iter = Parrot_OrderedHash_get_iter;
    vt->get_number = Parrot_OrderedHash_get_number;
    vt->get_number_keyed = Parrot_OrderedHash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_OrderedHash_get_number_keyed_int;
    vt->get_pmc = Parrot_OrderedHash_get_pmc;
    vt->get_pmc_keyed = Parrot_OrderedHash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_OrderedHash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_OrderedHash_get_pmc_keyed_str;
    vt->get_string_keyed = Parrot_OrderedHash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_OrderedHash_get_string_keyed_int;
    vt->init = Parrot_OrderedHash_init;
    vt->mark = Parrot_OrderedHash_mark;
    vt->visit = Parrot_OrderedHash_visit;
    vt->attr_size = sizeof(Parrot_OrderedHash_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_OrderedHash_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_OrderedHash_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_OrderedHash_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_OrderedHash_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_OrderedHash_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "OrderedHash", 11, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_OrderedHash_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "OrderedHash")), PMCNULL);
    return isa;
}

void
Parrot_OrderedHash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fhash Ffirst Flast ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_OrderedHash_get_vtable(interp);
        vt->base_type      = enum_class_OrderedHash;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "OrderedHash");
        vt->provides_str = CONST_STRING_GEN(interp, "array hash");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_OrderedHash_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_OrderedHash;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_OrderedHash_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_OrderedHash_class_init */
#line 758 "./src/pmc/orderedhash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=head1 HISTORY

Initial rev by leo 2003-08-21.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
