/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/packfile.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_packfile.h"
#include "pmc_default.h"
#include "packfile.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/packfile.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: packfile.pmc 44291 2010-02-22 09:28:39Z bacek $

=head1 NAME

src/pmc/packfile.pmc - Packfile PMC

=head1 DESCRIPTION

This class implements a Packfile object, as specified in PDD13.  This object is
the top level parser and serializer for *.pbc files.

=head2 Methods

=over 4

=cut

*/

#include "pmc/pmc_packfiledirectory.h"

/*
Copy attributes from PackFile* to Packfile PMC.
*/
static void
copy_packfile_header(PARROT_INTERP, PMC *self, PackFile *pf) {
    Parrot_Packfile_attributes *attrs = PARROT_PACKFILE(self);

    attrs->wordsize         = pf->header->wordsize;
    attrs->byteorder        = pf->header->byteorder;
    attrs->fptype           = pf->header->floattype;
    attrs->version_major    = pf->header->major;
    attrs->version_minor    = pf->header->minor;
    attrs->version_patch    = pf->header->patch;
    attrs->bytecode_major   = pf->header->bc_major;
    attrs->bytecode_minor   = pf->header->bc_minor;
    attrs->uuid_type        = pf->header->uuid_type;

    attrs->uuid = Parrot_str_new(interp, (char*)pf->header->uuid_data,
            pf->header->uuid_size);

}
#line 68 "./src/pmc/packfile.c"
static  INTVAL  Parrot_Packfile_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Packfile_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING  * Parrot_Packfile_get_string(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Packfile_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_Packfile_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_Packfile_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Packfile_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Packfile_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL val);
static  void  Parrot_Packfile_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value);
static  void  Parrot_Packfile_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *val);
static  void  Parrot_Packfile_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  void  Parrot_Packfile_set_string_native(PARROT_INTERP, PMC *pmc, STRING *str);
static  void Parrot_Packfile_nci_pack(PARROT_INTERP, PMC *pmc);
static  void Parrot_Packfile_nci_unpack(PARROT_INTERP, PMC *pmc);
static  void Parrot_Packfile_nci_get_directory(PARROT_INTERP, PMC *pmc);
void    Parrot_Packfile_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Packfile_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Packfile_get_vtable(PARROT_INTERP);
void    Parrot_Packfile_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Packfile_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Packfile_ro_get_vtable(PARROT_INTERP);
static  INTVAL 
Parrot_Packfile_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 273 "./src/pmc/packfile.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    return VTABLE_get_integer_keyed_str(interp, pmc, s);
#line 97 "./src/pmc/packfile.c"
}
static  INTVAL 
Parrot_Packfile_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 212 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes *attrs = PARROT_PACKFILE(pmc);
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "wordsize")))
        return attrs->wordsize;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "byteorder")))
        return attrs->byteorder;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "fptype")))
        return attrs->fptype;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_major")))
        return attrs->version_major;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_minor")))
        return attrs->version_minor;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_patch")))
        return attrs->version_patch;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "bytecode_major")))
        return attrs->bytecode_major;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "bytecode_minor")))
        return attrs->bytecode_minor;
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "uuid_type")))
        return attrs->uuid_type;

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                   "Packfile: No such integer key \"%s\"",
                   Parrot_string_cstring(interp, key));
#line 127 "./src/pmc/packfile.c"
}
static  STRING  *
Parrot_Packfile_get_string(PARROT_INTERP, PMC *pmc)
{
#line 112 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes * attrs = PARROT_PACKFILE(pmc);
    PackFile                   * pf =
            (PackFile*)VTABLE_get_pointer(interp, attrs->directory);

    opcode_t    length;
    opcode_t    *ptr;
    STRING      *str;

    /* Calculate required memory */
    length  = PackFile_pack_size(interp, pf) * sizeof (opcode_t);
    ptr     = (opcode_t*)Parrot_gc_allocate_memory_chunk(interp, length);

    /* Copy related attributes to header */
    pf->header->major     = attrs->version_major;
    pf->header->minor     = attrs->version_minor;
    pf->header->patch     = attrs->version_patch;
    pf->header->uuid_type = attrs->uuid_type;

    /* And pack it! */
    PackFile_pack(interp, pf, ptr);

    str = Parrot_str_new_init(interp, (const char*)ptr, length,
            PARROT_FIXED_8_ENCODING, PARROT_BINARY_CHARSET, 0);
    Parrot_gc_free_memory_chunk(interp, ptr);

    PackFile_destroy(interp, pf);
    return str;
#line 161 "./src/pmc/packfile.c"
}
static  STRING  *
Parrot_Packfile_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 289 "./src/pmc/packfile.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    return VTABLE_get_string_keyed_str(interp, pmc, s);
#line 170 "./src/pmc/packfile.c"
}
static  STRING  *
Parrot_Packfile_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 253 "./src/pmc/packfile.pmc"

    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "uuid")))
        return PARROT_PACKFILE(pmc)->uuid;

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                   "Packfile: No such string key \"%s\"",
                   Parrot_string_cstring(interp, key));
#line 183 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_init(PARROT_INTERP, PMC *pmc)
{
#line 68 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes *attrs =
            PMC_data_typed(pmc, Parrot_Packfile_attributes*);
    PackFile                   *pf;

    attrs->uuid     = Parrot_str_new_noinit(interp, enum_stringrep_one, 0);
    attrs->directory = Parrot_pmc_new(interp, enum_class_PackfileDirectory);

    /* Create dummy PackFile and copy default attributes to self */
    pf = PackFile_new(interp, 0);
    copy_packfile_header(interp, pmc, pf);
    PackFile_destroy(interp, pf);

    PObj_custom_mark_SET(pmc);
#line 203 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_mark(PARROT_INTERP, PMC *pmc)
{
#line 95 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes * attrs = PARROT_PACKFILE(pmc);

    Parrot_gc_mark_STRING_alive(interp, attrs->uuid);
    Parrot_gc_mark_PMC_alive(interp, attrs->directory);
#line 214 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL val)
{
#line 349 "./src/pmc/packfile.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    VTABLE_set_integer_keyed_str(interp, pmc, s, val);
#line 223 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
#line 315 "./src/pmc/packfile.pmc"

    Parrot_Packfile_attributes *attrs = PARROT_PACKFILE(pmc);
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_major"))) {
        attrs->version_major = value;
        return;
    }
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_minor"))) {
        attrs->version_minor = value;
        return;
    }
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "version_patch"))) {
        attrs->version_patch = value;
        return;
    }
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "uuid_type"))) {
        attrs->uuid_type = value;
        return;
    }
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                   "Packfile: No such integer key \"%s\"",
                   Parrot_string_cstring(interp, key));
#line 250 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *val)
{
#line 392 "./src/pmc/packfile.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    VTABLE_set_string_keyed_str(interp, pmc, s, val);
#line 259 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
#line 371 "./src/pmc/packfile.pmc"

    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "uuid"))) {
        PARROT_PACKFILE(pmc)->uuid = value;
        return;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                   "Packfile: No such string key \"%s\"",
                   Parrot_string_cstring(interp, key));
#line 274 "./src/pmc/packfile.c"
}
static  void 
Parrot_Packfile_set_string_native(PARROT_INTERP, PMC *pmc, STRING *str)
{
#line 152 "./src/pmc/packfile.pmc"

    PackFile        *pf = PackFile_new(interp, 0);
    const opcode_t  *ptr =
            (const opcode_t*)Parrot_string_cstring(interp, str);
    int             length = Parrot_str_byte_length(interp, str);
    Parrot_Packfile_attributes * attrs = PARROT_PACKFILE(pmc);

    if (!PackFile_unpack(interp, pf, ptr, length)) {
        PackFile_destroy(interp, pf);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_MALFORMED_PACKFILE,
                                    "Can't unpack packfile.");
    }

    /* Disable GC during copy data into internal structures. */
    Parrot_block_GC_mark(interp);

    /* Copy values from PackFile header to own attributes */
    copy_packfile_header(interp, pmc, pf);

    VTABLE_set_pointer(interp, attrs->directory, &pf->directory);

    Parrot_unblock_GC_mark(interp);

    PackFile_destroy(interp, pf);
#line 304 "./src/pmc/packfile.c"
}
static  void
Parrot_Packfile_nci_pack(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 317 "./src/pmc/packfile.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 408 "./src/pmc/packfile.pmc"

    STRING * ret = pmc->vtable->get_string(interp, pmc);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING * ret */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "S",
            (STRING*)ret);
    return;
    /*END RETURN STRING * ret */
    }
#line 410 "./src/pmc/packfile.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 344 "./src/pmc/packfile.c"
}
static  void
Parrot_Packfile_nci_unpack(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 357 "./src/pmc/packfile.pmc"
PMC* pmc;
STRING* str;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &str);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 424 "./src/pmc/packfile.pmc"

    pmc->vtable->set_string_native(interp, pmc, str);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 374 "./src/pmc/packfile.c"
}
static  void
Parrot_Packfile_nci_get_directory(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 387 "./src/pmc/packfile.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 438 "./src/pmc/packfile.pmc"

    PMC *dir = PARROT_PACKFILE(pmc)->directory;
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *dir */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)dir);
    return;
    /*END RETURN PMC *dir */
    }
#line 440 "./src/pmc/packfile.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 414 "./src/pmc/packfile.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Packfile_update_vtable(VTABLE *vt) {
    vt->get_integer_keyed = Parrot_Packfile_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_Packfile_get_integer_keyed_str;
    vt->get_string = Parrot_Packfile_get_string;
    vt->get_string_keyed = Parrot_Packfile_get_string_keyed;
    vt->get_string_keyed_str = Parrot_Packfile_get_string_keyed_str;
    vt->init = Parrot_Packfile_init;
    vt->mark = Parrot_Packfile_mark;
    vt->set_integer_keyed = Parrot_Packfile_set_integer_keyed;
    vt->set_integer_keyed_str = Parrot_Packfile_set_integer_keyed_str;
    vt->set_string_keyed = Parrot_Packfile_set_string_keyed;
    vt->set_string_keyed_str = Parrot_Packfile_set_string_keyed_str;
    vt->set_string_native = Parrot_Packfile_set_string_native;
    vt->attr_size = sizeof(Parrot_Packfile_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Packfile_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->get_integer_keyed = Parrot_Packfile_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_Packfile_get_integer_keyed_str;
    vt->get_string = Parrot_Packfile_get_string;
    vt->get_string_keyed = Parrot_Packfile_get_string_keyed;
    vt->get_string_keyed_str = Parrot_Packfile_get_string_keyed_str;
    vt->init = Parrot_Packfile_init;
    vt->mark = Parrot_Packfile_mark;
    vt->attr_size = sizeof(Parrot_Packfile_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Packfile_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Packfile_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Packfile_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Packfile_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Packfile_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Packfile", 8, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Packfile_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Packfile")), PMCNULL);
    return isa;
}

void
Parrot_Packfile_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iwordsize Ibyteorder Ifptype Iversion_major Iversion_minor Iversion_patch Ibytecode_major Ibytecode_minor Iuuid_type Suuid Fdirectory ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Packfile_get_vtable(interp);
        vt->base_type      = enum_class_Packfile;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Packfile");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Packfile_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Packfile;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Packfile_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Packfile_nci_pack), CONST_STRING_GEN(interp, "pack"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Packfile_nci_unpack), CONST_STRING_GEN(interp, "unpack"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Packfile_nci_get_directory), CONST_STRING_GEN(interp, "get_directory"));
        {
        }
    } /* pass */
} /* Parrot_Packfile_class_init */
#line 443 "./src/pmc/packfile.pmc"

/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
