/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/parrotinterpreter.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_parrotinterpreter.h"
#include "pmc_default.h"
#include "parrotinterpreter.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/parrotinterpreter.pmc"
/*
Copyright (C) 2001-2010, Parrot Foundation.
$Id: parrotinterpreter.pmc 44537 2010-02-27 22:13:23Z NotFound $

=head1 NAME

src/pmc/parrotinterpreter.pmc - Parrot Interpreter

=head1 DESCRIPTION

These are the vtable functions for the ParrotInterpreter base class

   getinterp P0
   set P1, P0[.IGLOBALS_*]  # access interpreter globals
   set I0, P0[x]            # interpinfo I0, x
   set I0, P0[-1]           # get interpreter flags
   set P0[-1], x            # set flags on interpreter
                            # NOTE: this doesn't restart

=head2 Functions

=over 4

=cut

*/

#include "parrot/embed.h"
#include "parrot/dynext.h"
#include "parrot/io.h"
#include "parrot/runcore_api.h"
#include "pmc/pmc_class.h"
#include "pmc/pmc_sub.h"

#define PMC_interp(x) ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->interp
#define PMC_args(x)   ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->args
#define PMC_sub(x)    ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->sub

/*

=item C<void
clone_interpreter(Parrot_Interp dest, const Parrot_Interp source, INTVAL flags)>

Clones the interpreter as specified by the flags.

=cut

*/

void
clone_interpreter(Parrot_Interp d, Parrot_Interp s, INTVAL flags)
{
    /* we block GC runs while cloning since C<d> is not yet running */
    Parrot_block_GC_mark(d);

    d->scheduler = Parrot_pmc_new(d, enum_class_Scheduler);
    d->scheduler = VTABLE_share_ro(d, d->scheduler);

    /* can't copy directly, unless you want double-frees */
    if (flags & PARROT_CLONE_RUNOPS)
        Parrot_runcore_switch(d, s->run_core->name);

    if (flags & PARROT_CLONE_INTERP_FLAGS) {
        /* XXX setting of IS_THREAD? */
        d->flags       = s->flags;
        d->debug_flags = s->debug_flags;
    }

    if (flags & PARROT_CLONE_HLL) {
        /* we'd like to share the HLL data. Give it a PMC_sync structure
           if it doesn't have one already */
        Parrot_gc_add_pmc_sync(s, s->HLL_info);
        d->HLL_info = s->HLL_info;
        Parrot_regenerate_HLL_namespaces(d);
    }

    if (flags & (PARROT_CLONE_LIBRARIES | PARROT_CLONE_CLASSES)) {
        INTVAL i, last_remove;
        const INTVAL start = d->n_vtable_max;

        /* copy type registrations to keep type numbers the same */
        d->class_hash   = Parrot_clone(d, s->class_hash);
        d->n_vtable_max = s->n_vtable_max;

        if (d->n_vtable_max > d->n_vtable_alloced)
            parrot_realloc_vtables(d);

        last_remove = s->n_vtable_max;

        for (i = s->n_vtable_max - 1; i >= start; --i) {
            if (s->vtables[i] && s->vtables[i]->pmc_class &&
                PObj_is_class_TEST(s->vtables[i]->pmc_class)) {
                STRING * const class_name =
                    VTABLE_get_string(s, s->vtables[i]->pmc_class);
                PARROT_ASSERT(VTABLE_exists_keyed_str(d,
                    d->class_hash, class_name));

                VTABLE_delete_keyed_str(d, d->class_hash, class_name);

                if (last_remove == i + 1) {
                    --d->n_vtable_max;
                    last_remove = i;
                }
            }
        }
    }

    if (flags & PARROT_CLONE_LIBRARIES) {
        PMC   * const libs     = VTABLE_get_pmc_keyed_int(s, s->iglobals,
            IGLOBALS_DYN_LIBS);
        PMC   * const lib_iter = VTABLE_get_iter(s, libs);
        const INTVAL n         = VTABLE_elements(s, libs);
        INTVAL i;

        for (i = 0; i < n; ++i) {
            STRING * const key     = VTABLE_shift_string(s, lib_iter);
            PMC    * const lib_pmc = VTABLE_get_pmc_keyed_str(s, libs, key);
            PMC    * const ignored = Parrot_clone_lib_into(d, s, lib_pmc);
            UNUSED(ignored);
        }
    }

    if (flags & PARROT_CLONE_CLASSES) {
        INTVAL i;
        for (i = 0; i < s->n_vtable_max; ++i) {
            if (s->vtables[i] && s->vtables[i]->pmc_class &&
                    PObj_is_class_TEST(s->vtables[i]->pmc_class)) {
                /* Cloning the class into the new interpreter ought
                 * to be sufficient to instantiate the class.  */
                PMC          *source       = s->vtables[i]->pmc_class;
                PMC          *dest         = Parrot_clone(d, source);
                Parrot_Class_attributes *source_class = PARROT_CLASS(source);
                Parrot_Class_attributes *dest_class   = PARROT_CLASS(dest);
                dest_class->name           = Parrot_str_copy(d, source_class->name);
                dest_class->_namespace     = VTABLE_clone(d, source_class->_namespace);
            }
        }
    }

    if (flags & PARROT_CLONE_CODE)
        pt_clone_code(d, s);

    if (flags & PARROT_CLONE_GLOBALS)
        pt_clone_globals(d, s);

    Parrot_unblock_GC_mark(d);
}


/*

=item C<static void
create_interp(PMC *self, Parrot_Interp parent)>

Creates a new child interpreter of C<parent>.

=cut

*/

static void
create_interp(PMC *self, Parrot_Interp parent)
{
    Interp_flags flag  = PARROT_NO_FLAGS;
    Parrot_Interp new_interp;

    if (self->vtable->base_type == enum_class_ParrotThread)
        flag = PARROT_IS_THREAD;

    new_interp       = make_interpreter(parent, (INTVAL)flag);
    PMC_interp(self) = new_interp;

    VTABLE_set_pmc_keyed_int(new_interp, new_interp->iglobals,
        (INTVAL) IGLOBALS_INTERPRETER, self);

    new_interp->current_cont = NEED_CONTINUATION;
}
#line 201 "./src/pmc/parrotinterpreter.c"
static  PMC  * Parrot_ParrotInterpreter_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ParrotInterpreter_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ParrotInterpreter_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ParrotInterpreter_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC  * Parrot_ParrotInterpreter_get_pmc(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ParrotInterpreter_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_ParrotInterpreter_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  * Parrot_ParrotInterpreter_get_pointer(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ParrotInterpreter_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ParrotInterpreter_init_pmc(PARROT_INTERP, PMC *pmc, PMC *parent);
static  opcode_t  * Parrot_ParrotInterpreter_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  INTVAL  Parrot_ParrotInterpreter_is_equal(PARROT_INTERP, PMC *pmc, PMC *val);
static  void  Parrot_ParrotInterpreter_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL val);
static  void  Parrot_ParrotInterpreter_set_pmc(PARROT_INTERP, PMC *pmc, PMC *args);
static  void  Parrot_ParrotInterpreter_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void  Parrot_ParrotInterpreter_thaw(PARROT_INTERP, PMC *pmc, PMC *info);
static  void  Parrot_ParrotInterpreter_thawfinish(PARROT_INTERP, PMC *pmc, PMC *info);
static  void  Parrot_ParrotInterpreter_visit(PARROT_INTERP, PMC *pmc, PMC *info);
static  void Parrot_ParrotInterpreter_nci_yield(PARROT_INTERP, PMC *pmc);
static  void Parrot_ParrotInterpreter_nci_recursion_limit(PARROT_INTERP, PMC *pmc);
static  void Parrot_ParrotInterpreter_nci_run_gc(PARROT_INTERP, PMC *pmc);
static  void Parrot_ParrotInterpreter_nci_hll_map(PARROT_INTERP, PMC *pmc);
static  void Parrot_ParrotInterpreter_nci_stdhandle(PARROT_INTERP, PMC *pmc);
void    Parrot_ParrotInterpreter_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_get_vtable(PARROT_INTERP);
void    Parrot_ParrotInterpreter_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_ParrotInterpreter_clone(PARROT_INTERP, PMC *pmc)
{
#line 617 "./src/pmc/parrotinterpreter.pmc"

    PMC * const dest = Parrot_pmc_new(interp, pmc->vtable->base_type);

    clone_interpreter(PMC_interp(dest),
                      PMC_interp(pmc), PARROT_CLONE_DEFAULT);

    return dest;
#line 242 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_destroy(PARROT_INTERP, PMC *pmc)
{
#line 281 "./src/pmc/parrotinterpreter.pmc"

    if (PMC_data(pmc)) {
        mem_gc_free(interp, PMC_data(pmc));
        PMC_data(pmc) = NULL;
    }
#line 253 "./src/pmc/parrotinterpreter.c"
}
static  INTVAL 
Parrot_ParrotInterpreter_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 337 "./src/pmc/parrotinterpreter.pmc"

    const Parrot_Interp i = PMC_interp(pmc);
    return (INTVAL)i->thread_data->tid;
#line 262 "./src/pmc/parrotinterpreter.c"
}
static  INTVAL 
Parrot_ParrotInterpreter_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 573 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(pmc);

    if (key == -1)
        return (INTVAL)new_interp->flags;

    return interpinfo(new_interp, key);
#line 275 "./src/pmc/parrotinterpreter.c"
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 378 "./src/pmc/parrotinterpreter.pmc"

    return PMC_args(pmc);
#line 283 "./src/pmc/parrotinterpreter.c"
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 443 "./src/pmc/parrotinterpreter.pmc"

    PMC    *nextkey, *cont;
    STRING *outer = NULL;
    STRING *item  = key_string(interp, key);
    STRING *name  = CONST_STRING(interp, "globals");
    int     level = 0;

    PMC *ctx;

    if (Parrot_str_equal(interp, item, name))
        return interp->root_namespace;

    name  = CONST_STRING(interp, "outer");

    if (Parrot_str_equal(interp, item, name)) {
        outer   = item;
        nextkey = key_next(interp, key);

        if (nextkey && (PObj_get_FLAGS(nextkey) & KEY_string_FLAG)) {
            key  = nextkey;
            item = VTABLE_get_string(interp, key);
        }
    }

    nextkey = key_next(interp, key);

    if (nextkey)
        level = VTABLE_get_integer(interp, nextkey);
    else if (outer)
        level = 1;

    if (level < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, CONTROL_ERROR,
            "No such caller depth");

    ctx = CURRENT_CONTEXT(interp);

    if (outer) {
        for (; level; --level) {
            ctx = Parrot_pcc_get_outer_ctx(interp, ctx);
            if (PMC_IS_NULL(ctx))
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such outer depth");
        }
    }
    else {
        for (; level; --level) {
            cont = Parrot_pcc_get_continuation(interp, ctx);

            if (PMC_IS_NULL(cont) || !PARROT_CONTINUATION(cont)->seg)
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such caller depth");

            ctx = PARROT_CONTINUATION(cont)->to_ctx;

            if (PMC_IS_NULL(Parrot_pcc_get_sub(interp, ctx)))
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such caller depth");
        }
    }

    if (item == outer)
        return Parrot_pcc_get_sub(interp, ctx);

    name = CONST_STRING(interp, "context");

    if (Parrot_str_equal(interp, item, name))
        return ctx;

    name = CONST_STRING(interp, "sub");

    if (Parrot_str_equal(interp, item, name))
        return Parrot_pcc_get_sub(interp, ctx);

    name = CONST_STRING(interp, "lexpad");

    if (Parrot_str_equal(interp, item, name))
        return Parrot_pcc_get_lex_pad(interp, ctx);

    name = CONST_STRING(interp, "namespace");

    if (Parrot_str_equal(interp, item, name))
        return Parrot_pcc_get_namespace(interp, ctx);

    name = CONST_STRING(interp, "continuation");

    if (Parrot_str_equal(interp, item, name))
        return VTABLE_clone(interp, Parrot_pcc_get_continuation(interp, ctx));

    name = CONST_STRING(interp, "annotations");

    if (Parrot_str_equal(interp, item, name)) {
        PMC        *sub_pmc = Parrot_pcc_get_sub(interp, ctx);
        if (ctx == CURRENT_CONTEXT(interp)) {
            /* We can't know the current program counter for the currently
             * executing sub, so can't return annotations for that. */
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                    "Cannot get annotations at depth 0; use annotations op instead.");
        }
        if (!PMC_IS_NULL(sub_pmc)
        &&   sub_pmc->vtable->base_type == enum_class_Sub) {
            Parrot_Sub_attributes *sub;
            PackFile_ByteCode     *seg;
            opcode_t              *pc  = Parrot_pcc_get_pc(interp, ctx);

            PMC_get_sub(interp, sub_pmc, sub);
            seg = sub->seg;

            if (sub->seg->annotations)
                return PackFile_Annotations_lookup(interp, seg->annotations,
                    pc - seg->base.data, NULL);
        }

        return Parrot_pmc_new(interp, enum_class_Hash);
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such item %Ss", item);
#line 407 "./src/pmc/parrotinterpreter.c"
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 407 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(pmc);

    if (key >= 0 && key < IGLOBALS_SIZE)
        return VTABLE_get_pmc_keyed_int(new_interp,
            new_interp->iglobals, key);

    /* quick hack to get the global stash */
    if (key == -1)
        return new_interp->root_namespace;

    return PMCNULL;
#line 425 "./src/pmc/parrotinterpreter.c"
}
static  void  *
Parrot_ParrotInterpreter_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 323 "./src/pmc/parrotinterpreter.pmc"

    return PMC_interp(pmc);
#line 433 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_init(PARROT_INTERP, PMC *pmc)
{
#line 227 "./src/pmc/parrotinterpreter.pmc"

    /*
     * init/init_pmc may be called internally (from thread creation in
     * ParrotThread::init_pmc() or stand-alone
     * so we check, if the interpreter is already set up
     */
    if (!PMC_data(pmc)) {
        Parrot_ParrotInterpreter_attributes *attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(pmc) = attrs;
    }
    if (!PMC_interp(pmc)) {
        create_interp(pmc, interp);
    }
    PObj_custom_destroy_SET(pmc);
#line 454 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_init_pmc(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 256 "./src/pmc/parrotinterpreter.pmc"

    Parrot_Interp p = PMC_interp(parent);

    if (!PMC_data(pmc)) {
        Parrot_ParrotInterpreter_attributes *attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(pmc) = attrs;
    }
    if (!PMC_interp(pmc)) {
        create_interp(pmc, p);
    }
    PObj_custom_destroy_SET(pmc);
#line 472 "./src/pmc/parrotinterpreter.c"
}
static  opcode_t  *
Parrot_ParrotInterpreter_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 352 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(pmc);

    /* setup code */
    pt_thread_prepare_for_run(new_interp, interp);

    /* TODO pass arguments from parent (interp) to child (new_interp) by
     * possibly clone of share the arguments r/o args can be passed as is */

    /* calculate offset and run */
    runops(new_interp, (size_t)((opcode_t *)PMC_sub(pmc) -
        (opcode_t *)interp->code->base.data));

    return (opcode_t *)next;
#line 492 "./src/pmc/parrotinterpreter.c"
}
static  INTVAL 
Parrot_ParrotInterpreter_is_equal(PARROT_INTERP, PMC *pmc, PMC *val)
{
#line 639 "./src/pmc/parrotinterpreter.pmc"

    Parrot_Interp self  = PMC_interp(pmc);
    Parrot_Interp other = PMC_interp(val);

    if (!self->thread_data && !other->thread_data)
        return 1;

    if (self->thread_data && other->thread_data &&
        self->thread_data->tid == other->thread_data->tid)
        return 1;

    return 0;
#line 510 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL val)
{
#line 592 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(pmc);

    /* set interpreter flags */
    if (key == -1) {
        const INTVAL allowed = PARROT_BOUNDS_FLAG | PARROT_PROFILE_FLAG |
                         PARROT_GC_DEBUG_FLAG;
        Parrot_clear_flag(new_interp, allowed);
        Parrot_set_flag(new_interp, val & allowed);
    }
#line 526 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_set_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
#line 392 "./src/pmc/parrotinterpreter.pmc"

    PMC_args(pmc) = args;
#line 534 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 299 "./src/pmc/parrotinterpreter.pmc"


    /* XXX: init_world in src/global_setup.c needs to create a
     * ParrotInterpreter through Parrot_pmc_new_noinit.  If this PMC hasn't been
     * initialized, cheat by initializing instead. */
    if (!PMC_data(pmc)) {
        Parrot_ParrotInterpreter_attributes *attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(pmc) = attrs;
        PObj_custom_destroy_SET(pmc);
    }
    PMC_interp(pmc) = (struct parrot_interp_t *)value;
#line 552 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_thaw(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 713 "./src/pmc/parrotinterpreter.pmc"

    if (!PMC_data(pmc)) {
        Parrot_ParrotInterpreter_attributes *attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(pmc) = attrs;
        PObj_custom_destroy_SET(pmc);
    }

    PMC_interp(pmc) = interp;
#line 567 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_thawfinish(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 724 "./src/pmc/parrotinterpreter.pmc"

    PMC * const new_info = PMC_args(pmc);
    const INTVAL  m      = VTABLE_elements(interp, new_info);
    INTVAL  i;
    UNUSED(info)

    PMC_args(pmc) = NULL;

    /* merge new_info */
    /* TODO compare old entries */

    for (i = 0; i < m; ++i) {
        PMC * const entry    = VTABLE_get_pmc_keyed_int(interp, new_info, i);
        PMC * const lib_pmc  = VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_lib);
        PMC * const name_pmc = VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_name);
        PMC * const typemap  = VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_typemap);
        INTVAL hll_id = - 1;

        if (!PMC_IS_NULL(name_pmc)) {
            STRING * const hll_name = VTABLE_get_string(interp, name_pmc);

            hll_id           = Parrot_register_HLL(interp, hll_name);
        }

        if (!PMC_IS_NULL(lib_pmc)) {
            STRING *lib_name = VTABLE_get_string(interp, lib_pmc);
            PMC    *ignored;

            if (!STRING_IS_EMPTY(lib_name)) {
                INTVAL id;
                ignored      = Parrot_load_lib(interp, lib_name, NULL);
                id           = Parrot_register_HLL_lib(interp, lib_name);
                UNUSED(id);
            }

            UNUSED(ignored);
        }

        if (hll_id >= 0 && !PMC_IS_NULL(typemap)) {
            PMC   *iter = VTABLE_get_iter(interp, typemap);
            INTVAL e    = VTABLE_get_integer(interp, typemap);
            INTVAL i;

            for (i = 0; i < e; ++i) {
                PMC * const key        = VTABLE_shift_pmc(interp, iter);
                const INTVAL core_type = VTABLE_get_integer(interp, key);
                const INTVAL hll_type  =
                    VTABLE_get_integer_keyed_int(interp, typemap, core_type);

                Parrot_register_HLL_type(interp, hll_id,
                    core_type, hll_type);
            }
        }
    }
#line 627 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_visit(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 680 "./src/pmc/parrotinterpreter.pmc"

    /*
     * the information frozen here is part of all PBCs
     * we probably need to freeze all dynamic extensible
     * mappings (or at least the dynamic part)
     * e.g.
     *    charsets   idx - name
     *    encodings  idx - name
     *    pmc types  idx - name
     *    dynamic oplibs    opcode nr - opname
     *
     * The machine thawing this info still needs to load
     * these extensions, but the order of loading could be
     * relaxed.
     *
     * creating all these info as standard PMCs would vastly
     * simplify this process
     *
     * thaw would then need a merge operation:
     *  - compare existing for sanity
     *  - extend new
     */

    /*  HLL_info */
    if (VTABLE_get_integer(interp, info) == VISIT_THAW_NORMAL ||
        VTABLE_get_integer(interp, info) == VISIT_THAW_CONSTANTS) {
        VISIT_PMC(interp, info, PMC_args(pmc));
    }
    else
        VISIT_PMC(interp, info, interp->HLL_info);

#line 664 "./src/pmc/parrotinterpreter.c"
}
static  void
Parrot_ParrotInterpreter_nci_yield(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 677 "./src/pmc/parrotinterpreter.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 206 "./src/pmc/parrotinterpreter.pmc"

    pt_thread_yield();
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 693 "./src/pmc/parrotinterpreter.c"
}
static  void
Parrot_ParrotInterpreter_nci_recursion_limit(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 706 "./src/pmc/parrotinterpreter.pmc"
PMC* pmc;
INTVAL l;
INTVAL has_l;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIp",
            &pmc, &l, &has_l);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 210 "./src/pmc/parrotinterpreter.pmc"

    const INTVAL ret = interp->recursion_limit;
    if (has_l)
        interp->recursion_limit = l;
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL ret */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "I",
            (INTVAL)ret);
    return;
    /*END RETURN INTVAL ret */
    }
#line 214 "./src/pmc/parrotinterpreter.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 737 "./src/pmc/parrotinterpreter.c"
}
static  void
Parrot_ParrotInterpreter_nci_run_gc(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 750 "./src/pmc/parrotinterpreter.pmc"
PMC* pmc;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 780 "./src/pmc/parrotinterpreter.pmc"

    Parrot_gc_mark_and_sweep(PMC_interp(pmc), 0);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 766 "./src/pmc/parrotinterpreter.c"
}
static  void
Parrot_ParrotInterpreter_nci_hll_map(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 779 "./src/pmc/parrotinterpreter.pmc"
PMC* pmc;
PMC* core_type;
PMC* hll_type;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPP",
            &pmc, &core_type, &hll_type);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 794 "./src/pmc/parrotinterpreter.pmc"

    INTVAL core_type_id = VTABLE_type(interp, core_type);
    INTVAL hll_type_id  = VTABLE_type(interp, hll_type);
    INTVAL hll_id       = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp));
    Parrot_register_HLL_type(interp, hll_id, core_type_id, hll_type_id);
#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 800 "./src/pmc/parrotinterpreter.c"
}
static  void
Parrot_ParrotInterpreter_nci_stdhandle(PARROT_INTERP, PMC *pmc)
{
#line 423 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    Parrot_pcc_set_signature(interp, _ctx, NULL);

    { /* BEGIN PARMS SCOPE */
#line 813 "./src/pmc/parrotinterpreter.pmc"
PMC* pmc;
INTVAL fileno;
PMC* newhandle;

#line 431 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIPo",
            &pmc, &fileno, &newhandle);
#line 435 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 817 "./src/pmc/parrotinterpreter.pmc"

    PMC * handle = Parrot_io_stdhandle(interp, fileno, newhandle);
    #line 260 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *handle */
#line 267 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    Parrot_pcc_fill_returns_from_c_args(interp, _call_object, "P",
            (PMC*)handle);
    return;
    /*END RETURN PMC *handle */
    }
#line 819 "./src/pmc/parrotinterpreter.pmc"

#line 442 "/builddir/build/BUILD/parrot-2.2.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 842 "./src/pmc/parrotinterpreter.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ParrotInterpreter_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ParrotInterpreter_clone;
    vt->destroy = Parrot_ParrotInterpreter_destroy;
    vt->get_integer = Parrot_ParrotInterpreter_get_integer;
    vt->get_integer_keyed_int = Parrot_ParrotInterpreter_get_integer_keyed_int;
    vt->get_pmc = Parrot_ParrotInterpreter_get_pmc;
    vt->get_pmc_keyed = Parrot_ParrotInterpreter_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ParrotInterpreter_get_pmc_keyed_int;
    vt->get_pointer = Parrot_ParrotInterpreter_get_pointer;
    vt->init = Parrot_ParrotInterpreter_init;
    vt->init_pmc = Parrot_ParrotInterpreter_init_pmc;
    vt->invoke = Parrot_ParrotInterpreter_invoke;
    vt->is_equal = Parrot_ParrotInterpreter_is_equal;
    vt->set_integer_keyed_int = Parrot_ParrotInterpreter_set_integer_keyed_int;
    vt->set_pmc = Parrot_ParrotInterpreter_set_pmc;
    vt->set_pointer = Parrot_ParrotInterpreter_set_pointer;
    vt->thaw = Parrot_ParrotInterpreter_thaw;
    vt->thawfinish = Parrot_ParrotInterpreter_thawfinish;
    vt->visit = Parrot_ParrotInterpreter_visit;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ParrotInterpreter_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ParrotInterpreter_clone;
    vt->destroy = Parrot_ParrotInterpreter_destroy;
    vt->get_integer = Parrot_ParrotInterpreter_get_integer;
    vt->get_integer_keyed_int = Parrot_ParrotInterpreter_get_integer_keyed_int;
    vt->get_pmc = Parrot_ParrotInterpreter_get_pmc;
    vt->get_pmc_keyed = Parrot_ParrotInterpreter_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ParrotInterpreter_get_pmc_keyed_int;
    vt->get_pointer = Parrot_ParrotInterpreter_get_pointer;
    vt->init = Parrot_ParrotInterpreter_init;
    vt->init_pmc = Parrot_ParrotInterpreter_init_pmc;
    vt->invoke = Parrot_ParrotInterpreter_invoke;
    vt->is_equal = Parrot_ParrotInterpreter_is_equal;
    vt->visit = Parrot_ParrotInterpreter_visit;
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ParrotInterpreter_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_ParrotInterpreter_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ParrotInterpreter_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_ParrotInterpreter_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ParrotInterpreter_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "ParrotInterpreter", 17, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ParrotInterpreter_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ParrotInterpreter")), PMCNULL);
    return isa;
}

void
Parrot_ParrotInterpreter_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":interp Itid Fargs Fsub ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ParrotInterpreter_get_vtable(interp);
        vt->base_type      = enum_class_ParrotInterpreter;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ParrotInterpreter");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ParrotInterpreter_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ParrotInterpreter;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ParrotInterpreter_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_ParrotInterpreter_nci_yield), CONST_STRING_GEN(interp, "yield"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_ParrotInterpreter_nci_recursion_limit), CONST_STRING_GEN(interp, "recursion_limit"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_ParrotInterpreter_nci_run_gc), CONST_STRING_GEN(interp, "run_gc"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_ParrotInterpreter_nci_hll_map), CONST_STRING_GEN(interp, "hll_map"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_ParrotInterpreter_nci_stdhandle), CONST_STRING_GEN(interp, "stdhandle"));
        {
        }
    } /* pass */
} /* Parrot_ParrotInterpreter_class_init */
#line 822 "./src/pmc/parrotinterpreter.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
